/*!
* Dynamsoft JavaScript Library
* @product Dynamsoft Image IO WASM Worker JS
* @website http://www.dynamsoft.com
* @copyright Copyright 2025, Dynamsoft Corporation
* @author Dynamsoft
* @version 3.0.0 (2025-06-27T06:39:28.218Z)
* @fileoverview Dynamsoft JavaScript Library for Image IO WASM Worker
* 
*/


var ImageIOModule = (() => {
  var _scriptName = typeof document != 'undefined' ? document.currentScript?.src : undefined;
  if (typeof __filename != 'undefined') _scriptName ||= __filename;
  return (
function(moduleArg = {}) {
  var moduleRtn;

var Module=moduleArg;var readyPromiseResolve,readyPromiseReject;var readyPromise=new Promise((resolve,reject)=>{readyPromiseResolve=resolve;readyPromiseReject=reject});var ENVIRONMENT_IS_WEB=typeof window=="object";var ENVIRONMENT_IS_WORKER=typeof importScripts=="function";var ENVIRONMENT_IS_NODE=typeof process=="object"&&typeof process.versions=="object"&&typeof process.versions.node=="string";if(ENVIRONMENT_IS_NODE){}var moduleOverrides=Object.assign({},Module);var arguments_=[];var thisProgram="./this.program";var quit_=(status,toThrow)=>{throw toThrow};var scriptDirectory="";function locateFile(path){if(Module["locateFile"]){return Module["locateFile"](path,scriptDirectory)}return scriptDirectory+path}var readAsync,readBinary;if(ENVIRONMENT_IS_NODE){var fs=require("fs");var nodePath=require("path");scriptDirectory=__dirname+"/";readBinary=filename=>{filename=isFileURI(filename)?new URL(filename):nodePath.normalize(filename);var ret=fs.readFileSync(filename);return ret};readAsync=(filename,binary=true)=>{filename=isFileURI(filename)?new URL(filename):nodePath.normalize(filename);return new Promise((resolve,reject)=>{fs.readFile(filename,binary?undefined:"utf8",(err,data)=>{if(err)reject(err);else resolve(binary?data.buffer:data)})})};if(!Module["thisProgram"]&&process.argv.length>1){thisProgram=process.argv[1].replace(/\\/g,"/")}arguments_=process.argv.slice(2);quit_=(status,toThrow)=>{process.exitCode=status;throw toThrow}}else if(ENVIRONMENT_IS_WEB||ENVIRONMENT_IS_WORKER){if(ENVIRONMENT_IS_WORKER){scriptDirectory=self.location.href}else if(typeof document!="undefined"&&document.currentScript){scriptDirectory=document.currentScript.src}if(_scriptName){scriptDirectory=_scriptName}if(scriptDirectory.startsWith("blob:")){scriptDirectory=""}else{scriptDirectory=scriptDirectory.substr(0,scriptDirectory.replace(/[?#].*/,"").lastIndexOf("/")+1)}{if(ENVIRONMENT_IS_WORKER){readBinary=url=>{var xhr=new XMLHttpRequest;xhr.open("GET",url,false);xhr.responseType="arraybuffer";xhr.send(null);return new Uint8Array(xhr.response)}}readAsync=url=>{if(isFileURI(url)){return new Promise((reject,resolve)=>{var xhr=new XMLHttpRequest;xhr.open("GET",url,true);xhr.responseType="arraybuffer";xhr.onload=()=>{if(xhr.status==200||xhr.status==0&&xhr.response){resolve(xhr.response)}reject(xhr.status)};xhr.onerror=reject;xhr.send(null)})}return fetch(url,{credentials:"same-origin"}).then(response=>{if(response.ok){return response.arrayBuffer()}return Promise.reject(new Error(response.status+" : "+response.url))})}}}else{}var out=Module["print"]||console.log.bind(console);var err=Module["printErr"]||console.error.bind(console);Object.assign(Module,moduleOverrides);moduleOverrides=null;if(Module["arguments"])arguments_=Module["arguments"];if(Module["thisProgram"])thisProgram=Module["thisProgram"];if(Module["quit"])quit_=Module["quit"];var wasmBinary;if(Module["wasmBinary"])wasmBinary=Module["wasmBinary"];var wasmMemory;var ABORT=false;var EXITSTATUS;function assert(condition,text){if(!condition){abort(text)}}var HEAP8,HEAPU8,HEAP16,HEAPU16,HEAP32,HEAPU32,HEAPF32,HEAPF64;function updateMemoryViews(){var b=wasmMemory.buffer;Module["HEAP8"]=HEAP8=new Int8Array(b);Module["HEAP16"]=HEAP16=new Int16Array(b);Module["HEAPU8"]=HEAPU8=new Uint8Array(b);Module["HEAPU16"]=HEAPU16=new Uint16Array(b);Module["HEAP32"]=HEAP32=new Int32Array(b);Module["HEAPU32"]=HEAPU32=new Uint32Array(b);Module["HEAPF32"]=HEAPF32=new Float32Array(b);Module["HEAPF64"]=HEAPF64=new Float64Array(b)}var __ATPRERUN__=[];var __ATINIT__=[];var __ATPOSTRUN__=[];var runtimeInitialized=false;function preRun(){if(Module["preRun"]){if(typeof Module["preRun"]=="function")Module["preRun"]=[Module["preRun"]];while(Module["preRun"].length){addOnPreRun(Module["preRun"].shift())}}callRuntimeCallbacks(__ATPRERUN__)}function initRuntime(){runtimeInitialized=true;if(!Module["noFSInit"]&&!FS.init.initialized)FS.init();FS.ignorePermissions=false;TTY.init();callRuntimeCallbacks(__ATINIT__)}function postRun(){if(Module["postRun"]){if(typeof Module["postRun"]=="function")Module["postRun"]=[Module["postRun"]];while(Module["postRun"].length){addOnPostRun(Module["postRun"].shift())}}callRuntimeCallbacks(__ATPOSTRUN__)}function addOnPreRun(cb){__ATPRERUN__.unshift(cb)}function addOnInit(cb){__ATINIT__.unshift(cb)}function addOnPostRun(cb){__ATPOSTRUN__.unshift(cb)}var runDependencies=0;var runDependencyWatcher=null;var dependenciesFulfilled=null;function getUniqueRunDependency(id){return id}function addRunDependency(id){runDependencies++;Module["monitorRunDependencies"]?.(runDependencies)}function removeRunDependency(id){runDependencies--;Module["monitorRunDependencies"]?.(runDependencies);if(runDependencies==0){if(runDependencyWatcher!==null){clearInterval(runDependencyWatcher);runDependencyWatcher=null}if(dependenciesFulfilled){var callback=dependenciesFulfilled;dependenciesFulfilled=null;callback()}}}function abort(what){Module["onAbort"]?.(what);what="Aborted("+what+")";err(what);ABORT=true;EXITSTATUS=1;what+=". Build with -sASSERTIONS for more info.";var e=new WebAssembly.RuntimeError(what);readyPromiseReject(e);throw e}var dataURIPrefix="data:application/octet-stream;base64,";var isDataURI=filename=>filename.startsWith(dataURIPrefix);var isFileURI=filename=>filename.startsWith("file://");function findWasmBinary(){var f="ddv-imageio.wasm";if(!isDataURI(f)){return locateFile(f)}return f}var wasmBinaryFile;function getBinarySync(file){if(file==wasmBinaryFile&&wasmBinary){return new Uint8Array(wasmBinary)}if(readBinary){return readBinary(file)}throw"both async and sync fetching of the wasm failed"}function getBinaryPromise(binaryFile){if(!wasmBinary){return readAsync(binaryFile).then(response=>new Uint8Array(response),()=>getBinarySync(binaryFile))}return Promise.resolve().then(()=>getBinarySync(binaryFile))}function instantiateArrayBuffer(binaryFile,imports,receiver){return getBinaryPromise(binaryFile).then(binary=>WebAssembly.instantiate(binary,imports)).then(receiver,reason=>{err(`failed to asynchronously prepare wasm: ${reason}`);abort(reason)})}function instantiateAsync(binary,binaryFile,imports,callback){if(!binary&&typeof WebAssembly.instantiateStreaming=="function"&&!isDataURI(binaryFile)&&!isFileURI(binaryFile)&&!ENVIRONMENT_IS_NODE&&typeof fetch=="function"){return fetch(binaryFile,{credentials:"same-origin"}).then(response=>{var result=WebAssembly.instantiateStreaming(response,imports);return result.then(callback,function(reason){err(`wasm streaming compile failed: ${reason}`);err("falling back to ArrayBuffer instantiation");return instantiateArrayBuffer(binaryFile,imports,callback)})})}return instantiateArrayBuffer(binaryFile,imports,callback)}function getWasmImports(){return{a:wasmImports}}function createWasm(){var info=getWasmImports();function receiveInstance(instance,module){wasmExports=instance.exports;wasmMemory=wasmExports["oa"];updateMemoryViews();wasmTable=wasmExports["Ca"];addOnInit(wasmExports["pa"]);removeRunDependency("wasm-instantiate");return wasmExports}addRunDependency("wasm-instantiate");function receiveInstantiationResult(result){receiveInstance(result["instance"])}if(Module["instantiateWasm"]){try{return Module["instantiateWasm"](info,receiveInstance)}catch(e){err(`Module.instantiateWasm callback failed with error: ${e}`);readyPromiseReject(e)}}if(!wasmBinaryFile)wasmBinaryFile=findWasmBinary();instantiateAsync(wasmBinary,wasmBinaryFile,info,receiveInstantiationResult).catch(readyPromiseReject);return{}}var tempDouble;var tempI64;function get_domain_js(){var origin;if(typeof global!=="undefined"){origin=""}else if(typeof window!=="undefined"){origin=window.location.origin}else if(typeof self!=="undefined"){origin=self.location.origin||"";if(origin==="blob://"){var href=self.location.href;var pos0=href.indexOf(":")+1;var pos1=href.indexOf("//",pos0)+2;var pos2=href.indexOf("/",pos1);origin=href.substring(pos0,pos2)}}else{origin=""}var lengthBytes=lengthBytesUTF8(origin)+1;var stringOnWasmHeap=_malloc(lengthBytes);stringToUTF8(origin,stringOnWasmHeap,lengthBytes);return stringOnWasmHeap}function ExitStatus(status){this.name="ExitStatus";this.message=`Program terminated with exit(${status})`;this.status=status}Module["ExitStatus"]=ExitStatus;var callRuntimeCallbacks=callbacks=>{while(callbacks.length>0){callbacks.shift()(Module)}};Module["callRuntimeCallbacks"]=callRuntimeCallbacks;function getValue(ptr,type="i8"){if(type.endsWith("*"))type="*";switch(type){case"i1":return HEAP8[ptr];case"i8":return HEAP8[ptr];case"i16":return HEAP16[ptr>>1];case"i32":return HEAP32[ptr>>2];case"i64":abort("to do getValue(i64) use WASM_BIGINT");case"float":return HEAPF32[ptr>>2];case"double":return HEAPF64[ptr>>3];case"*":return HEAPU32[ptr>>2];default:abort(`invalid type for getValue: ${type}`)}}Module["getValue"]=getValue;var noExitRuntime=Module["noExitRuntime"]||true;Module["noExitRuntime"]=noExitRuntime;function setValue(ptr,value,type="i8"){if(type.endsWith("*"))type="*";switch(type){case"i1":HEAP8[ptr]=value;break;case"i8":HEAP8[ptr]=value;break;case"i16":HEAP16[ptr>>1]=value;break;case"i32":HEAP32[ptr>>2]=value;break;case"i64":abort("to do setValue(i64) use WASM_BIGINT");case"float":HEAPF32[ptr>>2]=value;break;case"double":HEAPF64[ptr>>3]=value;break;case"*":HEAPU32[ptr>>2]=value;break;default:abort(`invalid type for setValue: ${type}`)}}Module["setValue"]=setValue;var stackRestore=val=>__emscripten_stack_restore(val);Module["stackRestore"]=stackRestore;var stackSave=()=>_emscripten_stack_get_current();Module["stackSave"]=stackSave;class ExceptionInfo{constructor(excPtr){this.excPtr=excPtr;this.ptr=excPtr-24}set_type(type){HEAPU32[this.ptr+4>>2]=type}get_type(){return HEAPU32[this.ptr+4>>2]}set_destructor(destructor){HEAPU32[this.ptr+8>>2]=destructor}get_destructor(){return HEAPU32[this.ptr+8>>2]}set_caught(caught){caught=caught?1:0;HEAP8[this.ptr+12]=caught}get_caught(){return HEAP8[this.ptr+12]!=0}set_rethrown(rethrown){rethrown=rethrown?1:0;HEAP8[this.ptr+13]=rethrown}get_rethrown(){return HEAP8[this.ptr+13]!=0}init(type,destructor){this.set_adjusted_ptr(0);this.set_type(type);this.set_destructor(destructor)}set_adjusted_ptr(adjustedPtr){HEAPU32[this.ptr+16>>2]=adjustedPtr}get_adjusted_ptr(){return HEAPU32[this.ptr+16>>2]}get_exception_ptr(){var isPointer=___cxa_is_pointer_type(this.get_type());if(isPointer){return HEAPU32[this.excPtr>>2]}var adjusted=this.get_adjusted_ptr();if(adjusted!==0)return adjusted;return this.excPtr}}Module["ExceptionInfo"]=ExceptionInfo;var exceptionLast=0;Module["exceptionLast"]=exceptionLast;var uncaughtExceptionCount=0;Module["uncaughtExceptionCount"]=uncaughtExceptionCount;var ___cxa_throw=(ptr,type,destructor)=>{var info=new ExceptionInfo(ptr);info.init(type,destructor);exceptionLast=ptr;uncaughtExceptionCount++;throw exceptionLast};Module["___cxa_throw"]=___cxa_throw;function syscallGetVarargI(){var ret=HEAP32[+SYSCALLS.varargs>>2];SYSCALLS.varargs+=4;return ret}Module["syscallGetVarargI"]=syscallGetVarargI;var syscallGetVarargP=syscallGetVarargI;Module["syscallGetVarargP"]=syscallGetVarargP;var PATH={isAbs:path=>path.charAt(0)==="/",splitPath:filename=>{var splitPathRe=/^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;return splitPathRe.exec(filename).slice(1)},normalizeArray:(parts,allowAboveRoot)=>{var up=0;for(var i=parts.length-1;i>=0;i--){var last=parts[i];if(last==="."){parts.splice(i,1)}else if(last===".."){parts.splice(i,1);up++}else if(up){parts.splice(i,1);up--}}if(allowAboveRoot){for(;up;up--){parts.unshift("..")}}return parts},normalize:path=>{var isAbsolute=PATH.isAbs(path),trailingSlash=path.substr(-1)==="/";path=PATH.normalizeArray(path.split("/").filter(p=>!!p),!isAbsolute).join("/");if(!path&&!isAbsolute){path="."}if(path&&trailingSlash){path+="/"}return(isAbsolute?"/":"")+path},dirname:path=>{var result=PATH.splitPath(path),root=result[0],dir=result[1];if(!root&&!dir){return"."}if(dir){dir=dir.substr(0,dir.length-1)}return root+dir},basename:path=>{if(path==="/")return"/";path=PATH.normalize(path);path=path.replace(/\/$/,"");var lastSlash=path.lastIndexOf("/");if(lastSlash===-1)return path;return path.substr(lastSlash+1)},join:(...paths)=>PATH.normalize(paths.join("/")),join2:(l,r)=>PATH.normalize(l+"/"+r)};Module["PATH"]=PATH;var initRandomFill=()=>{if(typeof crypto=="object"&&typeof crypto["getRandomValues"]=="function"){return view=>crypto.getRandomValues(view)}else if(ENVIRONMENT_IS_NODE){try{var crypto_module=require("crypto");var randomFillSync=crypto_module["randomFillSync"];if(randomFillSync){return view=>crypto_module["randomFillSync"](view)}var randomBytes=crypto_module["randomBytes"];return view=>(view.set(randomBytes(view.byteLength)),view)}catch(e){}}abort("initRandomDevice")};Module["initRandomFill"]=initRandomFill;var randomFill=view=>(randomFill=initRandomFill())(view);Module["randomFill"]=randomFill;var PATH_FS={resolve:(...args)=>{var resolvedPath="",resolvedAbsolute=false;for(var i=args.length-1;i>=-1&&!resolvedAbsolute;i--){var path=i>=0?args[i]:FS.cwd();if(typeof path!="string"){throw new TypeError("Arguments to path.resolve must be strings")}else if(!path){return""}resolvedPath=path+"/"+resolvedPath;resolvedAbsolute=PATH.isAbs(path)}resolvedPath=PATH.normalizeArray(resolvedPath.split("/").filter(p=>!!p),!resolvedAbsolute).join("/");return(resolvedAbsolute?"/":"")+resolvedPath||"."},relative:(from,to)=>{from=PATH_FS.resolve(from).substr(1);to=PATH_FS.resolve(to).substr(1);function trim(arr){var start=0;for(;start<arr.length;start++){if(arr[start]!=="")break}var end=arr.length-1;for(;end>=0;end--){if(arr[end]!=="")break}if(start>end)return[];return arr.slice(start,end-start+1)}var fromParts=trim(from.split("/"));var toParts=trim(to.split("/"));var length=Math.min(fromParts.length,toParts.length);var samePartsLength=length;for(var i=0;i<length;i++){if(fromParts[i]!==toParts[i]){samePartsLength=i;break}}var outputParts=[];for(var i=samePartsLength;i<fromParts.length;i++){outputParts.push("..")}outputParts=outputParts.concat(toParts.slice(samePartsLength));return outputParts.join("/")}};Module["PATH_FS"]=PATH_FS;var UTF8Decoder=typeof TextDecoder!="undefined"?new TextDecoder:undefined;Module["UTF8Decoder"]=UTF8Decoder;var UTF8ArrayToString=(heapOrArray,idx,maxBytesToRead)=>{var endIdx=idx+maxBytesToRead;var endPtr=idx;while(heapOrArray[endPtr]&&!(endPtr>=endIdx))++endPtr;if(endPtr-idx>16&&heapOrArray.buffer&&UTF8Decoder){return UTF8Decoder.decode(heapOrArray.subarray(idx,endPtr))}var str="";while(idx<endPtr){var u0=heapOrArray[idx++];if(!(u0&128)){str+=String.fromCharCode(u0);continue}var u1=heapOrArray[idx++]&63;if((u0&224)==192){str+=String.fromCharCode((u0&31)<<6|u1);continue}var u2=heapOrArray[idx++]&63;if((u0&240)==224){u0=(u0&15)<<12|u1<<6|u2}else{u0=(u0&7)<<18|u1<<12|u2<<6|heapOrArray[idx++]&63}if(u0<65536){str+=String.fromCharCode(u0)}else{var ch=u0-65536;str+=String.fromCharCode(55296|ch>>10,56320|ch&1023)}}return str};Module["UTF8ArrayToString"]=UTF8ArrayToString;var FS_stdin_getChar_buffer=[];Module["FS_stdin_getChar_buffer"]=FS_stdin_getChar_buffer;var lengthBytesUTF8=str=>{var len=0;for(var i=0;i<str.length;++i){var c=str.charCodeAt(i);if(c<=127){len++}else if(c<=2047){len+=2}else if(c>=55296&&c<=57343){len+=4;++i}else{len+=3}}return len};Module["lengthBytesUTF8"]=lengthBytesUTF8;var stringToUTF8Array=(str,heap,outIdx,maxBytesToWrite)=>{if(!(maxBytesToWrite>0))return 0;var startIdx=outIdx;var endIdx=outIdx+maxBytesToWrite-1;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343){var u1=str.charCodeAt(++i);u=65536+((u&1023)<<10)|u1&1023}if(u<=127){if(outIdx>=endIdx)break;heap[outIdx++]=u}else if(u<=2047){if(outIdx+1>=endIdx)break;heap[outIdx++]=192|u>>6;heap[outIdx++]=128|u&63}else if(u<=65535){if(outIdx+2>=endIdx)break;heap[outIdx++]=224|u>>12;heap[outIdx++]=128|u>>6&63;heap[outIdx++]=128|u&63}else{if(outIdx+3>=endIdx)break;heap[outIdx++]=240|u>>18;heap[outIdx++]=128|u>>12&63;heap[outIdx++]=128|u>>6&63;heap[outIdx++]=128|u&63}}heap[outIdx]=0;return outIdx-startIdx};Module["stringToUTF8Array"]=stringToUTF8Array;function intArrayFromString(stringy,dontAddNull,length){var len=length>0?length:lengthBytesUTF8(stringy)+1;var u8array=new Array(len);var numBytesWritten=stringToUTF8Array(stringy,u8array,0,u8array.length);if(dontAddNull)u8array.length=numBytesWritten;return u8array}Module["intArrayFromString"]=intArrayFromString;var FS_stdin_getChar=()=>{if(!FS_stdin_getChar_buffer.length){var result=null;if(ENVIRONMENT_IS_NODE){var BUFSIZE=256;var buf=Buffer.alloc(BUFSIZE);var bytesRead=0;var fd=process.stdin.fd;try{bytesRead=fs.readSync(fd,buf,0,BUFSIZE)}catch(e){if(e.toString().includes("EOF"))bytesRead=0;else throw e}if(bytesRead>0){result=buf.slice(0,bytesRead).toString("utf-8")}}else if(typeof window!="undefined"&&typeof window.prompt=="function"){result=window.prompt("Input: ");if(result!==null){result+="\n"}}else{}if(!result){return null}FS_stdin_getChar_buffer=intArrayFromString(result,true)}return FS_stdin_getChar_buffer.shift()};Module["FS_stdin_getChar"]=FS_stdin_getChar;var TTY={ttys:[],init(){},shutdown(){},register(dev,ops){TTY.ttys[dev]={input:[],output:[],ops:ops};FS.registerDevice(dev,TTY.stream_ops)},stream_ops:{open(stream){var tty=TTY.ttys[stream.node.rdev];if(!tty){throw new FS.ErrnoError(43)}stream.tty=tty;stream.seekable=false},close(stream){stream.tty.ops.fsync(stream.tty)},fsync(stream){stream.tty.ops.fsync(stream.tty)},read(stream,buffer,offset,length,pos){if(!stream.tty||!stream.tty.ops.get_char){throw new FS.ErrnoError(60)}var bytesRead=0;for(var i=0;i<length;i++){var result;try{result=stream.tty.ops.get_char(stream.tty)}catch(e){throw new FS.ErrnoError(29)}if(result===undefined&&bytesRead===0){throw new FS.ErrnoError(6)}if(result===null||result===undefined)break;bytesRead++;buffer[offset+i]=result}if(bytesRead){stream.node.timestamp=Date.now()}return bytesRead},write(stream,buffer,offset,length,pos){if(!stream.tty||!stream.tty.ops.put_char){throw new FS.ErrnoError(60)}try{for(var i=0;i<length;i++){stream.tty.ops.put_char(stream.tty,buffer[offset+i])}}catch(e){throw new FS.ErrnoError(29)}if(length){stream.node.timestamp=Date.now()}return i}},default_tty_ops:{get_char(tty){return FS_stdin_getChar()},put_char(tty,val){if(val===null||val===10){out(UTF8ArrayToString(tty.output,0));tty.output=[]}else{if(val!=0)tty.output.push(val)}},fsync(tty){if(tty.output&&tty.output.length>0){out(UTF8ArrayToString(tty.output,0));tty.output=[]}},ioctl_tcgets(tty){return{c_iflag:25856,c_oflag:5,c_cflag:191,c_lflag:35387,c_cc:[3,28,127,21,4,0,1,0,17,19,26,0,18,15,23,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]}},ioctl_tcsets(tty,optional_actions,data){return 0},ioctl_tiocgwinsz(tty){return[24,80]}},default_tty1_ops:{put_char(tty,val){if(val===null||val===10){err(UTF8ArrayToString(tty.output,0));tty.output=[]}else{if(val!=0)tty.output.push(val)}},fsync(tty){if(tty.output&&tty.output.length>0){err(UTF8ArrayToString(tty.output,0));tty.output=[]}}}};Module["TTY"]=TTY;var zeroMemory=(address,size)=>{HEAPU8.fill(0,address,address+size);return address};Module["zeroMemory"]=zeroMemory;var alignMemory=(size,alignment)=>Math.ceil(size/alignment)*alignment;Module["alignMemory"]=alignMemory;var mmapAlloc=size=>{size=alignMemory(size,65536);var ptr=_emscripten_builtin_memalign(65536,size);if(!ptr)return 0;return zeroMemory(ptr,size)};Module["mmapAlloc"]=mmapAlloc;var MEMFS={ops_table:null,mount(mount){return MEMFS.createNode(null,"/",16384|511,0)},createNode(parent,name,mode,dev){if(FS.isBlkdev(mode)||FS.isFIFO(mode)){throw new FS.ErrnoError(63)}MEMFS.ops_table||={dir:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,lookup:MEMFS.node_ops.lookup,mknod:MEMFS.node_ops.mknod,rename:MEMFS.node_ops.rename,unlink:MEMFS.node_ops.unlink,rmdir:MEMFS.node_ops.rmdir,readdir:MEMFS.node_ops.readdir,symlink:MEMFS.node_ops.symlink},stream:{llseek:MEMFS.stream_ops.llseek}},file:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:{llseek:MEMFS.stream_ops.llseek,read:MEMFS.stream_ops.read,write:MEMFS.stream_ops.write,allocate:MEMFS.stream_ops.allocate,mmap:MEMFS.stream_ops.mmap,msync:MEMFS.stream_ops.msync}},link:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,readlink:MEMFS.node_ops.readlink},stream:{}},chrdev:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:FS.chrdev_stream_ops}};var node=FS.createNode(parent,name,mode,dev);if(FS.isDir(node.mode)){node.node_ops=MEMFS.ops_table.dir.node;node.stream_ops=MEMFS.ops_table.dir.stream;node.contents={}}else if(FS.isFile(node.mode)){node.node_ops=MEMFS.ops_table.file.node;node.stream_ops=MEMFS.ops_table.file.stream;node.usedBytes=0;node.contents=null}else if(FS.isLink(node.mode)){node.node_ops=MEMFS.ops_table.link.node;node.stream_ops=MEMFS.ops_table.link.stream}else if(FS.isChrdev(node.mode)){node.node_ops=MEMFS.ops_table.chrdev.node;node.stream_ops=MEMFS.ops_table.chrdev.stream}node.timestamp=Date.now();if(parent){parent.contents[name]=node;parent.timestamp=node.timestamp}return node},getFileDataAsTypedArray(node){if(!node.contents)return new Uint8Array(0);if(node.contents.subarray)return node.contents.subarray(0,node.usedBytes);return new Uint8Array(node.contents)},expandFileStorage(node,newCapacity){var prevCapacity=node.contents?node.contents.length:0;if(prevCapacity>=newCapacity)return;var CAPACITY_DOUBLING_MAX=1024*1024;newCapacity=Math.max(newCapacity,prevCapacity*(prevCapacity<CAPACITY_DOUBLING_MAX?2:1.125)>>>0);if(prevCapacity!=0)newCapacity=Math.max(newCapacity,256);var oldContents=node.contents;node.contents=new Uint8Array(newCapacity);if(node.usedBytes>0)node.contents.set(oldContents.subarray(0,node.usedBytes),0)},resizeFileStorage(node,newSize){if(node.usedBytes==newSize)return;if(newSize==0){node.contents=null;node.usedBytes=0}else{var oldContents=node.contents;node.contents=new Uint8Array(newSize);if(oldContents){node.contents.set(oldContents.subarray(0,Math.min(newSize,node.usedBytes)))}node.usedBytes=newSize}},node_ops:{getattr(node){var attr={};attr.dev=FS.isChrdev(node.mode)?node.id:1;attr.ino=node.id;attr.mode=node.mode;attr.nlink=1;attr.uid=0;attr.gid=0;attr.rdev=node.rdev;if(FS.isDir(node.mode)){attr.size=4096}else if(FS.isFile(node.mode)){attr.size=node.usedBytes}else if(FS.isLink(node.mode)){attr.size=node.link.length}else{attr.size=0}attr.atime=new Date(node.timestamp);attr.mtime=new Date(node.timestamp);attr.ctime=new Date(node.timestamp);attr.blksize=4096;attr.blocks=Math.ceil(attr.size/attr.blksize);return attr},setattr(node,attr){if(attr.mode!==undefined){node.mode=attr.mode}if(attr.timestamp!==undefined){node.timestamp=attr.timestamp}if(attr.size!==undefined){MEMFS.resizeFileStorage(node,attr.size)}},lookup(parent,name){throw FS.genericErrors[44]},mknod(parent,name,mode,dev){return MEMFS.createNode(parent,name,mode,dev)},rename(old_node,new_dir,new_name){if(FS.isDir(old_node.mode)){var new_node;try{new_node=FS.lookupNode(new_dir,new_name)}catch(e){}if(new_node){for(var i in new_node.contents){throw new FS.ErrnoError(55)}}}delete old_node.parent.contents[old_node.name];old_node.parent.timestamp=Date.now();old_node.name=new_name;new_dir.contents[new_name]=old_node;new_dir.timestamp=old_node.parent.timestamp},unlink(parent,name){delete parent.contents[name];parent.timestamp=Date.now()},rmdir(parent,name){var node=FS.lookupNode(parent,name);for(var i in node.contents){throw new FS.ErrnoError(55)}delete parent.contents[name];parent.timestamp=Date.now()},readdir(node){var entries=[".",".."];for(var key of Object.keys(node.contents)){entries.push(key)}return entries},symlink(parent,newname,oldpath){var node=MEMFS.createNode(parent,newname,511|40960,0);node.link=oldpath;return node},readlink(node){if(!FS.isLink(node.mode)){throw new FS.ErrnoError(28)}return node.link}},stream_ops:{read(stream,buffer,offset,length,position){var contents=stream.node.contents;if(position>=stream.node.usedBytes)return 0;var size=Math.min(stream.node.usedBytes-position,length);if(size>8&&contents.subarray){buffer.set(contents.subarray(position,position+size),offset)}else{for(var i=0;i<size;i++)buffer[offset+i]=contents[position+i]}return size},write(stream,buffer,offset,length,position,canOwn){if(buffer.buffer===HEAP8.buffer){canOwn=false}if(!length)return 0;var node=stream.node;node.timestamp=Date.now();if(buffer.subarray&&(!node.contents||node.contents.subarray)){if(canOwn){node.contents=buffer.subarray(offset,offset+length);node.usedBytes=length;return length}else if(node.usedBytes===0&&position===0){node.contents=buffer.slice(offset,offset+length);node.usedBytes=length;return length}else if(position+length<=node.usedBytes){node.contents.set(buffer.subarray(offset,offset+length),position);return length}}MEMFS.expandFileStorage(node,position+length);if(node.contents.subarray&&buffer.subarray){node.contents.set(buffer.subarray(offset,offset+length),position)}else{for(var i=0;i<length;i++){node.contents[position+i]=buffer[offset+i]}}node.usedBytes=Math.max(node.usedBytes,position+length);return length},llseek(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){position+=stream.node.usedBytes}}if(position<0){throw new FS.ErrnoError(28)}return position},allocate(stream,offset,length){MEMFS.expandFileStorage(stream.node,offset+length);stream.node.usedBytes=Math.max(stream.node.usedBytes,offset+length)},mmap(stream,length,position,prot,flags){if(!FS.isFile(stream.node.mode)){throw new FS.ErrnoError(43)}var ptr;var allocated;var contents=stream.node.contents;if(!(flags&2)&&contents.buffer===HEAP8.buffer){allocated=false;ptr=contents.byteOffset}else{if(position>0||position+length<contents.length){if(contents.subarray){contents=contents.subarray(position,position+length)}else{contents=Array.prototype.slice.call(contents,position,position+length)}}allocated=true;ptr=mmapAlloc(length);if(!ptr){throw new FS.ErrnoError(48)}HEAP8.set(contents,ptr)}return{ptr:ptr,allocated:allocated}},msync(stream,buffer,offset,length,mmapFlags){MEMFS.stream_ops.write(stream,buffer,0,length,offset,false);return 0}}};Module["MEMFS"]=MEMFS;var asyncLoad=(url,onload,onerror,noRunDep)=>{var dep=!noRunDep?getUniqueRunDependency(`al ${url}`):"";readAsync(url).then(arrayBuffer=>{onload(new Uint8Array(arrayBuffer));if(dep)removeRunDependency(dep)},err=>{if(onerror){onerror()}else{throw`Loading data file "${url}" failed.`}});if(dep)addRunDependency(dep)};Module["asyncLoad"]=asyncLoad;var FS_createDataFile=(parent,name,fileData,canRead,canWrite,canOwn)=>{FS.createDataFile(parent,name,fileData,canRead,canWrite,canOwn)};Module["FS_createDataFile"]=FS_createDataFile;var preloadPlugins=Module["preloadPlugins"]||[];Module["preloadPlugins"]=preloadPlugins;var FS_handledByPreloadPlugin=(byteArray,fullname,finish,onerror)=>{if(typeof Browser!="undefined")Browser.init();var handled=false;preloadPlugins.forEach(plugin=>{if(handled)return;if(plugin["canHandle"](fullname)){plugin["handle"](byteArray,fullname,finish,onerror);handled=true}});return handled};Module["FS_handledByPreloadPlugin"]=FS_handledByPreloadPlugin;var FS_createPreloadedFile=(parent,name,url,canRead,canWrite,onload,onerror,dontCreateFile,canOwn,preFinish)=>{var fullname=name?PATH_FS.resolve(PATH.join2(parent,name)):parent;var dep=getUniqueRunDependency(`cp ${fullname}`);function processData(byteArray){function finish(byteArray){preFinish?.();if(!dontCreateFile){FS_createDataFile(parent,name,byteArray,canRead,canWrite,canOwn)}onload?.();removeRunDependency(dep)}if(FS_handledByPreloadPlugin(byteArray,fullname,finish,()=>{onerror?.();removeRunDependency(dep)})){return}finish(byteArray)}addRunDependency(dep);if(typeof url=="string"){asyncLoad(url,processData,onerror)}else{processData(url)}};Module["FS_createPreloadedFile"]=FS_createPreloadedFile;var FS_modeStringToFlags=str=>{var flagModes={r:0,"r+":2,w:512|64|1,"w+":512|64|2,a:1024|64|1,"a+":1024|64|2};var flags=flagModes[str];if(typeof flags=="undefined"){throw new Error(`Unknown file open mode: ${str}`)}return flags};Module["FS_modeStringToFlags"]=FS_modeStringToFlags;var FS_getMode=(canRead,canWrite)=>{var mode=0;if(canRead)mode|=292|73;if(canWrite)mode|=146;return mode};Module["FS_getMode"]=FS_getMode;var WORKERFS={DIR_MODE:16895,FILE_MODE:33279,reader:null,mount(mount){assert(ENVIRONMENT_IS_WORKER);if(!WORKERFS.reader)WORKERFS.reader=new FileReaderSync;var root=WORKERFS.createNode(null,"/",WORKERFS.DIR_MODE,0);var createdParents={};function ensureParent(path){var parts=path.split("/");var parent=root;for(var i=0;i<parts.length-1;i++){var curr=parts.slice(0,i+1).join("/");createdParents[curr]||=WORKERFS.createNode(parent,parts[i],WORKERFS.DIR_MODE,0);parent=createdParents[curr]}return parent}function base(path){var parts=path.split("/");return parts[parts.length-1]}Array.prototype.forEach.call(mount.opts["files"]||[],function(file){WORKERFS.createNode(ensureParent(file.name),base(file.name),WORKERFS.FILE_MODE,0,file,file.lastModifiedDate)});(mount.opts["blobs"]||[]).forEach(function(obj){WORKERFS.createNode(ensureParent(obj["name"]),base(obj["name"]),WORKERFS.FILE_MODE,0,obj["data"])});(mount.opts["packages"]||[]).forEach(function(pack){pack["metadata"].files.forEach(function(file){var name=file.filename.substr(1);WORKERFS.createNode(ensureParent(name),base(name),WORKERFS.FILE_MODE,0,pack["blob"].slice(file.start,file.end))})});return root},createNode(parent,name,mode,dev,contents,mtime){var node=FS.createNode(parent,name,mode);node.mode=mode;node.node_ops=WORKERFS.node_ops;node.stream_ops=WORKERFS.stream_ops;node.timestamp=(mtime||new Date).getTime();assert(WORKERFS.FILE_MODE!==WORKERFS.DIR_MODE);if(mode===WORKERFS.FILE_MODE){node.size=contents.size;node.contents=contents}else{node.size=4096;node.contents={}}if(parent){parent.contents[name]=node}return node},node_ops:{getattr(node){return{dev:1,ino:node.id,mode:node.mode,nlink:1,uid:0,gid:0,rdev:0,size:node.size,atime:new Date(node.timestamp),mtime:new Date(node.timestamp),ctime:new Date(node.timestamp),blksize:4096,blocks:Math.ceil(node.size/4096)}},setattr(node,attr){if(attr.mode!==undefined){node.mode=attr.mode}if(attr.timestamp!==undefined){node.timestamp=attr.timestamp}},lookup(parent,name){throw new FS.ErrnoError(44)},mknod(parent,name,mode,dev){throw new FS.ErrnoError(63)},rename(oldNode,newDir,newName){throw new FS.ErrnoError(63)},unlink(parent,name){throw new FS.ErrnoError(63)},rmdir(parent,name){throw new FS.ErrnoError(63)},readdir(node){var entries=[".",".."];for(var key of Object.keys(node.contents)){entries.push(key)}return entries},symlink(parent,newName,oldPath){throw new FS.ErrnoError(63)}},stream_ops:{read(stream,buffer,offset,length,position){if(position>=stream.node.size)return 0;var chunk=stream.node.contents.slice(position,position+length);var ab=WORKERFS.reader.readAsArrayBuffer(chunk);buffer.set(new Uint8Array(ab),offset);return chunk.size},write(stream,buffer,offset,length,position){throw new FS.ErrnoError(29)},llseek(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){position+=stream.node.size}}if(position<0){throw new FS.ErrnoError(28)}return position}}};Module["WORKERFS"]=WORKERFS;var FS={root:null,mounts:[],devices:{},streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:class{constructor(errno){this.name="ErrnoError";this.errno=errno}},genericErrors:{},filesystems:null,syncFSRequests:0,FSStream:class{constructor(){this.shared={}}get object(){return this.node}set object(val){this.node=val}get isRead(){return(this.flags&2097155)!==1}get isWrite(){return(this.flags&2097155)!==0}get isAppend(){return this.flags&1024}get flags(){return this.shared.flags}set flags(val){this.shared.flags=val}get position(){return this.shared.position}set position(val){this.shared.position=val}},FSNode:class{constructor(parent,name,mode,rdev){if(!parent){parent=this}this.parent=parent;this.mount=parent.mount;this.mounted=null;this.id=FS.nextInode++;this.name=name;this.mode=mode;this.node_ops={};this.stream_ops={};this.rdev=rdev;this.readMode=292|73;this.writeMode=146}get read(){return(this.mode&this.readMode)===this.readMode}set read(val){val?this.mode|=this.readMode:this.mode&=~this.readMode}get write(){return(this.mode&this.writeMode)===this.writeMode}set write(val){val?this.mode|=this.writeMode:this.mode&=~this.writeMode}get isFolder(){return FS.isDir(this.mode)}get isDevice(){return FS.isChrdev(this.mode)}},lookupPath(path,opts={}){path=PATH_FS.resolve(path);if(!path)return{path:"",node:null};var defaults={follow_mount:true,recurse_count:0};opts=Object.assign(defaults,opts);if(opts.recurse_count>8){throw new FS.ErrnoError(32)}var parts=path.split("/").filter(p=>!!p);var current=FS.root;var current_path="/";for(var i=0;i<parts.length;i++){var islast=i===parts.length-1;if(islast&&opts.parent){break}current=FS.lookupNode(current,parts[i]);current_path=PATH.join2(current_path,parts[i]);if(FS.isMountpoint(current)){if(!islast||islast&&opts.follow_mount){current=current.mounted.root}}if(!islast||opts.follow){var count=0;while(FS.isLink(current.mode)){var link=FS.readlink(current_path);current_path=PATH_FS.resolve(PATH.dirname(current_path),link);var lookup=FS.lookupPath(current_path,{recurse_count:opts.recurse_count+1});current=lookup.node;if(count++>40){throw new FS.ErrnoError(32)}}}}return{path:current_path,node:current}},getPath(node){var path;while(true){if(FS.isRoot(node)){var mount=node.mount.mountpoint;if(!path)return mount;return mount[mount.length-1]!=="/"?`${mount}/${path}`:mount+path}path=path?`${node.name}/${path}`:node.name;node=node.parent}},hashName(parentid,name){var hash=0;for(var i=0;i<name.length;i++){hash=(hash<<5)-hash+name.charCodeAt(i)|0}return(parentid+hash>>>0)%FS.nameTable.length},hashAddNode(node){var hash=FS.hashName(node.parent.id,node.name);node.name_next=FS.nameTable[hash];FS.nameTable[hash]=node},hashRemoveNode(node){var hash=FS.hashName(node.parent.id,node.name);if(FS.nameTable[hash]===node){FS.nameTable[hash]=node.name_next}else{var current=FS.nameTable[hash];while(current){if(current.name_next===node){current.name_next=node.name_next;break}current=current.name_next}}},lookupNode(parent,name){var errCode=FS.mayLookup(parent);if(errCode){throw new FS.ErrnoError(errCode)}var hash=FS.hashName(parent.id,name);for(var node=FS.nameTable[hash];node;node=node.name_next){var nodeName=node.name;if(node.parent.id===parent.id&&nodeName===name){return node}}return FS.lookup(parent,name)},createNode(parent,name,mode,rdev){var node=new FS.FSNode(parent,name,mode,rdev);FS.hashAddNode(node);return node},destroyNode(node){FS.hashRemoveNode(node)},isRoot(node){return node===node.parent},isMountpoint(node){return!!node.mounted},isFile(mode){return(mode&61440)===32768},isDir(mode){return(mode&61440)===16384},isLink(mode){return(mode&61440)===40960},isChrdev(mode){return(mode&61440)===8192},isBlkdev(mode){return(mode&61440)===24576},isFIFO(mode){return(mode&61440)===4096},isSocket(mode){return(mode&49152)===49152},flagsToPermissionString(flag){var perms=["r","w","rw"][flag&3];if(flag&512){perms+="w"}return perms},nodePermissions(node,perms){if(FS.ignorePermissions){return 0}if(perms.includes("r")&&!(node.mode&292)){return 2}else if(perms.includes("w")&&!(node.mode&146)){return 2}else if(perms.includes("x")&&!(node.mode&73)){return 2}return 0},mayLookup(dir){if(!FS.isDir(dir.mode))return 54;var errCode=FS.nodePermissions(dir,"x");if(errCode)return errCode;if(!dir.node_ops.lookup)return 2;return 0},mayCreate(dir,name){try{var node=FS.lookupNode(dir,name);return 20}catch(e){}return FS.nodePermissions(dir,"wx")},mayDelete(dir,name,isdir){var node;try{node=FS.lookupNode(dir,name)}catch(e){return e.errno}var errCode=FS.nodePermissions(dir,"wx");if(errCode){return errCode}if(isdir){if(!FS.isDir(node.mode)){return 54}if(FS.isRoot(node)||FS.getPath(node)===FS.cwd()){return 10}}else{if(FS.isDir(node.mode)){return 31}}return 0},mayOpen(node,flags){if(!node){return 44}if(FS.isLink(node.mode)){return 32}else if(FS.isDir(node.mode)){if(FS.flagsToPermissionString(flags)!=="r"||flags&512){return 31}}return FS.nodePermissions(node,FS.flagsToPermissionString(flags))},MAX_OPEN_FDS:4096,nextfd(){for(var fd=0;fd<=FS.MAX_OPEN_FDS;fd++){if(!FS.streams[fd]){return fd}}throw new FS.ErrnoError(33)},getStreamChecked(fd){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(8)}return stream},getStream:fd=>FS.streams[fd],createStream(stream,fd=-1){stream=Object.assign(new FS.FSStream,stream);if(fd==-1){fd=FS.nextfd()}stream.fd=fd;FS.streams[fd]=stream;return stream},closeStream(fd){FS.streams[fd]=null},dupStream(origStream,fd=-1){var stream=FS.createStream(origStream,fd);stream.stream_ops?.dup?.(stream);return stream},chrdev_stream_ops:{open(stream){var device=FS.getDevice(stream.node.rdev);stream.stream_ops=device.stream_ops;stream.stream_ops.open?.(stream)},llseek(){throw new FS.ErrnoError(70)}},major:dev=>dev>>8,minor:dev=>dev&255,makedev:(ma,mi)=>ma<<8|mi,registerDevice(dev,ops){FS.devices[dev]={stream_ops:ops}},getDevice:dev=>FS.devices[dev],getMounts(mount){var mounts=[];var check=[mount];while(check.length){var m=check.pop();mounts.push(m);check.push(...m.mounts)}return mounts},syncfs(populate,callback){if(typeof populate=="function"){callback=populate;populate=false}FS.syncFSRequests++;if(FS.syncFSRequests>1){err(`warning: ${FS.syncFSRequests} FS.syncfs operations in flight at once, probably just doing extra work`)}var mounts=FS.getMounts(FS.root.mount);var completed=0;function doCallback(errCode){FS.syncFSRequests--;return callback(errCode)}function done(errCode){if(errCode){if(!done.errored){done.errored=true;return doCallback(errCode)}return}if(++completed>=mounts.length){doCallback(null)}}mounts.forEach(mount=>{if(!mount.type.syncfs){return done(null)}mount.type.syncfs(mount,populate,done)})},mount(type,opts,mountpoint){var root=mountpoint==="/";var pseudo=!mountpoint;var node;if(root&&FS.root){throw new FS.ErrnoError(10)}else if(!root&&!pseudo){var lookup=FS.lookupPath(mountpoint,{follow_mount:false});mountpoint=lookup.path;node=lookup.node;if(FS.isMountpoint(node)){throw new FS.ErrnoError(10)}if(!FS.isDir(node.mode)){throw new FS.ErrnoError(54)}}var mount={type:type,opts:opts,mountpoint:mountpoint,mounts:[]};var mountRoot=type.mount(mount);mountRoot.mount=mount;mount.root=mountRoot;if(root){FS.root=mountRoot}else if(node){node.mounted=mount;if(node.mount){node.mount.mounts.push(mount)}}return mountRoot},unmount(mountpoint){var lookup=FS.lookupPath(mountpoint,{follow_mount:false});if(!FS.isMountpoint(lookup.node)){throw new FS.ErrnoError(28)}var node=lookup.node;var mount=node.mounted;var mounts=FS.getMounts(mount);Object.keys(FS.nameTable).forEach(hash=>{var current=FS.nameTable[hash];while(current){var next=current.name_next;if(mounts.includes(current.mount)){FS.destroyNode(current)}current=next}});node.mounted=null;var idx=node.mount.mounts.indexOf(mount);node.mount.mounts.splice(idx,1)},lookup(parent,name){return parent.node_ops.lookup(parent,name)},mknod(path,mode,dev){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);if(!name||name==="."||name===".."){throw new FS.ErrnoError(28)}var errCode=FS.mayCreate(parent,name);if(errCode){throw new FS.ErrnoError(errCode)}if(!parent.node_ops.mknod){throw new FS.ErrnoError(63)}return parent.node_ops.mknod(parent,name,mode,dev)},create(path,mode){mode=mode!==undefined?mode:438;mode&=4095;mode|=32768;return FS.mknod(path,mode,0)},mkdir(path,mode){mode=mode!==undefined?mode:511;mode&=511|512;mode|=16384;return FS.mknod(path,mode,0)},mkdirTree(path,mode){var dirs=path.split("/");var d="";for(var i=0;i<dirs.length;++i){if(!dirs[i])continue;d+="/"+dirs[i];try{FS.mkdir(d,mode)}catch(e){if(e.errno!=20)throw e}}},mkdev(path,mode,dev){if(typeof dev=="undefined"){dev=mode;mode=438}mode|=8192;return FS.mknod(path,mode,dev)},symlink(oldpath,newpath){if(!PATH_FS.resolve(oldpath)){throw new FS.ErrnoError(44)}var lookup=FS.lookupPath(newpath,{parent:true});var parent=lookup.node;if(!parent){throw new FS.ErrnoError(44)}var newname=PATH.basename(newpath);var errCode=FS.mayCreate(parent,newname);if(errCode){throw new FS.ErrnoError(errCode)}if(!parent.node_ops.symlink){throw new FS.ErrnoError(63)}return parent.node_ops.symlink(parent,newname,oldpath)},rename(old_path,new_path){var old_dirname=PATH.dirname(old_path);var new_dirname=PATH.dirname(new_path);var old_name=PATH.basename(old_path);var new_name=PATH.basename(new_path);var lookup,old_dir,new_dir;lookup=FS.lookupPath(old_path,{parent:true});old_dir=lookup.node;lookup=FS.lookupPath(new_path,{parent:true});new_dir=lookup.node;if(!old_dir||!new_dir)throw new FS.ErrnoError(44);if(old_dir.mount!==new_dir.mount){throw new FS.ErrnoError(75)}var old_node=FS.lookupNode(old_dir,old_name);var relative=PATH_FS.relative(old_path,new_dirname);if(relative.charAt(0)!=="."){throw new FS.ErrnoError(28)}relative=PATH_FS.relative(new_path,old_dirname);if(relative.charAt(0)!=="."){throw new FS.ErrnoError(55)}var new_node;try{new_node=FS.lookupNode(new_dir,new_name)}catch(e){}if(old_node===new_node){return}var isdir=FS.isDir(old_node.mode);var errCode=FS.mayDelete(old_dir,old_name,isdir);if(errCode){throw new FS.ErrnoError(errCode)}errCode=new_node?FS.mayDelete(new_dir,new_name,isdir):FS.mayCreate(new_dir,new_name);if(errCode){throw new FS.ErrnoError(errCode)}if(!old_dir.node_ops.rename){throw new FS.ErrnoError(63)}if(FS.isMountpoint(old_node)||new_node&&FS.isMountpoint(new_node)){throw new FS.ErrnoError(10)}if(new_dir!==old_dir){errCode=FS.nodePermissions(old_dir,"w");if(errCode){throw new FS.ErrnoError(errCode)}}FS.hashRemoveNode(old_node);try{old_dir.node_ops.rename(old_node,new_dir,new_name);old_node.parent=new_dir}catch(e){throw e}finally{FS.hashAddNode(old_node)}},rmdir(path){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);var node=FS.lookupNode(parent,name);var errCode=FS.mayDelete(parent,name,true);if(errCode){throw new FS.ErrnoError(errCode)}if(!parent.node_ops.rmdir){throw new FS.ErrnoError(63)}if(FS.isMountpoint(node)){throw new FS.ErrnoError(10)}parent.node_ops.rmdir(parent,name);FS.destroyNode(node)},readdir(path){var lookup=FS.lookupPath(path,{follow:true});var node=lookup.node;if(!node.node_ops.readdir){throw new FS.ErrnoError(54)}return node.node_ops.readdir(node)},unlink(path){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;if(!parent){throw new FS.ErrnoError(44)}var name=PATH.basename(path);var node=FS.lookupNode(parent,name);var errCode=FS.mayDelete(parent,name,false);if(errCode){throw new FS.ErrnoError(errCode)}if(!parent.node_ops.unlink){throw new FS.ErrnoError(63)}if(FS.isMountpoint(node)){throw new FS.ErrnoError(10)}parent.node_ops.unlink(parent,name);FS.destroyNode(node)},readlink(path){var lookup=FS.lookupPath(path);var link=lookup.node;if(!link){throw new FS.ErrnoError(44)}if(!link.node_ops.readlink){throw new FS.ErrnoError(28)}return PATH_FS.resolve(FS.getPath(link.parent),link.node_ops.readlink(link))},stat(path,dontFollow){var lookup=FS.lookupPath(path,{follow:!dontFollow});var node=lookup.node;if(!node){throw new FS.ErrnoError(44)}if(!node.node_ops.getattr){throw new FS.ErrnoError(63)}return node.node_ops.getattr(node)},lstat(path){return FS.stat(path,true)},chmod(path,mode,dontFollow){var node;if(typeof path=="string"){var lookup=FS.lookupPath(path,{follow:!dontFollow});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(63)}node.node_ops.setattr(node,{mode:mode&4095|node.mode&~4095,timestamp:Date.now()})},lchmod(path,mode){FS.chmod(path,mode,true)},fchmod(fd,mode){var stream=FS.getStreamChecked(fd);FS.chmod(stream.node,mode)},chown(path,uid,gid,dontFollow){var node;if(typeof path=="string"){var lookup=FS.lookupPath(path,{follow:!dontFollow});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(63)}node.node_ops.setattr(node,{timestamp:Date.now()})},lchown(path,uid,gid){FS.chown(path,uid,gid,true)},fchown(fd,uid,gid){var stream=FS.getStreamChecked(fd);FS.chown(stream.node,uid,gid)},truncate(path,len){if(len<0){throw new FS.ErrnoError(28)}var node;if(typeof path=="string"){var lookup=FS.lookupPath(path,{follow:true});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(63)}if(FS.isDir(node.mode)){throw new FS.ErrnoError(31)}if(!FS.isFile(node.mode)){throw new FS.ErrnoError(28)}var errCode=FS.nodePermissions(node,"w");if(errCode){throw new FS.ErrnoError(errCode)}node.node_ops.setattr(node,{size:len,timestamp:Date.now()})},ftruncate(fd,len){var stream=FS.getStreamChecked(fd);if((stream.flags&2097155)===0){throw new FS.ErrnoError(28)}FS.truncate(stream.node,len)},utime(path,atime,mtime){var lookup=FS.lookupPath(path,{follow:true});var node=lookup.node;node.node_ops.setattr(node,{timestamp:Math.max(atime,mtime)})},open(path,flags,mode){if(path===""){throw new FS.ErrnoError(44)}flags=typeof flags=="string"?FS_modeStringToFlags(flags):flags;if(flags&64){mode=typeof mode=="undefined"?438:mode;mode=mode&4095|32768}else{mode=0}var node;if(typeof path=="object"){node=path}else{path=PATH.normalize(path);try{var lookup=FS.lookupPath(path,{follow:!(flags&131072)});node=lookup.node}catch(e){}}var created=false;if(flags&64){if(node){if(flags&128){throw new FS.ErrnoError(20)}}else{node=FS.mknod(path,mode,0);created=true}}if(!node){throw new FS.ErrnoError(44)}if(FS.isChrdev(node.mode)){flags&=~512}if(flags&65536&&!FS.isDir(node.mode)){throw new FS.ErrnoError(54)}if(!created){var errCode=FS.mayOpen(node,flags);if(errCode){throw new FS.ErrnoError(errCode)}}if(flags&512&&!created){FS.truncate(node,0)}flags&=~(128|512|131072);var stream=FS.createStream({node:node,path:FS.getPath(node),flags:flags,seekable:true,position:0,stream_ops:node.stream_ops,ungotten:[],error:false});if(stream.stream_ops.open){stream.stream_ops.open(stream)}if(Module["logReadFiles"]&&!(flags&1)){if(!FS.readFiles)FS.readFiles={};if(!(path in FS.readFiles)){FS.readFiles[path]=1}}return stream},close(stream){if(FS.isClosed(stream)){throw new FS.ErrnoError(8)}if(stream.getdents)stream.getdents=null;try{if(stream.stream_ops.close){stream.stream_ops.close(stream)}}catch(e){throw e}finally{FS.closeStream(stream.fd)}stream.fd=null},isClosed(stream){return stream.fd===null},llseek(stream,offset,whence){if(FS.isClosed(stream)){throw new FS.ErrnoError(8)}if(!stream.seekable||!stream.stream_ops.llseek){throw new FS.ErrnoError(70)}if(whence!=0&&whence!=1&&whence!=2){throw new FS.ErrnoError(28)}stream.position=stream.stream_ops.llseek(stream,offset,whence);stream.ungotten=[];return stream.position},read(stream,buffer,offset,length,position){if(length<0||position<0){throw new FS.ErrnoError(28)}if(FS.isClosed(stream)){throw new FS.ErrnoError(8)}if((stream.flags&2097155)===1){throw new FS.ErrnoError(8)}if(FS.isDir(stream.node.mode)){throw new FS.ErrnoError(31)}if(!stream.stream_ops.read){throw new FS.ErrnoError(28)}var seeking=typeof position!="undefined";if(!seeking){position=stream.position}else if(!stream.seekable){throw new FS.ErrnoError(70)}var bytesRead=stream.stream_ops.read(stream,buffer,offset,length,position);if(!seeking)stream.position+=bytesRead;return bytesRead},write(stream,buffer,offset,length,position,canOwn){if(length<0||position<0){throw new FS.ErrnoError(28)}if(FS.isClosed(stream)){throw new FS.ErrnoError(8)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(8)}if(FS.isDir(stream.node.mode)){throw new FS.ErrnoError(31)}if(!stream.stream_ops.write){throw new FS.ErrnoError(28)}if(stream.seekable&&stream.flags&1024){FS.llseek(stream,0,2)}var seeking=typeof position!="undefined";if(!seeking){position=stream.position}else if(!stream.seekable){throw new FS.ErrnoError(70)}var bytesWritten=stream.stream_ops.write(stream,buffer,offset,length,position,canOwn);if(!seeking)stream.position+=bytesWritten;return bytesWritten},allocate(stream,offset,length){if(FS.isClosed(stream)){throw new FS.ErrnoError(8)}if(offset<0||length<=0){throw new FS.ErrnoError(28)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(8)}if(!FS.isFile(stream.node.mode)&&!FS.isDir(stream.node.mode)){throw new FS.ErrnoError(43)}if(!stream.stream_ops.allocate){throw new FS.ErrnoError(138)}stream.stream_ops.allocate(stream,offset,length)},mmap(stream,length,position,prot,flags){if((prot&2)!==0&&(flags&2)===0&&(stream.flags&2097155)!==2){throw new FS.ErrnoError(2)}if((stream.flags&2097155)===1){throw new FS.ErrnoError(2)}if(!stream.stream_ops.mmap){throw new FS.ErrnoError(43)}return stream.stream_ops.mmap(stream,length,position,prot,flags)},msync(stream,buffer,offset,length,mmapFlags){if(!stream.stream_ops.msync){return 0}return stream.stream_ops.msync(stream,buffer,offset,length,mmapFlags)},ioctl(stream,cmd,arg){if(!stream.stream_ops.ioctl){throw new FS.ErrnoError(59)}return stream.stream_ops.ioctl(stream,cmd,arg)},readFile(path,opts={}){opts.flags=opts.flags||0;opts.encoding=opts.encoding||"binary";if(opts.encoding!=="utf8"&&opts.encoding!=="binary"){throw new Error(`Invalid encoding type "${opts.encoding}"`)}var ret;var stream=FS.open(path,opts.flags);var stat=FS.stat(path);var length=stat.size;var buf=new Uint8Array(length);FS.read(stream,buf,0,length,0);if(opts.encoding==="utf8"){ret=UTF8ArrayToString(buf,0)}else if(opts.encoding==="binary"){ret=buf}FS.close(stream);return ret},writeFile(path,data,opts={}){opts.flags=opts.flags||577;var stream=FS.open(path,opts.flags,opts.mode);if(typeof data=="string"){var buf=new Uint8Array(lengthBytesUTF8(data)+1);var actualNumBytes=stringToUTF8Array(data,buf,0,buf.length);FS.write(stream,buf,0,actualNumBytes,undefined,opts.canOwn)}else if(ArrayBuffer.isView(data)){FS.write(stream,data,0,data.byteLength,undefined,opts.canOwn)}else{throw new Error("Unsupported data type")}FS.close(stream)},cwd:()=>FS.currentPath,chdir(path){var lookup=FS.lookupPath(path,{follow:true});if(lookup.node===null){throw new FS.ErrnoError(44)}if(!FS.isDir(lookup.node.mode)){throw new FS.ErrnoError(54)}var errCode=FS.nodePermissions(lookup.node,"x");if(errCode){throw new FS.ErrnoError(errCode)}FS.currentPath=lookup.path},createDefaultDirectories(){FS.mkdir("/tmp");FS.mkdir("/home");FS.mkdir("/home/web_user")},createDefaultDevices(){FS.mkdir("/dev");FS.registerDevice(FS.makedev(1,3),{read:()=>0,write:(stream,buffer,offset,length,pos)=>length});FS.mkdev("/dev/null",FS.makedev(1,3));TTY.register(FS.makedev(5,0),TTY.default_tty_ops);TTY.register(FS.makedev(6,0),TTY.default_tty1_ops);FS.mkdev("/dev/tty",FS.makedev(5,0));FS.mkdev("/dev/tty1",FS.makedev(6,0));var randomBuffer=new Uint8Array(1024),randomLeft=0;var randomByte=()=>{if(randomLeft===0){randomLeft=randomFill(randomBuffer).byteLength}return randomBuffer[--randomLeft]};FS.createDevice("/dev","random",randomByte);FS.createDevice("/dev","urandom",randomByte);FS.mkdir("/dev/shm");FS.mkdir("/dev/shm/tmp")},createSpecialDirectories(){FS.mkdir("/proc");var proc_self=FS.mkdir("/proc/self");FS.mkdir("/proc/self/fd");FS.mount({mount(){var node=FS.createNode(proc_self,"fd",16384|511,73);node.node_ops={lookup(parent,name){var fd=+name;var stream=FS.getStreamChecked(fd);var ret={parent:null,mount:{mountpoint:"fake"},node_ops:{readlink:()=>stream.path}};ret.parent=ret;return ret}};return node}},{},"/proc/self/fd")},createStandardStreams(){if(Module["stdin"]){FS.createDevice("/dev","stdin",Module["stdin"])}else{FS.symlink("/dev/tty","/dev/stdin")}if(Module["stdout"]){FS.createDevice("/dev","stdout",null,Module["stdout"])}else{FS.symlink("/dev/tty","/dev/stdout")}if(Module["stderr"]){FS.createDevice("/dev","stderr",null,Module["stderr"])}else{FS.symlink("/dev/tty1","/dev/stderr")}var stdin=FS.open("/dev/stdin",0);var stdout=FS.open("/dev/stdout",1);var stderr=FS.open("/dev/stderr",1)},staticInit(){[44].forEach(code=>{FS.genericErrors[code]=new FS.ErrnoError(code);FS.genericErrors[code].stack="<generic error, no stack>"});FS.nameTable=new Array(4096);FS.mount(MEMFS,{},"/");FS.createDefaultDirectories();FS.createDefaultDevices();FS.createSpecialDirectories();FS.filesystems={MEMFS:MEMFS,WORKERFS:WORKERFS}},init(input,output,error){FS.init.initialized=true;Module["stdin"]=input||Module["stdin"];Module["stdout"]=output||Module["stdout"];Module["stderr"]=error||Module["stderr"];FS.createStandardStreams()},quit(){FS.init.initialized=false;for(var i=0;i<FS.streams.length;i++){var stream=FS.streams[i];if(!stream){continue}FS.close(stream)}},findObject(path,dontResolveLastLink){var ret=FS.analyzePath(path,dontResolveLastLink);if(!ret.exists){return null}return ret.object},analyzePath(path,dontResolveLastLink){try{var lookup=FS.lookupPath(path,{follow:!dontResolveLastLink});path=lookup.path}catch(e){}var ret={isRoot:false,exists:false,error:0,name:null,path:null,object:null,parentExists:false,parentPath:null,parentObject:null};try{var lookup=FS.lookupPath(path,{parent:true});ret.parentExists=true;ret.parentPath=lookup.path;ret.parentObject=lookup.node;ret.name=PATH.basename(path);lookup=FS.lookupPath(path,{follow:!dontResolveLastLink});ret.exists=true;ret.path=lookup.path;ret.object=lookup.node;ret.name=lookup.node.name;ret.isRoot=lookup.path==="/"}catch(e){ret.error=e.errno}return ret},createPath(parent,path,canRead,canWrite){parent=typeof parent=="string"?parent:FS.getPath(parent);var parts=path.split("/").reverse();while(parts.length){var part=parts.pop();if(!part)continue;var current=PATH.join2(parent,part);try{FS.mkdir(current)}catch(e){}parent=current}return current},createFile(parent,name,properties,canRead,canWrite){var path=PATH.join2(typeof parent=="string"?parent:FS.getPath(parent),name);var mode=FS_getMode(canRead,canWrite);return FS.create(path,mode)},createDataFile(parent,name,data,canRead,canWrite,canOwn){var path=name;if(parent){parent=typeof parent=="string"?parent:FS.getPath(parent);path=name?PATH.join2(parent,name):parent}var mode=FS_getMode(canRead,canWrite);var node=FS.create(path,mode);if(data){if(typeof data=="string"){var arr=new Array(data.length);for(var i=0,len=data.length;i<len;++i)arr[i]=data.charCodeAt(i);data=arr}FS.chmod(node,mode|146);var stream=FS.open(node,577);FS.write(stream,data,0,data.length,0,canOwn);FS.close(stream);FS.chmod(node,mode)}},createDevice(parent,name,input,output){var path=PATH.join2(typeof parent=="string"?parent:FS.getPath(parent),name);var mode=FS_getMode(!!input,!!output);if(!FS.createDevice.major)FS.createDevice.major=64;var dev=FS.makedev(FS.createDevice.major++,0);FS.registerDevice(dev,{open(stream){stream.seekable=false},close(stream){if(output?.buffer?.length){output(10)}},read(stream,buffer,offset,length,pos){var bytesRead=0;for(var i=0;i<length;i++){var result;try{result=input()}catch(e){throw new FS.ErrnoError(29)}if(result===undefined&&bytesRead===0){throw new FS.ErrnoError(6)}if(result===null||result===undefined)break;bytesRead++;buffer[offset+i]=result}if(bytesRead){stream.node.timestamp=Date.now()}return bytesRead},write(stream,buffer,offset,length,pos){for(var i=0;i<length;i++){try{output(buffer[offset+i])}catch(e){throw new FS.ErrnoError(29)}}if(length){stream.node.timestamp=Date.now()}return i}});return FS.mkdev(path,mode,dev)},forceLoadFile(obj){if(obj.isDevice||obj.isFolder||obj.link||obj.contents)return true;if(typeof XMLHttpRequest!="undefined"){throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.")}else{try{obj.contents=readBinary(obj.url);obj.usedBytes=obj.contents.length}catch(e){throw new FS.ErrnoError(29)}}},createLazyFile(parent,name,url,canRead,canWrite){class LazyUint8Array{constructor(){this.lengthKnown=false;this.chunks=[]}get(idx){if(idx>this.length-1||idx<0){return undefined}var chunkOffset=idx%this.chunkSize;var chunkNum=idx/this.chunkSize|0;return this.getter(chunkNum)[chunkOffset]}setDataGetter(getter){this.getter=getter}cacheLength(){var xhr=new XMLHttpRequest;xhr.open("HEAD",url,false);xhr.send(null);if(!(xhr.status>=200&&xhr.status<300||xhr.status===304))throw new Error("Couldn't load "+url+". Status: "+xhr.status);var datalength=Number(xhr.getResponseHeader("Content-length"));var header;var hasByteServing=(header=xhr.getResponseHeader("Accept-Ranges"))&&header==="bytes";var usesGzip=(header=xhr.getResponseHeader("Content-Encoding"))&&header==="gzip";var chunkSize=1024*1024;if(!hasByteServing)chunkSize=datalength;var doXHR=(from,to)=>{if(from>to)throw new Error("invalid range ("+from+", "+to+") or no bytes requested!");if(to>datalength-1)throw new Error("only "+datalength+" bytes available! programmer error!");var xhr=new XMLHttpRequest;xhr.open("GET",url,false);if(datalength!==chunkSize)xhr.setRequestHeader("Range","bytes="+from+"-"+to);xhr.responseType="arraybuffer";if(xhr.overrideMimeType){xhr.overrideMimeType("text/plain; charset=x-user-defined")}xhr.send(null);if(!(xhr.status>=200&&xhr.status<300||xhr.status===304))throw new Error("Couldn't load "+url+". Status: "+xhr.status);if(xhr.response!==undefined){return new Uint8Array(xhr.response||[])}return intArrayFromString(xhr.responseText||"",true)};var lazyArray=this;lazyArray.setDataGetter(chunkNum=>{var start=chunkNum*chunkSize;var end=(chunkNum+1)*chunkSize-1;end=Math.min(end,datalength-1);if(typeof lazyArray.chunks[chunkNum]=="undefined"){lazyArray.chunks[chunkNum]=doXHR(start,end)}if(typeof lazyArray.chunks[chunkNum]=="undefined")throw new Error("doXHR failed!");return lazyArray.chunks[chunkNum]});if(usesGzip||!datalength){chunkSize=datalength=1;datalength=this.getter(0).length;chunkSize=datalength;out("LazyFiles on gzip forces download of the whole file when length is accessed")}this._length=datalength;this._chunkSize=chunkSize;this.lengthKnown=true}get length(){if(!this.lengthKnown){this.cacheLength()}return this._length}get chunkSize(){if(!this.lengthKnown){this.cacheLength()}return this._chunkSize}}if(typeof XMLHttpRequest!="undefined"){if(!ENVIRONMENT_IS_WORKER)throw"Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc";var lazyArray=new LazyUint8Array;var properties={isDevice:false,contents:lazyArray}}else{var properties={isDevice:false,url:url}}var node=FS.createFile(parent,name,properties,canRead,canWrite);if(properties.contents){node.contents=properties.contents}else if(properties.url){node.contents=null;node.url=properties.url}Object.defineProperties(node,{usedBytes:{get:function(){return this.contents.length}}});var stream_ops={};var keys=Object.keys(node.stream_ops);keys.forEach(key=>{var fn=node.stream_ops[key];stream_ops[key]=(...args)=>{FS.forceLoadFile(node);return fn(...args)}});function writeChunks(stream,buffer,offset,length,position){var contents=stream.node.contents;if(position>=contents.length)return 0;var size=Math.min(contents.length-position,length);if(contents.slice){for(var i=0;i<size;i++){buffer[offset+i]=contents[position+i]}}else{for(var i=0;i<size;i++){buffer[offset+i]=contents.get(position+i)}}return size}stream_ops.read=(stream,buffer,offset,length,position)=>{FS.forceLoadFile(node);return writeChunks(stream,buffer,offset,length,position)};stream_ops.mmap=(stream,length,position,prot,flags)=>{FS.forceLoadFile(node);var ptr=mmapAlloc(length);if(!ptr){throw new FS.ErrnoError(48)}writeChunks(stream,HEAP8,ptr,length,position);return{ptr:ptr,allocated:true}};node.stream_ops=stream_ops;return node}};Module["FS"]=FS;var UTF8ToString=(ptr,maxBytesToRead)=>ptr?UTF8ArrayToString(HEAPU8,ptr,maxBytesToRead):"";Module["UTF8ToString"]=UTF8ToString;var SYSCALLS={DEFAULT_POLLMASK:5,calculateAt(dirfd,path,allowEmpty){if(PATH.isAbs(path)){return path}var dir;if(dirfd===-100){dir=FS.cwd()}else{var dirstream=SYSCALLS.getStreamFromFD(dirfd);dir=dirstream.path}if(path.length==0){if(!allowEmpty){throw new FS.ErrnoError(44)}return dir}return PATH.join2(dir,path)},doStat(func,path,buf){var stat=func(path);HEAP32[buf>>2]=stat.dev;HEAP32[buf+4>>2]=stat.mode;HEAPU32[buf+8>>2]=stat.nlink;HEAP32[buf+12>>2]=stat.uid;HEAP32[buf+16>>2]=stat.gid;HEAP32[buf+20>>2]=stat.rdev;tempI64=[stat.size>>>0,(tempDouble=stat.size,+Math.abs(tempDouble)>=1?tempDouble>0?+Math.floor(tempDouble/4294967296)>>>0:~~+Math.ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[buf+24>>2]=tempI64[0],HEAP32[buf+28>>2]=tempI64[1];HEAP32[buf+32>>2]=4096;HEAP32[buf+36>>2]=stat.blocks;var atime=stat.atime.getTime();var mtime=stat.mtime.getTime();var ctime=stat.ctime.getTime();tempI64=[Math.floor(atime/1e3)>>>0,(tempDouble=Math.floor(atime/1e3),+Math.abs(tempDouble)>=1?tempDouble>0?+Math.floor(tempDouble/4294967296)>>>0:~~+Math.ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[buf+40>>2]=tempI64[0],HEAP32[buf+44>>2]=tempI64[1];HEAPU32[buf+48>>2]=atime%1e3*1e3;tempI64=[Math.floor(mtime/1e3)>>>0,(tempDouble=Math.floor(mtime/1e3),+Math.abs(tempDouble)>=1?tempDouble>0?+Math.floor(tempDouble/4294967296)>>>0:~~+Math.ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[buf+56>>2]=tempI64[0],HEAP32[buf+60>>2]=tempI64[1];HEAPU32[buf+64>>2]=mtime%1e3*1e3;tempI64=[Math.floor(ctime/1e3)>>>0,(tempDouble=Math.floor(ctime/1e3),+Math.abs(tempDouble)>=1?tempDouble>0?+Math.floor(tempDouble/4294967296)>>>0:~~+Math.ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[buf+72>>2]=tempI64[0],HEAP32[buf+76>>2]=tempI64[1];HEAPU32[buf+80>>2]=ctime%1e3*1e3;tempI64=[stat.ino>>>0,(tempDouble=stat.ino,+Math.abs(tempDouble)>=1?tempDouble>0?+Math.floor(tempDouble/4294967296)>>>0:~~+Math.ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[buf+88>>2]=tempI64[0],HEAP32[buf+92>>2]=tempI64[1];return 0},doMsync(addr,stream,len,flags,offset){if(!FS.isFile(stream.node.mode)){throw new FS.ErrnoError(43)}if(flags&2){return 0}var buffer=HEAPU8.slice(addr,addr+len);FS.msync(stream,buffer,offset,len,flags)},getStreamFromFD(fd){var stream=FS.getStreamChecked(fd);return stream},varargs:undefined,getStr(ptr){var ret=UTF8ToString(ptr);return ret}};Module["SYSCALLS"]=SYSCALLS;function ___syscall_fcntl64(fd,cmd,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(fd);switch(cmd){case 0:{var arg=syscallGetVarargI();if(arg<0){return-28}while(FS.streams[arg]){arg++}var newStream;newStream=FS.dupStream(stream,arg);return newStream.fd}case 1:case 2:return 0;case 3:return stream.flags;case 4:{var arg=syscallGetVarargI();stream.flags|=arg;return 0}case 12:{var arg=syscallGetVarargP();var offset=0;HEAP16[arg+offset>>1]=2;return 0}case 13:case 14:return 0}return-28}catch(e){if(typeof FS=="undefined"||!(e.name==="ErrnoError"))throw e;return-e.errno}}Module["___syscall_fcntl64"]=___syscall_fcntl64;function ___syscall_fstat64(fd,buf){try{var stream=SYSCALLS.getStreamFromFD(fd);return SYSCALLS.doStat(FS.stat,stream.path,buf)}catch(e){if(typeof FS=="undefined"||!(e.name==="ErrnoError"))throw e;return-e.errno}}Module["___syscall_fstat64"]=___syscall_fstat64;var convertI32PairToI53Checked=(lo,hi)=>hi+2097152>>>0<4194305-!!lo?(lo>>>0)+hi*4294967296:NaN;Module["convertI32PairToI53Checked"]=convertI32PairToI53Checked;function ___syscall_ftruncate64(fd,length_low,length_high){var length=convertI32PairToI53Checked(length_low,length_high);try{if(isNaN(length))return 61;FS.ftruncate(fd,length);return 0}catch(e){if(typeof FS=="undefined"||!(e.name==="ErrnoError"))throw e;return-e.errno}}Module["___syscall_ftruncate64"]=___syscall_ftruncate64;var stringToUTF8=(str,outPtr,maxBytesToWrite)=>stringToUTF8Array(str,HEAPU8,outPtr,maxBytesToWrite);Module["stringToUTF8"]=stringToUTF8;function ___syscall_getdents64(fd,dirp,count){try{var stream=SYSCALLS.getStreamFromFD(fd);stream.getdents||=FS.readdir(stream.path);var struct_size=280;var pos=0;var off=FS.llseek(stream,0,1);var idx=Math.floor(off/struct_size);while(idx<stream.getdents.length&&pos+struct_size<=count){var id;var type;var name=stream.getdents[idx];if(name==="."){id=stream.node.id;type=4}else if(name===".."){var lookup=FS.lookupPath(stream.path,{parent:true});id=lookup.node.id;type=4}else{var child=FS.lookupNode(stream.node,name);id=child.id;type=FS.isChrdev(child.mode)?2:FS.isDir(child.mode)?4:FS.isLink(child.mode)?10:8}tempI64=[id>>>0,(tempDouble=id,+Math.abs(tempDouble)>=1?tempDouble>0?+Math.floor(tempDouble/4294967296)>>>0:~~+Math.ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[dirp+pos>>2]=tempI64[0],HEAP32[dirp+pos+4>>2]=tempI64[1];tempI64=[(idx+1)*struct_size>>>0,(tempDouble=(idx+1)*struct_size,+Math.abs(tempDouble)>=1?tempDouble>0?+Math.floor(tempDouble/4294967296)>>>0:~~+Math.ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[dirp+pos+8>>2]=tempI64[0],HEAP32[dirp+pos+12>>2]=tempI64[1];HEAP16[dirp+pos+16>>1]=280;HEAP8[dirp+pos+18]=type;stringToUTF8(name,dirp+pos+19,256);pos+=struct_size;idx+=1}FS.llseek(stream,idx*struct_size,0);return pos}catch(e){if(typeof FS=="undefined"||!(e.name==="ErrnoError"))throw e;return-e.errno}}Module["___syscall_getdents64"]=___syscall_getdents64;function ___syscall_ioctl(fd,op,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(fd);switch(op){case 21509:{if(!stream.tty)return-59;return 0}case 21505:{if(!stream.tty)return-59;if(stream.tty.ops.ioctl_tcgets){var termios=stream.tty.ops.ioctl_tcgets(stream);var argp=syscallGetVarargP();HEAP32[argp>>2]=termios.c_iflag||0;HEAP32[argp+4>>2]=termios.c_oflag||0;HEAP32[argp+8>>2]=termios.c_cflag||0;HEAP32[argp+12>>2]=termios.c_lflag||0;for(var i=0;i<32;i++){HEAP8[argp+i+17]=termios.c_cc[i]||0}return 0}return 0}case 21510:case 21511:case 21512:{if(!stream.tty)return-59;return 0}case 21506:case 21507:case 21508:{if(!stream.tty)return-59;if(stream.tty.ops.ioctl_tcsets){var argp=syscallGetVarargP();var c_iflag=HEAP32[argp>>2];var c_oflag=HEAP32[argp+4>>2];var c_cflag=HEAP32[argp+8>>2];var c_lflag=HEAP32[argp+12>>2];var c_cc=[];for(var i=0;i<32;i++){c_cc.push(HEAP8[argp+i+17])}return stream.tty.ops.ioctl_tcsets(stream.tty,op,{c_iflag:c_iflag,c_oflag:c_oflag,c_cflag:c_cflag,c_lflag:c_lflag,c_cc:c_cc})}return 0}case 21519:{if(!stream.tty)return-59;var argp=syscallGetVarargP();HEAP32[argp>>2]=0;return 0}case 21520:{if(!stream.tty)return-59;return-28}case 21531:{var argp=syscallGetVarargP();return FS.ioctl(stream,op,argp)}case 21523:{if(!stream.tty)return-59;if(stream.tty.ops.ioctl_tiocgwinsz){var winsize=stream.tty.ops.ioctl_tiocgwinsz(stream.tty);var argp=syscallGetVarargP();HEAP16[argp>>1]=winsize[0];HEAP16[argp+2>>1]=winsize[1]}return 0}case 21524:{if(!stream.tty)return-59;return 0}case 21515:{if(!stream.tty)return-59;return 0}default:return-28}}catch(e){if(typeof FS=="undefined"||!(e.name==="ErrnoError"))throw e;return-e.errno}}Module["___syscall_ioctl"]=___syscall_ioctl;function ___syscall_lstat64(path,buf){try{path=SYSCALLS.getStr(path);return SYSCALLS.doStat(FS.lstat,path,buf)}catch(e){if(typeof FS=="undefined"||!(e.name==="ErrnoError"))throw e;return-e.errno}}Module["___syscall_lstat64"]=___syscall_lstat64;function ___syscall_mkdirat(dirfd,path,mode){try{path=SYSCALLS.getStr(path);path=SYSCALLS.calculateAt(dirfd,path);path=PATH.normalize(path);if(path[path.length-1]==="/")path=path.substr(0,path.length-1);FS.mkdir(path,mode,0);return 0}catch(e){if(typeof FS=="undefined"||!(e.name==="ErrnoError"))throw e;return-e.errno}}Module["___syscall_mkdirat"]=___syscall_mkdirat;function ___syscall_newfstatat(dirfd,path,buf,flags){try{path=SYSCALLS.getStr(path);var nofollow=flags&256;var allowEmpty=flags&4096;flags=flags&~6400;path=SYSCALLS.calculateAt(dirfd,path,allowEmpty);return SYSCALLS.doStat(nofollow?FS.lstat:FS.stat,path,buf)}catch(e){if(typeof FS=="undefined"||!(e.name==="ErrnoError"))throw e;return-e.errno}}Module["___syscall_newfstatat"]=___syscall_newfstatat;function ___syscall_openat(dirfd,path,flags,varargs){SYSCALLS.varargs=varargs;try{path=SYSCALLS.getStr(path);path=SYSCALLS.calculateAt(dirfd,path);var mode=varargs?syscallGetVarargI():0;return FS.open(path,flags,mode).fd}catch(e){if(typeof FS=="undefined"||!(e.name==="ErrnoError"))throw e;return-e.errno}}Module["___syscall_openat"]=___syscall_openat;function ___syscall_rmdir(path){try{path=SYSCALLS.getStr(path);FS.rmdir(path);return 0}catch(e){if(typeof FS=="undefined"||!(e.name==="ErrnoError"))throw e;return-e.errno}}Module["___syscall_rmdir"]=___syscall_rmdir;function ___syscall_stat64(path,buf){try{path=SYSCALLS.getStr(path);return SYSCALLS.doStat(FS.stat,path,buf)}catch(e){if(typeof FS=="undefined"||!(e.name==="ErrnoError"))throw e;return-e.errno}}Module["___syscall_stat64"]=___syscall_stat64;function ___syscall_unlinkat(dirfd,path,flags){try{path=SYSCALLS.getStr(path);path=SYSCALLS.calculateAt(dirfd,path);if(flags===0){FS.unlink(path)}else if(flags===512){FS.rmdir(path)}else{abort("Invalid flags passed to unlinkat")}return 0}catch(e){if(typeof FS=="undefined"||!(e.name==="ErrnoError"))throw e;return-e.errno}}Module["___syscall_unlinkat"]=___syscall_unlinkat;var __abort_js=()=>{abort("")};Module["__abort_js"]=__abort_js;var __embind_register_bigint=(primitiveType,name,size,minRange,maxRange)=>{};Module["__embind_register_bigint"]=__embind_register_bigint;var embind_init_charCodes=()=>{var codes=new Array(256);for(var i=0;i<256;++i){codes[i]=String.fromCharCode(i)}embind_charCodes=codes};Module["embind_init_charCodes"]=embind_init_charCodes;var embind_charCodes;Module["embind_charCodes"]=embind_charCodes;var readLatin1String=ptr=>{var ret="";var c=ptr;while(HEAPU8[c]){ret+=embind_charCodes[HEAPU8[c++]]}return ret};Module["readLatin1String"]=readLatin1String;var awaitingDependencies={};Module["awaitingDependencies"]=awaitingDependencies;var registeredTypes={};Module["registeredTypes"]=registeredTypes;var typeDependencies={};Module["typeDependencies"]=typeDependencies;var BindingError;Module["BindingError"]=BindingError;var throwBindingError=message=>{throw new BindingError(message)};Module["throwBindingError"]=throwBindingError;var InternalError;Module["InternalError"]=InternalError;var throwInternalError=message=>{throw new InternalError(message)};Module["throwInternalError"]=throwInternalError;var whenDependentTypesAreResolved=(myTypes,dependentTypes,getTypeConverters)=>{myTypes.forEach(function(type){typeDependencies[type]=dependentTypes});function onComplete(typeConverters){var myTypeConverters=getTypeConverters(typeConverters);if(myTypeConverters.length!==myTypes.length){throwInternalError("Mismatched type converter count")}for(var i=0;i<myTypes.length;++i){registerType(myTypes[i],myTypeConverters[i])}}var typeConverters=new Array(dependentTypes.length);var unregisteredTypes=[];var registered=0;dependentTypes.forEach((dt,i)=>{if(registeredTypes.hasOwnProperty(dt)){typeConverters[i]=registeredTypes[dt]}else{unregisteredTypes.push(dt);if(!awaitingDependencies.hasOwnProperty(dt)){awaitingDependencies[dt]=[]}awaitingDependencies[dt].push(()=>{typeConverters[i]=registeredTypes[dt];++registered;if(registered===unregisteredTypes.length){onComplete(typeConverters)}})}});if(0===unregisteredTypes.length){onComplete(typeConverters)}};Module["whenDependentTypesAreResolved"]=whenDependentTypesAreResolved;function sharedRegisterType(rawType,registeredInstance,options={}){var name=registeredInstance.name;if(!rawType){throwBindingError(`type "${name}" must have a positive integer typeid pointer`)}if(registeredTypes.hasOwnProperty(rawType)){if(options.ignoreDuplicateRegistrations){return}else{throwBindingError(`Cannot register type '${name}' twice`)}}registeredTypes[rawType]=registeredInstance;delete typeDependencies[rawType];if(awaitingDependencies.hasOwnProperty(rawType)){var callbacks=awaitingDependencies[rawType];delete awaitingDependencies[rawType];callbacks.forEach(cb=>cb())}}Module["sharedRegisterType"]=sharedRegisterType;function registerType(rawType,registeredInstance,options={}){if(!("argPackAdvance"in registeredInstance)){throw new TypeError("registerType registeredInstance requires argPackAdvance")}return sharedRegisterType(rawType,registeredInstance,options)}Module["registerType"]=registerType;var GenericWireTypeSize=8;Module["GenericWireTypeSize"]=GenericWireTypeSize;var __embind_register_bool=(rawType,name,trueValue,falseValue)=>{name=readLatin1String(name);registerType(rawType,{name:name,fromWireType:function(wt){return!!wt},toWireType:function(destructors,o){return o?trueValue:falseValue},argPackAdvance:GenericWireTypeSize,readValueFromPointer:function(pointer){return this["fromWireType"](HEAPU8[pointer])},destructorFunction:null})};Module["__embind_register_bool"]=__embind_register_bool;var shallowCopyInternalPointer=o=>({count:o.count,deleteScheduled:o.deleteScheduled,preservePointerOnDelete:o.preservePointerOnDelete,ptr:o.ptr,ptrType:o.ptrType,smartPtr:o.smartPtr,smartPtrType:o.smartPtrType});Module["shallowCopyInternalPointer"]=shallowCopyInternalPointer;var throwInstanceAlreadyDeleted=obj=>{function getInstanceTypeName(handle){return handle.$$.ptrType.registeredClass.name}throwBindingError(getInstanceTypeName(obj)+" instance already deleted")};Module["throwInstanceAlreadyDeleted"]=throwInstanceAlreadyDeleted;var finalizationRegistry=false;Module["finalizationRegistry"]=finalizationRegistry;var detachFinalizer=handle=>{};Module["detachFinalizer"]=detachFinalizer;var runDestructor=$$=>{if($$.smartPtr){$$.smartPtrType.rawDestructor($$.smartPtr)}else{$$.ptrType.registeredClass.rawDestructor($$.ptr)}};Module["runDestructor"]=runDestructor;var releaseClassHandle=$$=>{$$.count.value-=1;var toDelete=0===$$.count.value;if(toDelete){runDestructor($$)}};Module["releaseClassHandle"]=releaseClassHandle;var downcastPointer=(ptr,ptrClass,desiredClass)=>{if(ptrClass===desiredClass){return ptr}if(undefined===desiredClass.baseClass){return null}var rv=downcastPointer(ptr,ptrClass,desiredClass.baseClass);if(rv===null){return null}return desiredClass.downcast(rv)};Module["downcastPointer"]=downcastPointer;var registeredPointers={};Module["registeredPointers"]=registeredPointers;var getInheritedInstanceCount=()=>Object.keys(registeredInstances).length;Module["getInheritedInstanceCount"]=getInheritedInstanceCount;var getLiveInheritedInstances=()=>{var rv=[];for(var k in registeredInstances){if(registeredInstances.hasOwnProperty(k)){rv.push(registeredInstances[k])}}return rv};Module["getLiveInheritedInstances"]=getLiveInheritedInstances;var deletionQueue=[];Module["deletionQueue"]=deletionQueue;var flushPendingDeletes=()=>{while(deletionQueue.length){var obj=deletionQueue.pop();obj.$$.deleteScheduled=false;obj["delete"]()}};Module["flushPendingDeletes"]=flushPendingDeletes;var delayFunction;Module["delayFunction"]=delayFunction;var setDelayFunction=fn=>{delayFunction=fn;if(deletionQueue.length&&delayFunction){delayFunction(flushPendingDeletes)}};Module["setDelayFunction"]=setDelayFunction;var init_embind=()=>{Module["getInheritedInstanceCount"]=getInheritedInstanceCount;Module["getLiveInheritedInstances"]=getLiveInheritedInstances;Module["flushPendingDeletes"]=flushPendingDeletes;Module["setDelayFunction"]=setDelayFunction};Module["init_embind"]=init_embind;var registeredInstances={};Module["registeredInstances"]=registeredInstances;var getBasestPointer=(class_,ptr)=>{if(ptr===undefined){throwBindingError("ptr should not be undefined")}while(class_.baseClass){ptr=class_.upcast(ptr);class_=class_.baseClass}return ptr};Module["getBasestPointer"]=getBasestPointer;var getInheritedInstance=(class_,ptr)=>{ptr=getBasestPointer(class_,ptr);return registeredInstances[ptr]};Module["getInheritedInstance"]=getInheritedInstance;var makeClassHandle=(prototype,record)=>{if(!record.ptrType||!record.ptr){throwInternalError("makeClassHandle requires ptr and ptrType")}var hasSmartPtrType=!!record.smartPtrType;var hasSmartPtr=!!record.smartPtr;if(hasSmartPtrType!==hasSmartPtr){throwInternalError("Both smartPtrType and smartPtr must be specified")}record.count={value:1};return attachFinalizer(Object.create(prototype,{$$:{value:record,writable:true}}))};Module["makeClassHandle"]=makeClassHandle;function RegisteredPointer_fromWireType(ptr){var rawPointer=this.getPointee(ptr);if(!rawPointer){this.destructor(ptr);return null}var registeredInstance=getInheritedInstance(this.registeredClass,rawPointer);if(undefined!==registeredInstance){if(0===registeredInstance.$$.count.value){registeredInstance.$$.ptr=rawPointer;registeredInstance.$$.smartPtr=ptr;return registeredInstance["clone"]()}else{var rv=registeredInstance["clone"]();this.destructor(ptr);return rv}}function makeDefaultHandle(){if(this.isSmartPointer){return makeClassHandle(this.registeredClass.instancePrototype,{ptrType:this.pointeeType,ptr:rawPointer,smartPtrType:this,smartPtr:ptr})}else{return makeClassHandle(this.registeredClass.instancePrototype,{ptrType:this,ptr:ptr})}}var actualType=this.registeredClass.getActualType(rawPointer);var registeredPointerRecord=registeredPointers[actualType];if(!registeredPointerRecord){return makeDefaultHandle.call(this)}var toType;if(this.isConst){toType=registeredPointerRecord.constPointerType}else{toType=registeredPointerRecord.pointerType}var dp=downcastPointer(rawPointer,this.registeredClass,toType.registeredClass);if(dp===null){return makeDefaultHandle.call(this)}if(this.isSmartPointer){return makeClassHandle(toType.registeredClass.instancePrototype,{ptrType:toType,ptr:dp,smartPtrType:this,smartPtr:ptr})}else{return makeClassHandle(toType.registeredClass.instancePrototype,{ptrType:toType,ptr:dp})}}Module["RegisteredPointer_fromWireType"]=RegisteredPointer_fromWireType;var attachFinalizer=handle=>{if("undefined"===typeof FinalizationRegistry){attachFinalizer=handle=>handle;return handle}finalizationRegistry=new FinalizationRegistry(info=>{releaseClassHandle(info.$$)});attachFinalizer=handle=>{var $$=handle.$$;var hasSmartPtr=!!$$.smartPtr;if(hasSmartPtr){var info={$$:$$};finalizationRegistry.register(handle,info,handle)}return handle};detachFinalizer=handle=>finalizationRegistry.unregister(handle);return attachFinalizer(handle)};Module["attachFinalizer"]=attachFinalizer;var init_ClassHandle=()=>{Object.assign(ClassHandle.prototype,{isAliasOf(other){if(!(this instanceof ClassHandle)){return false}if(!(other instanceof ClassHandle)){return false}var leftClass=this.$$.ptrType.registeredClass;var left=this.$$.ptr;other.$$=other.$$;var rightClass=other.$$.ptrType.registeredClass;var right=other.$$.ptr;while(leftClass.baseClass){left=leftClass.upcast(left);leftClass=leftClass.baseClass}while(rightClass.baseClass){right=rightClass.upcast(right);rightClass=rightClass.baseClass}return leftClass===rightClass&&left===right},clone(){if(!this.$$.ptr){throwInstanceAlreadyDeleted(this)}if(this.$$.preservePointerOnDelete){this.$$.count.value+=1;return this}else{var clone=attachFinalizer(Object.create(Object.getPrototypeOf(this),{$$:{value:shallowCopyInternalPointer(this.$$)}}));clone.$$.count.value+=1;clone.$$.deleteScheduled=false;return clone}},delete(){if(!this.$$.ptr){throwInstanceAlreadyDeleted(this)}if(this.$$.deleteScheduled&&!this.$$.preservePointerOnDelete){throwBindingError("Object already scheduled for deletion")}detachFinalizer(this);releaseClassHandle(this.$$);if(!this.$$.preservePointerOnDelete){this.$$.smartPtr=undefined;this.$$.ptr=undefined}},isDeleted(){return!this.$$.ptr},deleteLater(){if(!this.$$.ptr){throwInstanceAlreadyDeleted(this)}if(this.$$.deleteScheduled&&!this.$$.preservePointerOnDelete){throwBindingError("Object already scheduled for deletion")}deletionQueue.push(this);if(deletionQueue.length===1&&delayFunction){delayFunction(flushPendingDeletes)}this.$$.deleteScheduled=true;return this}})};Module["init_ClassHandle"]=init_ClassHandle;function ClassHandle(){}Module["ClassHandle"]=ClassHandle;var createNamedFunction=(name,body)=>Object.defineProperty(body,"name",{value:name});Module["createNamedFunction"]=createNamedFunction;var ensureOverloadTable=(proto,methodName,humanName)=>{if(undefined===proto[methodName].overloadTable){var prevFunc=proto[methodName];proto[methodName]=function(...args){if(!proto[methodName].overloadTable.hasOwnProperty(args.length)){throwBindingError(`Function '${humanName}' called with an invalid number of arguments (${args.length}) - expects one of (${proto[methodName].overloadTable})!`)}return proto[methodName].overloadTable[args.length].apply(this,args)};proto[methodName].overloadTable=[];proto[methodName].overloadTable[prevFunc.argCount]=prevFunc}};Module["ensureOverloadTable"]=ensureOverloadTable;var exposePublicSymbol=(name,value,numArguments)=>{if(Module.hasOwnProperty(name)){if(undefined===numArguments||undefined!==Module[name].overloadTable&&undefined!==Module[name].overloadTable[numArguments]){throwBindingError(`Cannot register public name '${name}' twice`)}ensureOverloadTable(Module,name,name);if(Module.hasOwnProperty(numArguments)){throwBindingError(`Cannot register multiple overloads of a function with the same number of arguments (${numArguments})!`)}Module[name].overloadTable[numArguments]=value}else{Module[name]=value;if(undefined!==numArguments){Module[name].numArguments=numArguments}}};Module["exposePublicSymbol"]=exposePublicSymbol;var char_0=48;Module["char_0"]=char_0;var char_9=57;Module["char_9"]=char_9;var makeLegalFunctionName=name=>{if(undefined===name){return"_unknown"}name=name.replace(/[^a-zA-Z0-9_]/g,"$");var f=name.charCodeAt(0);if(f>=char_0&&f<=char_9){return`_${name}`}return name};Module["makeLegalFunctionName"]=makeLegalFunctionName;function RegisteredClass(name,constructor,instancePrototype,rawDestructor,baseClass,getActualType,upcast,downcast){this.name=name;this.constructor=constructor;this.instancePrototype=instancePrototype;this.rawDestructor=rawDestructor;this.baseClass=baseClass;this.getActualType=getActualType;this.upcast=upcast;this.downcast=downcast;this.pureVirtualFunctions=[]}Module["RegisteredClass"]=RegisteredClass;var upcastPointer=(ptr,ptrClass,desiredClass)=>{while(ptrClass!==desiredClass){if(!ptrClass.upcast){throwBindingError(`Expected null or instance of ${desiredClass.name}, got an instance of ${ptrClass.name}`)}ptr=ptrClass.upcast(ptr);ptrClass=ptrClass.baseClass}return ptr};Module["upcastPointer"]=upcastPointer;function constNoSmartPtrRawPointerToWireType(destructors,handle){if(handle===null){if(this.isReference){throwBindingError(`null is not a valid ${this.name}`)}return 0}if(!handle.$$){throwBindingError(`Cannot pass "${embindRepr(handle)}" as a ${this.name}`)}if(!handle.$$.ptr){throwBindingError(`Cannot pass deleted object as a pointer of type ${this.name}`)}var handleClass=handle.$$.ptrType.registeredClass;var ptr=upcastPointer(handle.$$.ptr,handleClass,this.registeredClass);return ptr}Module["constNoSmartPtrRawPointerToWireType"]=constNoSmartPtrRawPointerToWireType;function genericPointerToWireType(destructors,handle){var ptr;if(handle===null){if(this.isReference){throwBindingError(`null is not a valid ${this.name}`)}if(this.isSmartPointer){ptr=this.rawConstructor();if(destructors!==null){destructors.push(this.rawDestructor,ptr)}return ptr}else{return 0}}if(!handle||!handle.$$){throwBindingError(`Cannot pass "${embindRepr(handle)}" as a ${this.name}`)}if(!handle.$$.ptr){throwBindingError(`Cannot pass deleted object as a pointer of type ${this.name}`)}if(!this.isConst&&handle.$$.ptrType.isConst){throwBindingError(`Cannot convert argument of type ${handle.$$.smartPtrType?handle.$$.smartPtrType.name:handle.$$.ptrType.name} to parameter type ${this.name}`)}var handleClass=handle.$$.ptrType.registeredClass;ptr=upcastPointer(handle.$$.ptr,handleClass,this.registeredClass);if(this.isSmartPointer){if(undefined===handle.$$.smartPtr){throwBindingError("Passing raw pointer to smart pointer is illegal")}switch(this.sharingPolicy){case 0:if(handle.$$.smartPtrType===this){ptr=handle.$$.smartPtr}else{throwBindingError(`Cannot convert argument of type ${handle.$$.smartPtrType?handle.$$.smartPtrType.name:handle.$$.ptrType.name} to parameter type ${this.name}`)}break;case 1:ptr=handle.$$.smartPtr;break;case 2:if(handle.$$.smartPtrType===this){ptr=handle.$$.smartPtr}else{var clonedHandle=handle["clone"]();ptr=this.rawShare(ptr,Emval.toHandle(()=>clonedHandle["delete"]()));if(destructors!==null){destructors.push(this.rawDestructor,ptr)}}break;default:throwBindingError("Unsupporting sharing policy")}}return ptr}Module["genericPointerToWireType"]=genericPointerToWireType;function nonConstNoSmartPtrRawPointerToWireType(destructors,handle){if(handle===null){if(this.isReference){throwBindingError(`null is not a valid ${this.name}`)}return 0}if(!handle.$$){throwBindingError(`Cannot pass "${embindRepr(handle)}" as a ${this.name}`)}if(!handle.$$.ptr){throwBindingError(`Cannot pass deleted object as a pointer of type ${this.name}`)}if(handle.$$.ptrType.isConst){throwBindingError(`Cannot convert argument of type ${handle.$$.ptrType.name} to parameter type ${this.name}`)}var handleClass=handle.$$.ptrType.registeredClass;var ptr=upcastPointer(handle.$$.ptr,handleClass,this.registeredClass);return ptr}Module["nonConstNoSmartPtrRawPointerToWireType"]=nonConstNoSmartPtrRawPointerToWireType;function readPointer(pointer){return this["fromWireType"](HEAPU32[pointer>>2])}Module["readPointer"]=readPointer;var init_RegisteredPointer=()=>{Object.assign(RegisteredPointer.prototype,{getPointee(ptr){if(this.rawGetPointee){ptr=this.rawGetPointee(ptr)}return ptr},destructor(ptr){this.rawDestructor?.(ptr)},argPackAdvance:GenericWireTypeSize,readValueFromPointer:readPointer,fromWireType:RegisteredPointer_fromWireType})};Module["init_RegisteredPointer"]=init_RegisteredPointer;function RegisteredPointer(name,registeredClass,isReference,isConst,isSmartPointer,pointeeType,sharingPolicy,rawGetPointee,rawConstructor,rawShare,rawDestructor){this.name=name;this.registeredClass=registeredClass;this.isReference=isReference;this.isConst=isConst;this.isSmartPointer=isSmartPointer;this.pointeeType=pointeeType;this.sharingPolicy=sharingPolicy;this.rawGetPointee=rawGetPointee;this.rawConstructor=rawConstructor;this.rawShare=rawShare;this.rawDestructor=rawDestructor;if(!isSmartPointer&&registeredClass.baseClass===undefined){if(isConst){this["toWireType"]=constNoSmartPtrRawPointerToWireType;this.destructorFunction=null}else{this["toWireType"]=nonConstNoSmartPtrRawPointerToWireType;this.destructorFunction=null}}else{this["toWireType"]=genericPointerToWireType}}Module["RegisteredPointer"]=RegisteredPointer;var replacePublicSymbol=(name,value,numArguments)=>{if(!Module.hasOwnProperty(name)){throwInternalError("Replacing nonexistent public symbol")}if(undefined!==Module[name].overloadTable&&undefined!==numArguments){Module[name].overloadTable[numArguments]=value}else{Module[name]=value;Module[name].argCount=numArguments}};Module["replacePublicSymbol"]=replacePublicSymbol;var dynCallLegacy=(sig,ptr,args)=>{sig=sig.replace(/p/g,"i");var f=Module["dynCall_"+sig];return f(ptr,...args)};Module["dynCallLegacy"]=dynCallLegacy;var wasmTableMirror=[];Module["wasmTableMirror"]=wasmTableMirror;var wasmTable;Module["wasmTable"]=wasmTable;var getWasmTableEntry=funcPtr=>{var func=wasmTableMirror[funcPtr];if(!func){if(funcPtr>=wasmTableMirror.length)wasmTableMirror.length=funcPtr+1;wasmTableMirror[funcPtr]=func=wasmTable.get(funcPtr)}return func};Module["getWasmTableEntry"]=getWasmTableEntry;var dynCall=(sig,ptr,args=[])=>{if(sig.includes("j")){return dynCallLegacy(sig,ptr,args)}var rtn=getWasmTableEntry(ptr)(...args);return rtn};Module["dynCall"]=dynCall;var getDynCaller=(sig,ptr)=>(...args)=>dynCall(sig,ptr,args);Module["getDynCaller"]=getDynCaller;var embind__requireFunction=(signature,rawFunction)=>{signature=readLatin1String(signature);function makeDynCaller(){if(signature.includes("j")){return getDynCaller(signature,rawFunction)}return getWasmTableEntry(rawFunction)}var fp=makeDynCaller();if(typeof fp!="function"){throwBindingError(`unknown function pointer with signature ${signature}: ${rawFunction}`)}return fp};Module["embind__requireFunction"]=embind__requireFunction;var extendError=(baseErrorType,errorName)=>{var errorClass=createNamedFunction(errorName,function(message){this.name=errorName;this.message=message;var stack=new Error(message).stack;if(stack!==undefined){this.stack=this.toString()+"\n"+stack.replace(/^Error(:[^\n]*)?\n/,"")}});errorClass.prototype=Object.create(baseErrorType.prototype);errorClass.prototype.constructor=errorClass;errorClass.prototype.toString=function(){if(this.message===undefined){return this.name}else{return`${this.name}: ${this.message}`}};return errorClass};Module["extendError"]=extendError;var UnboundTypeError;Module["UnboundTypeError"]=UnboundTypeError;var getTypeName=type=>{var ptr=___getTypeName(type);var rv=readLatin1String(ptr);_free(ptr);return rv};Module["getTypeName"]=getTypeName;var throwUnboundTypeError=(message,types)=>{var unboundTypes=[];var seen={};function visit(type){if(seen[type]){return}if(registeredTypes[type]){return}if(typeDependencies[type]){typeDependencies[type].forEach(visit);return}unboundTypes.push(type);seen[type]=true}types.forEach(visit);throw new UnboundTypeError(`${message}: `+unboundTypes.map(getTypeName).join([", "]))};Module["throwUnboundTypeError"]=throwUnboundTypeError;var __embind_register_class=(rawType,rawPointerType,rawConstPointerType,baseClassRawType,getActualTypeSignature,getActualType,upcastSignature,upcast,downcastSignature,downcast,name,destructorSignature,rawDestructor)=>{name=readLatin1String(name);getActualType=embind__requireFunction(getActualTypeSignature,getActualType);upcast&&=embind__requireFunction(upcastSignature,upcast);downcast&&=embind__requireFunction(downcastSignature,downcast);rawDestructor=embind__requireFunction(destructorSignature,rawDestructor);var legalFunctionName=makeLegalFunctionName(name);exposePublicSymbol(legalFunctionName,function(){throwUnboundTypeError(`Cannot construct ${name} due to unbound types`,[baseClassRawType])});whenDependentTypesAreResolved([rawType,rawPointerType,rawConstPointerType],baseClassRawType?[baseClassRawType]:[],base=>{base=base[0];var baseClass;var basePrototype;if(baseClassRawType){baseClass=base.registeredClass;basePrototype=baseClass.instancePrototype}else{basePrototype=ClassHandle.prototype}var constructor=createNamedFunction(name,function(...args){if(Object.getPrototypeOf(this)!==instancePrototype){throw new BindingError("Use 'new' to construct "+name)}if(undefined===registeredClass.constructor_body){throw new BindingError(name+" has no accessible constructor")}var body=registeredClass.constructor_body[args.length];if(undefined===body){throw new BindingError(`Tried to invoke ctor of ${name} with invalid number of parameters (${args.length}) - expected (${Object.keys(registeredClass.constructor_body).toString()}) parameters instead!`)}return body.apply(this,args)});var instancePrototype=Object.create(basePrototype,{constructor:{value:constructor}});constructor.prototype=instancePrototype;var registeredClass=new RegisteredClass(name,constructor,instancePrototype,rawDestructor,baseClass,getActualType,upcast,downcast);if(registeredClass.baseClass){registeredClass.baseClass.__derivedClasses??=[];registeredClass.baseClass.__derivedClasses.push(registeredClass)}var referenceConverter=new RegisteredPointer(name,registeredClass,true,false,false);var pointerConverter=new RegisteredPointer(name+"*",registeredClass,false,false,false);var constPointerConverter=new RegisteredPointer(name+" const*",registeredClass,false,true,false);registeredPointers[rawType]={pointerType:pointerConverter,constPointerType:constPointerConverter};replacePublicSymbol(legalFunctionName,constructor);return[referenceConverter,pointerConverter,constPointerConverter]})};Module["__embind_register_class"]=__embind_register_class;var heap32VectorToArray=(count,firstElement)=>{var array=[];for(var i=0;i<count;i++){array.push(HEAPU32[firstElement+i*4>>2])}return array};Module["heap32VectorToArray"]=heap32VectorToArray;var runDestructors=destructors=>{while(destructors.length){var ptr=destructors.pop();var del=destructors.pop();del(ptr)}};Module["runDestructors"]=runDestructors;function usesDestructorStack(argTypes){for(var i=1;i<argTypes.length;++i){if(argTypes[i]!==null&&argTypes[i].destructorFunction===undefined){return true}}return false}Module["usesDestructorStack"]=usesDestructorStack;var InvokerFunctions={ftftnt:function(humanName,throwBindingError,invoker,fn,runDestructors,retType,classParam,argType0,argType1,argType2,arg0Wired_dtor,arg2Wired_dtor){return function(arg0,arg1,arg2){if(arguments.length!==3){throwBindingError("function "+humanName+" called with "+arguments.length+" arguments, expected 3")}var arg0Wired=argType0["toWireType"](null,arg0);var arg1Wired=argType1["toWireType"](null,arg1);var arg2Wired=argType2["toWireType"](null,arg2);var rv=invoker(fn,arg0Wired,arg1Wired,arg2Wired);arg0Wired_dtor(arg0Wired);arg2Wired_dtor(arg2Wired);var ret=retType["fromWireType"](rv);return ret}},tffn:function(humanName,throwBindingError,invoker,fn,runDestructors,retType,classParam){return function(){if(arguments.length!==0){throwBindingError("function "+humanName+" called with "+arguments.length+" arguments, expected 0")}var thisWired=classParam["toWireType"](null,this);invoker(fn,thisWired)}},ttfn:function(humanName,throwBindingError,invoker,fn,runDestructors,retType,classParam){return function(){if(arguments.length!==0){throwBindingError("function "+humanName+" called with "+arguments.length+" arguments, expected 0")}var thisWired=classParam["toWireType"](null,this);var rv=invoker(fn,thisWired);var ret=retType["fromWireType"](rv);return ret}},ttfnnnnnn:function(humanName,throwBindingError,invoker,fn,runDestructors,retType,classParam,argType0,argType1,argType2,argType3,argType4){return function(arg0,arg1,arg2,arg3,arg4){if(arguments.length!==5){throwBindingError("function "+humanName+" called with "+arguments.length+" arguments, expected 5")}var thisWired=classParam["toWireType"](null,this);var arg0Wired=argType0["toWireType"](null,arg0);var arg1Wired=argType1["toWireType"](null,arg1);var arg2Wired=argType2["toWireType"](null,arg2);var arg3Wired=argType3["toWireType"](null,arg3);var arg4Wired=argType4["toWireType"](null,arg4);var rv=invoker(fn,thisWired,arg0Wired,arg1Wired,arg2Wired,arg3Wired,arg4Wired);var ret=retType["fromWireType"](rv);return ret}},ttfnnnn:function(humanName,throwBindingError,invoker,fn,runDestructors,retType,classParam,argType0,argType1,argType2){return function(arg0,arg1,arg2){if(arguments.length!==3){throwBindingError("function "+humanName+" called with "+arguments.length+" arguments, expected 3")}var thisWired=classParam["toWireType"](null,this);var arg0Wired=argType0["toWireType"](null,arg0);var arg1Wired=argType1["toWireType"](null,arg1);var arg2Wired=argType2["toWireType"](null,arg2);var rv=invoker(fn,thisWired,arg0Wired,arg1Wired,arg2Wired);var ret=retType["fromWireType"](rv);return ret}},ttfnt:function(humanName,throwBindingError,invoker,fn,runDestructors,retType,classParam,argType0,arg0Wired_dtor){return function(arg0){if(arguments.length!==1){throwBindingError("function "+humanName+" called with "+arguments.length+" arguments, expected 1")}var thisWired=classParam["toWireType"](null,this);var arg0Wired=argType0["toWireType"](null,arg0);var rv=invoker(fn,thisWired,arg0Wired);arg0Wired_dtor(arg0Wired);var ret=retType["fromWireType"](rv);return ret}},ttfnnnnnnn:function(humanName,throwBindingError,invoker,fn,runDestructors,retType,classParam,argType0,argType1,argType2,argType3,argType4,argType5){return function(arg0,arg1,arg2,arg3,arg4,arg5){if(arguments.length!==6){throwBindingError("function "+humanName+" called with "+arguments.length+" arguments, expected 6")}var thisWired=classParam["toWireType"](null,this);var arg0Wired=argType0["toWireType"](null,arg0);var arg1Wired=argType1["toWireType"](null,arg1);var arg2Wired=argType2["toWireType"](null,arg2);var arg3Wired=argType3["toWireType"](null,arg3);var arg4Wired=argType4["toWireType"](null,arg4);var arg5Wired=argType5["toWireType"](null,arg5);var rv=invoker(fn,thisWired,arg0Wired,arg1Wired,arg2Wired,arg3Wired,arg4Wired,arg5Wired);var ret=retType["fromWireType"](rv);return ret}},ttfnntn:function(humanName,throwBindingError,invoker,fn,runDestructors,retType,classParam,argType0,argType1,argType2,arg1Wired_dtor){return function(arg0,arg1,arg2){if(arguments.length!==3){throwBindingError("function "+humanName+" called with "+arguments.length+" arguments, expected 3")}var thisWired=classParam["toWireType"](null,this);var arg0Wired=argType0["toWireType"](null,arg0);var arg1Wired=argType1["toWireType"](null,arg1);var arg2Wired=argType2["toWireType"](null,arg2);var rv=invoker(fn,thisWired,arg0Wired,arg1Wired,arg2Wired);arg1Wired_dtor(arg1Wired);var ret=retType["fromWireType"](rv);return ret}},ttfnnn:function(humanName,throwBindingError,invoker,fn,runDestructors,retType,classParam,argType0,argType1){return function(arg0,arg1){if(arguments.length!==2){throwBindingError("function "+humanName+" called with "+arguments.length+" arguments, expected 2")}var thisWired=classParam["toWireType"](null,this);var arg0Wired=argType0["toWireType"](null,arg0);var arg1Wired=argType1["toWireType"](null,arg1);var rv=invoker(fn,thisWired,arg0Wired,arg1Wired);var ret=retType["fromWireType"](rv);return ret}},ttfnnnnnnnnnnn:function(humanName,throwBindingError,invoker,fn,runDestructors,retType,classParam,argType0,argType1,argType2,argType3,argType4,argType5,argType6,argType7,argType8,argType9){return function(arg0,arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9){if(arguments.length!==10){throwBindingError("function "+humanName+" called with "+arguments.length+" arguments, expected 10")}var thisWired=classParam["toWireType"](null,this);var arg0Wired=argType0["toWireType"](null,arg0);var arg1Wired=argType1["toWireType"](null,arg1);var arg2Wired=argType2["toWireType"](null,arg2);var arg3Wired=argType3["toWireType"](null,arg3);var arg4Wired=argType4["toWireType"](null,arg4);var arg5Wired=argType5["toWireType"](null,arg5);var arg6Wired=argType6["toWireType"](null,arg6);var arg7Wired=argType7["toWireType"](null,arg7);var arg8Wired=argType8["toWireType"](null,arg8);var arg9Wired=argType9["toWireType"](null,arg9);var rv=invoker(fn,thisWired,arg0Wired,arg1Wired,arg2Wired,arg3Wired,arg4Wired,arg5Wired,arg6Wired,arg7Wired,arg8Wired,arg9Wired);var ret=retType["fromWireType"](rv);return ret}},tffnnntn:function(humanName,throwBindingError,invoker,fn,runDestructors,retType,classParam,argType0,argType1,argType2,argType3,arg2Wired_dtor){return function(arg0,arg1,arg2,arg3){if(arguments.length!==4){throwBindingError("function "+humanName+" called with "+arguments.length+" arguments, expected 4")}var thisWired=classParam["toWireType"](null,this);var arg0Wired=argType0["toWireType"](null,arg0);var arg1Wired=argType1["toWireType"](null,arg1);var arg2Wired=argType2["toWireType"](null,arg2);var arg3Wired=argType3["toWireType"](null,arg3);invoker(fn,thisWired,arg0Wired,arg1Wired,arg2Wired,arg3Wired);arg2Wired_dtor(arg2Wired)}},tffntnt:function(humanName,throwBindingError,invoker,fn,runDestructors,retType,classParam,argType0,argType1,argType2,arg0Wired_dtor,arg2Wired_dtor){return function(arg0,arg1,arg2){if(arguments.length!==3){throwBindingError("function "+humanName+" called with "+arguments.length+" arguments, expected 3")}var thisWired=classParam["toWireType"](null,this);var arg0Wired=argType0["toWireType"](null,arg0);var arg1Wired=argType1["toWireType"](null,arg1);var arg2Wired=argType2["toWireType"](null,arg2);invoker(fn,thisWired,arg0Wired,arg1Wired,arg2Wired);arg0Wired_dtor(arg0Wired);arg2Wired_dtor(arg2Wired)}},ttfnn:function(humanName,throwBindingError,invoker,fn,runDestructors,retType,classParam,argType0){return function(arg0){if(arguments.length!==1){throwBindingError("function "+humanName+" called with "+arguments.length+" arguments, expected 1")}var thisWired=classParam["toWireType"](null,this);var arg0Wired=argType0["toWireType"](null,arg0);var rv=invoker(fn,thisWired,arg0Wired);var ret=retType["fromWireType"](rv);return ret}},ftf:function(humanName,throwBindingError,invoker,fn,runDestructors,retType,classParam){return function(){if(arguments.length!==0){throwBindingError("function "+humanName+" called with "+arguments.length+" arguments, expected 0")}var rv=invoker(fn);var ret=retType["fromWireType"](rv);return ret}},tffnn:function(humanName,throwBindingError,invoker,fn,runDestructors,retType,classParam,argType0){return function(arg0){if(arguments.length!==1){throwBindingError("function "+humanName+" called with "+arguments.length+" arguments, expected 1")}var thisWired=classParam["toWireType"](null,this);var arg0Wired=argType0["toWireType"](null,arg0);invoker(fn,thisWired,arg0Wired)}},tffnnn:function(humanName,throwBindingError,invoker,fn,runDestructors,retType,classParam,argType0,argType1){return function(arg0,arg1){if(arguments.length!==2){throwBindingError("function "+humanName+" called with "+arguments.length+" arguments, expected 2")}var thisWired=classParam["toWireType"](null,this);var arg0Wired=argType0["toWireType"](null,arg0);var arg1Wired=argType1["toWireType"](null,arg1);invoker(fn,thisWired,arg0Wired,arg1Wired)}},ttfnnnnn:function(humanName,throwBindingError,invoker,fn,runDestructors,retType,classParam,argType0,argType1,argType2,argType3){return function(arg0,arg1,arg2,arg3){if(arguments.length!==4){throwBindingError("function "+humanName+" called with "+arguments.length+" arguments, expected 4")}var thisWired=classParam["toWireType"](null,this);var arg0Wired=argType0["toWireType"](null,arg0);var arg1Wired=argType1["toWireType"](null,arg1);var arg2Wired=argType2["toWireType"](null,arg2);var arg3Wired=argType3["toWireType"](null,arg3);var rv=invoker(fn,thisWired,arg0Wired,arg1Wired,arg2Wired,arg3Wired);var ret=retType["fromWireType"](rv);return ret}},ttfnnnt:function(humanName,throwBindingError,invoker,fn,runDestructors,retType,classParam,argType0,argType1,argType2,arg2Wired_dtor){return function(arg0,arg1,arg2){if(arguments.length!==3){throwBindingError("function "+humanName+" called with "+arguments.length+" arguments, expected 3")}var thisWired=classParam["toWireType"](null,this);var arg0Wired=argType0["toWireType"](null,arg0);var arg1Wired=argType1["toWireType"](null,arg1);var arg2Wired=argType2["toWireType"](null,arg2);var rv=invoker(fn,thisWired,arg0Wired,arg1Wired,arg2Wired);arg2Wired_dtor(arg2Wired);var ret=retType["fromWireType"](rv);return ret}},ttfnntnnn:function(humanName,throwBindingError,invoker,fn,runDestructors,retType,classParam,argType0,argType1,argType2,argType3,argType4,arg1Wired_dtor){return function(arg0,arg1,arg2,arg3,arg4){if(arguments.length!==5){throwBindingError("function "+humanName+" called with "+arguments.length+" arguments, expected 5")}var thisWired=classParam["toWireType"](null,this);var arg0Wired=argType0["toWireType"](null,arg0);var arg1Wired=argType1["toWireType"](null,arg1);var arg2Wired=argType2["toWireType"](null,arg2);var arg3Wired=argType3["toWireType"](null,arg3);var arg4Wired=argType4["toWireType"](null,arg4);var rv=invoker(fn,thisWired,arg0Wired,arg1Wired,arg2Wired,arg3Wired,arg4Wired);arg1Wired_dtor(arg1Wired);var ret=retType["fromWireType"](rv);return ret}},ttfnntnnnnn:function(humanName,throwBindingError,invoker,fn,runDestructors,retType,classParam,argType0,argType1,argType2,argType3,argType4,argType5,argType6,arg1Wired_dtor){return function(arg0,arg1,arg2,arg3,arg4,arg5,arg6){if(arguments.length!==7){throwBindingError("function "+humanName+" called with "+arguments.length+" arguments, expected 7")}var thisWired=classParam["toWireType"](null,this);var arg0Wired=argType0["toWireType"](null,arg0);var arg1Wired=argType1["toWireType"](null,arg1);var arg2Wired=argType2["toWireType"](null,arg2);var arg3Wired=argType3["toWireType"](null,arg3);var arg4Wired=argType4["toWireType"](null,arg4);var arg5Wired=argType5["toWireType"](null,arg5);var arg6Wired=argType6["toWireType"](null,arg6);var rv=invoker(fn,thisWired,arg0Wired,arg1Wired,arg2Wired,arg3Wired,arg4Wired,arg5Wired,arg6Wired);arg1Wired_dtor(arg1Wired);var ret=retType["fromWireType"](rv);return ret}},ttfnnt:function(humanName,throwBindingError,invoker,fn,runDestructors,retType,classParam,argType0,argType1,arg1Wired_dtor){return function(arg0,arg1){if(arguments.length!==2){throwBindingError("function "+humanName+" called with "+arguments.length+" arguments, expected 2")}var thisWired=classParam["toWireType"](null,this);var arg0Wired=argType0["toWireType"](null,arg0);var arg1Wired=argType1["toWireType"](null,arg1);var rv=invoker(fn,thisWired,arg0Wired,arg1Wired);arg1Wired_dtor(arg1Wired);var ret=retType["fromWireType"](rv);return ret}},ttfnnnntnn:function(humanName,throwBindingError,invoker,fn,runDestructors,retType,classParam,argType0,argType1,argType2,argType3,argType4,argType5,arg3Wired_dtor){return function(arg0,arg1,arg2,arg3,arg4,arg5){if(arguments.length!==6){throwBindingError("function "+humanName+" called with "+arguments.length+" arguments, expected 6")}var thisWired=classParam["toWireType"](null,this);var arg0Wired=argType0["toWireType"](null,arg0);var arg1Wired=argType1["toWireType"](null,arg1);var arg2Wired=argType2["toWireType"](null,arg2);var arg3Wired=argType3["toWireType"](null,arg3);var arg4Wired=argType4["toWireType"](null,arg4);var arg5Wired=argType5["toWireType"](null,arg5);var rv=invoker(fn,thisWired,arg0Wired,arg1Wired,arg2Wired,arg3Wired,arg4Wired,arg5Wired);arg3Wired_dtor(arg3Wired);var ret=retType["fromWireType"](rv);return ret}},ttfnnntnnn:function(humanName,throwBindingError,invoker,fn,runDestructors,retType,classParam,argType0,argType1,argType2,argType3,argType4,argType5,arg2Wired_dtor){return function(arg0,arg1,arg2,arg3,arg4,arg5){if(arguments.length!==6){throwBindingError("function "+humanName+" called with "+arguments.length+" arguments, expected 6")}var thisWired=classParam["toWireType"](null,this);var arg0Wired=argType0["toWireType"](null,arg0);var arg1Wired=argType1["toWireType"](null,arg1);var arg2Wired=argType2["toWireType"](null,arg2);var arg3Wired=argType3["toWireType"](null,arg3);var arg4Wired=argType4["toWireType"](null,arg4);var arg5Wired=argType5["toWireType"](null,arg5);var rv=invoker(fn,thisWired,arg0Wired,arg1Wired,arg2Wired,arg3Wired,arg4Wired,arg5Wired);arg2Wired_dtor(arg2Wired);var ret=retType["fromWireType"](rv);return ret}},ttfntnnnn:function(humanName,throwBindingError,invoker,fn,runDestructors,retType,classParam,argType0,argType1,argType2,argType3,argType4,arg0Wired_dtor){return function(arg0,arg1,arg2,arg3,arg4){if(arguments.length!==5){throwBindingError("function "+humanName+" called with "+arguments.length+" arguments, expected 5")}var thisWired=classParam["toWireType"](null,this);var arg0Wired=argType0["toWireType"](null,arg0);var arg1Wired=argType1["toWireType"](null,arg1);var arg2Wired=argType2["toWireType"](null,arg2);var arg3Wired=argType3["toWireType"](null,arg3);var arg4Wired=argType4["toWireType"](null,arg4);var rv=invoker(fn,thisWired,arg0Wired,arg1Wired,arg2Wired,arg3Wired,arg4Wired);arg0Wired_dtor(arg0Wired);var ret=retType["fromWireType"](rv);return ret}}};Module["InvokerFunctions"]=InvokerFunctions;function createJsInvokerSignature(argTypes,isClassMethodFunc,returns,isAsync){const signature=[isClassMethodFunc?"t":"f",returns?"t":"f",isAsync?"t":"f"];for(let i=isClassMethodFunc?1:2;i<argTypes.length;++i){const arg=argTypes[i];let destructorSig="";if(arg.destructorFunction===undefined){destructorSig="u"}else if(arg.destructorFunction===null){destructorSig="n"}else{destructorSig="t"}signature.push(destructorSig)}return signature.join("")}Module["createJsInvokerSignature"]=createJsInvokerSignature;function craftInvokerFunction(humanName,argTypes,classType,cppInvokerFunc,cppTargetFunc,isAsync){var argCount=argTypes.length;if(argCount<2){throwBindingError("argTypes array size mismatch! Must at least get return value and 'this' types!")}var isClassMethodFunc=argTypes[1]!==null&&classType!==null;var needsDestructorStack=usesDestructorStack(argTypes);var returns=argTypes[0].name!=="void";var closureArgs=[humanName,throwBindingError,cppInvokerFunc,cppTargetFunc,runDestructors,argTypes[0],argTypes[1]];for(var i=0;i<argCount-2;++i){closureArgs.push(argTypes[i+2])}if(!needsDestructorStack){for(var i=isClassMethodFunc?1:2;i<argTypes.length;++i){if(argTypes[i].destructorFunction!==null){closureArgs.push(argTypes[i].destructorFunction)}}}var signature=createJsInvokerSignature(argTypes,isClassMethodFunc,returns,isAsync);var invokerFn=InvokerFunctions[signature](...closureArgs);return createNamedFunction(humanName,invokerFn)}Module["craftInvokerFunction"]=craftInvokerFunction;var __embind_register_class_constructor=(rawClassType,argCount,rawArgTypesAddr,invokerSignature,invoker,rawConstructor)=>{var rawArgTypes=heap32VectorToArray(argCount,rawArgTypesAddr);invoker=embind__requireFunction(invokerSignature,invoker);whenDependentTypesAreResolved([],[rawClassType],classType=>{classType=classType[0];var humanName=`constructor ${classType.name}`;if(undefined===classType.registeredClass.constructor_body){classType.registeredClass.constructor_body=[]}if(undefined!==classType.registeredClass.constructor_body[argCount-1]){throw new BindingError(`Cannot register multiple constructors with identical number of parameters (${argCount-1}) for class '${classType.name}'! Overload resolution is currently only performed using the parameter count, not actual type info!`)}classType.registeredClass.constructor_body[argCount-1]=()=>{throwUnboundTypeError(`Cannot construct ${classType.name} due to unbound types`,rawArgTypes)};whenDependentTypesAreResolved([],rawArgTypes,argTypes=>{argTypes.splice(1,0,null);classType.registeredClass.constructor_body[argCount-1]=craftInvokerFunction(humanName,argTypes,null,invoker,rawConstructor);return[]});return[]})};Module["__embind_register_class_constructor"]=__embind_register_class_constructor;var getFunctionName=signature=>{signature=signature.trim();const argsIndex=signature.indexOf("(");if(argsIndex!==-1){return signature.substr(0,argsIndex)}else{return signature}};Module["getFunctionName"]=getFunctionName;var __embind_register_class_function=(rawClassType,methodName,argCount,rawArgTypesAddr,invokerSignature,rawInvoker,context,isPureVirtual,isAsync)=>{var rawArgTypes=heap32VectorToArray(argCount,rawArgTypesAddr);methodName=readLatin1String(methodName);methodName=getFunctionName(methodName);rawInvoker=embind__requireFunction(invokerSignature,rawInvoker);whenDependentTypesAreResolved([],[rawClassType],classType=>{classType=classType[0];var humanName=`${classType.name}.${methodName}`;if(methodName.startsWith("@@")){methodName=Symbol[methodName.substring(2)]}if(isPureVirtual){classType.registeredClass.pureVirtualFunctions.push(methodName)}function unboundTypesHandler(){throwUnboundTypeError(`Cannot call ${humanName} due to unbound types`,rawArgTypes)}var proto=classType.registeredClass.instancePrototype;var method=proto[methodName];if(undefined===method||undefined===method.overloadTable&&method.className!==classType.name&&method.argCount===argCount-2){unboundTypesHandler.argCount=argCount-2;unboundTypesHandler.className=classType.name;proto[methodName]=unboundTypesHandler}else{ensureOverloadTable(proto,methodName,humanName);proto[methodName].overloadTable[argCount-2]=unboundTypesHandler}whenDependentTypesAreResolved([],rawArgTypes,argTypes=>{var memberFunction=craftInvokerFunction(humanName,argTypes,classType,rawInvoker,context,isAsync);if(undefined===proto[methodName].overloadTable){memberFunction.argCount=argCount-2;proto[methodName]=memberFunction}else{proto[methodName].overloadTable[argCount-2]=memberFunction}return[]});return[]})};Module["__embind_register_class_function"]=__embind_register_class_function;var emval_freelist=[];Module["emval_freelist"]=emval_freelist;var emval_handles=[];Module["emval_handles"]=emval_handles;var __emval_decref=handle=>{if(handle>9&&0===--emval_handles[handle+1]){emval_handles[handle]=undefined;emval_freelist.push(handle)}};Module["__emval_decref"]=__emval_decref;var count_emval_handles=()=>emval_handles.length/2-5-emval_freelist.length;Module["count_emval_handles"]=count_emval_handles;var init_emval=()=>{emval_handles.push(0,1,undefined,1,null,1,true,1,false,1);Module["count_emval_handles"]=count_emval_handles};Module["init_emval"]=init_emval;var Emval={toValue:handle=>{if(!handle){throwBindingError("Cannot use deleted val. handle = "+handle)}return emval_handles[handle]},toHandle:value=>{switch(value){case undefined:return 2;case null:return 4;case true:return 6;case false:return 8;default:{const handle=emval_freelist.pop()||emval_handles.length;emval_handles[handle]=value;emval_handles[handle+1]=1;return handle}}}};Module["Emval"]=Emval;var EmValType={name:"emscripten::val",fromWireType:handle=>{var rv=Emval.toValue(handle);__emval_decref(handle);return rv},toWireType:(destructors,value)=>Emval.toHandle(value),argPackAdvance:GenericWireTypeSize,readValueFromPointer:readPointer,destructorFunction:null};Module["EmValType"]=EmValType;var __embind_register_emval=rawType=>registerType(rawType,EmValType);Module["__embind_register_emval"]=__embind_register_emval;var embindRepr=v=>{if(v===null){return"null"}var t=typeof v;if(t==="object"||t==="array"||t==="function"){return v.toString()}else{return""+v}};Module["embindRepr"]=embindRepr;var floatReadValueFromPointer=(name,width)=>{switch(width){case 4:return function(pointer){return this["fromWireType"](HEAPF32[pointer>>2])};case 8:return function(pointer){return this["fromWireType"](HEAPF64[pointer>>3])};default:throw new TypeError(`invalid float width (${width}): ${name}`)}};Module["floatReadValueFromPointer"]=floatReadValueFromPointer;var __embind_register_float=(rawType,name,size)=>{name=readLatin1String(name);registerType(rawType,{name:name,fromWireType:value=>value,toWireType:(destructors,value)=>value,argPackAdvance:GenericWireTypeSize,readValueFromPointer:floatReadValueFromPointer(name,size),destructorFunction:null})};Module["__embind_register_float"]=__embind_register_float;var integerReadValueFromPointer=(name,width,signed)=>{switch(width){case 1:return signed?pointer=>HEAP8[pointer]:pointer=>HEAPU8[pointer];case 2:return signed?pointer=>HEAP16[pointer>>1]:pointer=>HEAPU16[pointer>>1];case 4:return signed?pointer=>HEAP32[pointer>>2]:pointer=>HEAPU32[pointer>>2];default:throw new TypeError(`invalid integer width (${width}): ${name}`)}};Module["integerReadValueFromPointer"]=integerReadValueFromPointer;var __embind_register_integer=(primitiveType,name,size,minRange,maxRange)=>{name=readLatin1String(name);if(maxRange===-1){maxRange=4294967295}var fromWireType=value=>value;if(minRange===0){var bitshift=32-8*size;fromWireType=value=>value<<bitshift>>>bitshift}var isUnsignedType=name.includes("unsigned");var checkAssertions=(value,toTypeName)=>{};var toWireType;if(isUnsignedType){toWireType=function(destructors,value){checkAssertions(value,this.name);return value>>>0}}else{toWireType=function(destructors,value){checkAssertions(value,this.name);return value}}registerType(primitiveType,{name:name,fromWireType:fromWireType,toWireType:toWireType,argPackAdvance:GenericWireTypeSize,readValueFromPointer:integerReadValueFromPointer(name,size,minRange!==0),destructorFunction:null})};Module["__embind_register_integer"]=__embind_register_integer;var __embind_register_memory_view=(rawType,dataTypeIndex,name)=>{var typeMapping=[Int8Array,Uint8Array,Int16Array,Uint16Array,Int32Array,Uint32Array,Float32Array,Float64Array];var TA=typeMapping[dataTypeIndex];function decodeMemoryView(handle){var size=HEAPU32[handle>>2];var data=HEAPU32[handle+4>>2];return new TA(HEAP8.buffer,data,size)}name=readLatin1String(name);registerType(rawType,{name:name,fromWireType:decodeMemoryView,argPackAdvance:GenericWireTypeSize,readValueFromPointer:decodeMemoryView},{ignoreDuplicateRegistrations:true})};Module["__embind_register_memory_view"]=__embind_register_memory_view;var __embind_register_optional=(rawOptionalType,rawType)=>{__embind_register_emval(rawOptionalType)};Module["__embind_register_optional"]=__embind_register_optional;var __embind_register_std_string=(rawType,name)=>{name=readLatin1String(name);var stdStringIsUTF8=name==="std::string";registerType(rawType,{name:name,fromWireType(value){var length=HEAPU32[value>>2];var payload=value+4;var str;if(stdStringIsUTF8){var decodeStartPtr=payload;for(var i=0;i<=length;++i){var currentBytePtr=payload+i;if(i==length||HEAPU8[currentBytePtr]==0){var maxRead=currentBytePtr-decodeStartPtr;var stringSegment=UTF8ToString(decodeStartPtr,maxRead);if(str===undefined){str=stringSegment}else{str+=String.fromCharCode(0);str+=stringSegment}decodeStartPtr=currentBytePtr+1}}}else{var a=new Array(length);for(var i=0;i<length;++i){a[i]=String.fromCharCode(HEAPU8[payload+i])}str=a.join("")}_free(value);return str},toWireType(destructors,value){if(value instanceof ArrayBuffer){value=new Uint8Array(value)}var length;var valueIsOfTypeString=typeof value=="string";if(!(valueIsOfTypeString||value instanceof Uint8Array||value instanceof Uint8ClampedArray||value instanceof Int8Array)){throwBindingError("Cannot pass non-string to std::string")}if(stdStringIsUTF8&&valueIsOfTypeString){length=lengthBytesUTF8(value)}else{length=value.length}var base=_malloc(4+length+1);var ptr=base+4;HEAPU32[base>>2]=length;if(stdStringIsUTF8&&valueIsOfTypeString){stringToUTF8(value,ptr,length+1)}else{if(valueIsOfTypeString){for(var i=0;i<length;++i){var charCode=value.charCodeAt(i);if(charCode>255){_free(ptr);throwBindingError("String has UTF-16 code units that do not fit in 8 bits")}HEAPU8[ptr+i]=charCode}}else{for(var i=0;i<length;++i){HEAPU8[ptr+i]=value[i]}}}if(destructors!==null){destructors.push(_free,base)}return base},argPackAdvance:GenericWireTypeSize,readValueFromPointer:readPointer,destructorFunction(ptr){_free(ptr)}})};Module["__embind_register_std_string"]=__embind_register_std_string;var UTF16Decoder=typeof TextDecoder!="undefined"?new TextDecoder("utf-16le"):undefined;Module["UTF16Decoder"]=UTF16Decoder;var UTF16ToString=(ptr,maxBytesToRead)=>{var endPtr=ptr;var idx=endPtr>>1;var maxIdx=idx+maxBytesToRead/2;while(!(idx>=maxIdx)&&HEAPU16[idx])++idx;endPtr=idx<<1;if(endPtr-ptr>32&&UTF16Decoder)return UTF16Decoder.decode(HEAPU8.subarray(ptr,endPtr));var str="";for(var i=0;!(i>=maxBytesToRead/2);++i){var codeUnit=HEAP16[ptr+i*2>>1];if(codeUnit==0)break;str+=String.fromCharCode(codeUnit)}return str};Module["UTF16ToString"]=UTF16ToString;var stringToUTF16=(str,outPtr,maxBytesToWrite)=>{maxBytesToWrite??=2147483647;if(maxBytesToWrite<2)return 0;maxBytesToWrite-=2;var startPtr=outPtr;var numCharsToWrite=maxBytesToWrite<str.length*2?maxBytesToWrite/2:str.length;for(var i=0;i<numCharsToWrite;++i){var codeUnit=str.charCodeAt(i);HEAP16[outPtr>>1]=codeUnit;outPtr+=2}HEAP16[outPtr>>1]=0;return outPtr-startPtr};Module["stringToUTF16"]=stringToUTF16;var lengthBytesUTF16=str=>str.length*2;Module["lengthBytesUTF16"]=lengthBytesUTF16;var UTF32ToString=(ptr,maxBytesToRead)=>{var i=0;var str="";while(!(i>=maxBytesToRead/4)){var utf32=HEAP32[ptr+i*4>>2];if(utf32==0)break;++i;if(utf32>=65536){var ch=utf32-65536;str+=String.fromCharCode(55296|ch>>10,56320|ch&1023)}else{str+=String.fromCharCode(utf32)}}return str};Module["UTF32ToString"]=UTF32ToString;var stringToUTF32=(str,outPtr,maxBytesToWrite)=>{maxBytesToWrite??=2147483647;if(maxBytesToWrite<4)return 0;var startPtr=outPtr;var endPtr=startPtr+maxBytesToWrite-4;for(var i=0;i<str.length;++i){var codeUnit=str.charCodeAt(i);if(codeUnit>=55296&&codeUnit<=57343){var trailSurrogate=str.charCodeAt(++i);codeUnit=65536+((codeUnit&1023)<<10)|trailSurrogate&1023}HEAP32[outPtr>>2]=codeUnit;outPtr+=4;if(outPtr+4>endPtr)break}HEAP32[outPtr>>2]=0;return outPtr-startPtr};Module["stringToUTF32"]=stringToUTF32;var lengthBytesUTF32=str=>{var len=0;for(var i=0;i<str.length;++i){var codeUnit=str.charCodeAt(i);if(codeUnit>=55296&&codeUnit<=57343)++i;len+=4}return len};Module["lengthBytesUTF32"]=lengthBytesUTF32;var __embind_register_std_wstring=(rawType,charSize,name)=>{name=readLatin1String(name);var decodeString,encodeString,readCharAt,lengthBytesUTF;if(charSize===2){decodeString=UTF16ToString;encodeString=stringToUTF16;lengthBytesUTF=lengthBytesUTF16;readCharAt=pointer=>HEAPU16[pointer>>1]}else if(charSize===4){decodeString=UTF32ToString;encodeString=stringToUTF32;lengthBytesUTF=lengthBytesUTF32;readCharAt=pointer=>HEAPU32[pointer>>2]}registerType(rawType,{name:name,fromWireType:value=>{var length=HEAPU32[value>>2];var str;var decodeStartPtr=value+4;for(var i=0;i<=length;++i){var currentBytePtr=value+4+i*charSize;if(i==length||readCharAt(currentBytePtr)==0){var maxReadBytes=currentBytePtr-decodeStartPtr;var stringSegment=decodeString(decodeStartPtr,maxReadBytes);if(str===undefined){str=stringSegment}else{str+=String.fromCharCode(0);str+=stringSegment}decodeStartPtr=currentBytePtr+charSize}}_free(value);return str},toWireType:(destructors,value)=>{if(!(typeof value=="string")){throwBindingError(`Cannot pass non-string to C++ string type ${name}`)}var length=lengthBytesUTF(value);var ptr=_malloc(4+length+charSize);HEAPU32[ptr>>2]=length/charSize;encodeString(value,ptr+4,length+charSize);if(destructors!==null){destructors.push(_free,ptr)}return ptr},argPackAdvance:GenericWireTypeSize,readValueFromPointer:readPointer,destructorFunction(ptr){_free(ptr)}})};Module["__embind_register_std_wstring"]=__embind_register_std_wstring;var __embind_register_void=(rawType,name)=>{name=readLatin1String(name);registerType(rawType,{isVoid:true,name:name,argPackAdvance:0,fromWireType:()=>undefined,toWireType:(destructors,o)=>undefined})};Module["__embind_register_void"]=__embind_register_void;var nowIsMonotonic=1;Module["nowIsMonotonic"]=nowIsMonotonic;var __emscripten_get_now_is_monotonic=()=>nowIsMonotonic;Module["__emscripten_get_now_is_monotonic"]=__emscripten_get_now_is_monotonic;var __emscripten_memcpy_js=(dest,src,num)=>HEAPU8.copyWithin(dest,src,src+num);Module["__emscripten_memcpy_js"]=__emscripten_memcpy_js;var __emscripten_throw_longjmp=()=>{throw Infinity};Module["__emscripten_throw_longjmp"]=__emscripten_throw_longjmp;var requireRegisteredType=(rawType,humanName)=>{var impl=registeredTypes[rawType];if(undefined===impl){throwBindingError(`${humanName} has unknown type ${getTypeName(rawType)}`)}return impl};Module["requireRegisteredType"]=requireRegisteredType;var emval_returnValue=(returnType,destructorsRef,handle)=>{var destructors=[];var result=returnType["toWireType"](destructors,handle);if(destructors.length){HEAPU32[destructorsRef>>2]=Emval.toHandle(destructors)}return result};Module["emval_returnValue"]=emval_returnValue;var __emval_as=(handle,returnType,destructorsRef)=>{handle=Emval.toValue(handle);returnType=requireRegisteredType(returnType,"emval::as");return emval_returnValue(returnType,destructorsRef,handle)};Module["__emval_as"]=__emval_as;var __emval_is_number=handle=>{handle=Emval.toValue(handle);return typeof handle=="number"};Module["__emval_is_number"]=__emval_is_number;var __emval_run_destructors=handle=>{var destructors=Emval.toValue(handle);runDestructors(destructors);__emval_decref(handle)};Module["__emval_run_destructors"]=__emval_run_destructors;var __emval_take_value=(type,arg)=>{type=requireRegisteredType(type,"_emval_take_value");var v=type["readValueFromPointer"](arg);return Emval.toHandle(v)};Module["__emval_take_value"]=__emval_take_value;function __gmtime_js(time_low,time_high,tmPtr){var time=convertI32PairToI53Checked(time_low,time_high);var date=new Date(time*1e3);HEAP32[tmPtr>>2]=date.getUTCSeconds();HEAP32[tmPtr+4>>2]=date.getUTCMinutes();HEAP32[tmPtr+8>>2]=date.getUTCHours();HEAP32[tmPtr+12>>2]=date.getUTCDate();HEAP32[tmPtr+16>>2]=date.getUTCMonth();HEAP32[tmPtr+20>>2]=date.getUTCFullYear()-1900;HEAP32[tmPtr+24>>2]=date.getUTCDay();var start=Date.UTC(date.getUTCFullYear(),0,1,0,0,0,0);var yday=(date.getTime()-start)/(1e3*60*60*24)|0;HEAP32[tmPtr+28>>2]=yday}Module["__gmtime_js"]=__gmtime_js;var isLeapYear=year=>year%4===0&&(year%100!==0||year%400===0);Module["isLeapYear"]=isLeapYear;var MONTH_DAYS_LEAP_CUMULATIVE=[0,31,60,91,121,152,182,213,244,274,305,335];Module["MONTH_DAYS_LEAP_CUMULATIVE"]=MONTH_DAYS_LEAP_CUMULATIVE;var MONTH_DAYS_REGULAR_CUMULATIVE=[0,31,59,90,120,151,181,212,243,273,304,334];Module["MONTH_DAYS_REGULAR_CUMULATIVE"]=MONTH_DAYS_REGULAR_CUMULATIVE;var ydayFromDate=date=>{var leap=isLeapYear(date.getFullYear());var monthDaysCumulative=leap?MONTH_DAYS_LEAP_CUMULATIVE:MONTH_DAYS_REGULAR_CUMULATIVE;var yday=monthDaysCumulative[date.getMonth()]+date.getDate()-1;return yday};Module["ydayFromDate"]=ydayFromDate;function __localtime_js(time_low,time_high,tmPtr){var time=convertI32PairToI53Checked(time_low,time_high);var date=new Date(time*1e3);HEAP32[tmPtr>>2]=date.getSeconds();HEAP32[tmPtr+4>>2]=date.getMinutes();HEAP32[tmPtr+8>>2]=date.getHours();HEAP32[tmPtr+12>>2]=date.getDate();HEAP32[tmPtr+16>>2]=date.getMonth();HEAP32[tmPtr+20>>2]=date.getFullYear()-1900;HEAP32[tmPtr+24>>2]=date.getDay();var yday=ydayFromDate(date)|0;HEAP32[tmPtr+28>>2]=yday;HEAP32[tmPtr+36>>2]=-(date.getTimezoneOffset()*60);var start=new Date(date.getFullYear(),0,1);var summerOffset=new Date(date.getFullYear(),6,1).getTimezoneOffset();var winterOffset=start.getTimezoneOffset();var dst=(summerOffset!=winterOffset&&date.getTimezoneOffset()==Math.min(winterOffset,summerOffset))|0;HEAP32[tmPtr+32>>2]=dst}Module["__localtime_js"]=__localtime_js;function __mmap_js(len,prot,flags,fd,offset_low,offset_high,allocated,addr){var offset=convertI32PairToI53Checked(offset_low,offset_high);try{if(isNaN(offset))return 61;var stream=SYSCALLS.getStreamFromFD(fd);var res=FS.mmap(stream,len,offset,prot,flags);var ptr=res.ptr;HEAP32[allocated>>2]=res.allocated;HEAPU32[addr>>2]=ptr;return 0}catch(e){if(typeof FS=="undefined"||!(e.name==="ErrnoError"))throw e;return-e.errno}}Module["__mmap_js"]=__mmap_js;function __munmap_js(addr,len,prot,flags,fd,offset_low,offset_high){var offset=convertI32PairToI53Checked(offset_low,offset_high);try{var stream=SYSCALLS.getStreamFromFD(fd);if(prot&2){SYSCALLS.doMsync(addr,stream,len,flags,offset)}}catch(e){if(typeof FS=="undefined"||!(e.name==="ErrnoError"))throw e;return-e.errno}}Module["__munmap_js"]=__munmap_js;var __tzset_js=(timezone,daylight,std_name,dst_name)=>{var currentYear=(new Date).getFullYear();var winter=new Date(currentYear,0,1);var summer=new Date(currentYear,6,1);var winterOffset=winter.getTimezoneOffset();var summerOffset=summer.getTimezoneOffset();var stdTimezoneOffset=Math.max(winterOffset,summerOffset);HEAPU32[timezone>>2]=stdTimezoneOffset*60;HEAP32[daylight>>2]=Number(winterOffset!=summerOffset);var extractZone=timezoneOffset=>{var sign=timezoneOffset>=0?"-":"+";var absOffset=Math.abs(timezoneOffset);var hours=String(Math.floor(absOffset/60)).padStart(2,"0");var minutes=String(absOffset%60).padStart(2,"0");return`UTC${sign}${hours}${minutes}`};var winterName=extractZone(winterOffset);var summerName=extractZone(summerOffset);if(summerOffset<winterOffset){stringToUTF8(winterName,std_name,17);stringToUTF8(summerName,dst_name,17)}else{stringToUTF8(winterName,dst_name,17);stringToUTF8(summerName,std_name,17)}};Module["__tzset_js"]=__tzset_js;var _emscripten_date_now=()=>Date.now();Module["_emscripten_date_now"]=_emscripten_date_now;var _emscripten_errn=(str,len)=>err(UTF8ToString(str,len));Module["_emscripten_errn"]=_emscripten_errn;var getHeapMax=()=>2147483648;Module["getHeapMax"]=getHeapMax;var _emscripten_get_heap_max=()=>getHeapMax();Module["_emscripten_get_heap_max"]=_emscripten_get_heap_max;var _emscripten_get_now;_emscripten_get_now=()=>performance.now();Module["_emscripten_get_now"]=_emscripten_get_now;var growMemory=size=>{var b=wasmMemory.buffer;var pages=(size-b.byteLength+65535)/65536;try{wasmMemory.grow(pages);updateMemoryViews();return 1}catch(e){}};Module["growMemory"]=growMemory;var _emscripten_resize_heap=requestedSize=>{var oldSize=HEAPU8.length;requestedSize>>>=0;var maxHeapSize=getHeapMax();if(requestedSize>maxHeapSize){return false}var alignUp=(x,multiple)=>x+(multiple-x%multiple)%multiple;for(var cutDown=1;cutDown<=4;cutDown*=2){var overGrownHeapSize=oldSize*(1+.2/cutDown);overGrownHeapSize=Math.min(overGrownHeapSize,requestedSize+100663296);var newSize=Math.min(maxHeapSize,alignUp(Math.max(requestedSize,overGrownHeapSize),65536));var replacement=growMemory(newSize);if(replacement){return true}}return false};Module["_emscripten_resize_heap"]=_emscripten_resize_heap;var ENV={};Module["ENV"]=ENV;var getExecutableName=()=>thisProgram||"./this.program";Module["getExecutableName"]=getExecutableName;var getEnvStrings=()=>{if(!getEnvStrings.strings){var lang=(typeof navigator=="object"&&navigator.languages&&navigator.languages[0]||"C").replace("-","_")+".UTF-8";var env={USER:"web_user",LOGNAME:"web_user",PATH:"/",PWD:"/",HOME:"/home/web_user",LANG:lang,_:getExecutableName()};for(var x in ENV){if(ENV[x]===undefined)delete env[x];else env[x]=ENV[x]}var strings=[];for(var x in env){strings.push(`${x}=${env[x]}`)}getEnvStrings.strings=strings}return getEnvStrings.strings};Module["getEnvStrings"]=getEnvStrings;var stringToAscii=(str,buffer)=>{for(var i=0;i<str.length;++i){HEAP8[buffer++]=str.charCodeAt(i)}HEAP8[buffer]=0};Module["stringToAscii"]=stringToAscii;var _environ_get=(__environ,environ_buf)=>{var bufSize=0;getEnvStrings().forEach((string,i)=>{var ptr=environ_buf+bufSize;HEAPU32[__environ+i*4>>2]=ptr;stringToAscii(string,ptr);bufSize+=string.length+1});return 0};Module["_environ_get"]=_environ_get;var _environ_sizes_get=(penviron_count,penviron_buf_size)=>{var strings=getEnvStrings();HEAPU32[penviron_count>>2]=strings.length;var bufSize=0;strings.forEach(string=>bufSize+=string.length+1);HEAPU32[penviron_buf_size>>2]=bufSize;return 0};Module["_environ_sizes_get"]=_environ_sizes_get;var runtimeKeepaliveCounter=0;Module["runtimeKeepaliveCounter"]=runtimeKeepaliveCounter;var keepRuntimeAlive=()=>noExitRuntime||runtimeKeepaliveCounter>0;Module["keepRuntimeAlive"]=keepRuntimeAlive;var _proc_exit=code=>{EXITSTATUS=code;if(!keepRuntimeAlive()){Module["onExit"]?.(code);ABORT=true}quit_(code,new ExitStatus(code))};Module["_proc_exit"]=_proc_exit;var exitJS=(status,implicit)=>{EXITSTATUS=status;_proc_exit(status)};Module["exitJS"]=exitJS;var _exit=exitJS;Module["_exit"]=_exit;function _fd_close(fd){try{var stream=SYSCALLS.getStreamFromFD(fd);FS.close(stream);return 0}catch(e){if(typeof FS=="undefined"||!(e.name==="ErrnoError"))throw e;return e.errno}}Module["_fd_close"]=_fd_close;var doReadv=(stream,iov,iovcnt,offset)=>{var ret=0;for(var i=0;i<iovcnt;i++){var ptr=HEAPU32[iov>>2];var len=HEAPU32[iov+4>>2];iov+=8;var curr=FS.read(stream,HEAP8,ptr,len,offset);if(curr<0)return-1;ret+=curr;if(curr<len)break;if(typeof offset!="undefined"){offset+=curr}}return ret};Module["doReadv"]=doReadv;function _fd_read(fd,iov,iovcnt,pnum){try{var stream=SYSCALLS.getStreamFromFD(fd);var num=doReadv(stream,iov,iovcnt);HEAPU32[pnum>>2]=num;return 0}catch(e){if(typeof FS=="undefined"||!(e.name==="ErrnoError"))throw e;return e.errno}}Module["_fd_read"]=_fd_read;function _fd_seek(fd,offset_low,offset_high,whence,newOffset){var offset=convertI32PairToI53Checked(offset_low,offset_high);try{if(isNaN(offset))return 61;var stream=SYSCALLS.getStreamFromFD(fd);FS.llseek(stream,offset,whence);tempI64=[stream.position>>>0,(tempDouble=stream.position,+Math.abs(tempDouble)>=1?tempDouble>0?+Math.floor(tempDouble/4294967296)>>>0:~~+Math.ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[newOffset>>2]=tempI64[0],HEAP32[newOffset+4>>2]=tempI64[1];if(stream.getdents&&offset===0&&whence===0)stream.getdents=null;return 0}catch(e){if(typeof FS=="undefined"||!(e.name==="ErrnoError"))throw e;return e.errno}}Module["_fd_seek"]=_fd_seek;function _fd_sync(fd){try{var stream=SYSCALLS.getStreamFromFD(fd);if(stream.stream_ops?.fsync){return stream.stream_ops.fsync(stream)}return 0}catch(e){if(typeof FS=="undefined"||!(e.name==="ErrnoError"))throw e;return e.errno}}Module["_fd_sync"]=_fd_sync;var doWritev=(stream,iov,iovcnt,offset)=>{var ret=0;for(var i=0;i<iovcnt;i++){var ptr=HEAPU32[iov>>2];var len=HEAPU32[iov+4>>2];iov+=8;var curr=FS.write(stream,HEAP8,ptr,len,offset);if(curr<0)return-1;ret+=curr;if(typeof offset!="undefined"){offset+=curr}}return ret};Module["doWritev"]=doWritev;function _fd_write(fd,iov,iovcnt,pnum){try{var stream=SYSCALLS.getStreamFromFD(fd);var num=doWritev(stream,iov,iovcnt);HEAPU32[pnum>>2]=num;return 0}catch(e){if(typeof FS=="undefined"||!(e.name==="ErrnoError"))throw e;return e.errno}}Module["_fd_write"]=_fd_write;var getCFunc=ident=>{var func=Module["_"+ident];return func};Module["getCFunc"]=getCFunc;var writeArrayToMemory=(array,buffer)=>{HEAP8.set(array,buffer)};Module["writeArrayToMemory"]=writeArrayToMemory;var stackAlloc=sz=>__emscripten_stack_alloc(sz);Module["stackAlloc"]=stackAlloc;var stringToUTF8OnStack=str=>{var size=lengthBytesUTF8(str)+1;var ret=stackAlloc(size);stringToUTF8(str,ret,size);return ret};Module["stringToUTF8OnStack"]=stringToUTF8OnStack;var ccall=(ident,returnType,argTypes,args,opts)=>{var toC={string:str=>{var ret=0;if(str!==null&&str!==undefined&&str!==0){ret=stringToUTF8OnStack(str)}return ret},array:arr=>{var ret=stackAlloc(arr.length);writeArrayToMemory(arr,ret);return ret}};function convertReturnValue(ret){if(returnType==="string"){return UTF8ToString(ret)}if(returnType==="boolean")return Boolean(ret);return ret}var func=getCFunc(ident);var cArgs=[];var stack=0;if(args){for(var i=0;i<args.length;i++){var converter=toC[argTypes[i]];if(converter){if(stack===0)stack=stackSave();cArgs[i]=converter(args[i])}else{cArgs[i]=args[i]}}}var ret=func(...cArgs);function onDone(ret){if(stack!==0)stackRestore(stack);return convertReturnValue(ret)}ret=onDone(ret);return ret};Module["ccall"]=ccall;FS.createPreloadedFile=FS_createPreloadedFile;FS.staticInit();embind_init_charCodes();BindingError=Module["BindingError"]=class BindingError extends Error{constructor(message){super(message);this.name="BindingError"}};InternalError=Module["InternalError"]=class InternalError extends Error{constructor(message){super(message);this.name="InternalError"}};init_ClassHandle();init_embind();init_RegisteredPointer();UnboundTypeError=Module["UnboundTypeError"]=extendError(Error,"UnboundTypeError");init_emval();var wasmImports={n:___cxa_throw,s:___syscall_fcntl64,aa:___syscall_fstat64,K:___syscall_ftruncate64,T:___syscall_getdents64,ba:___syscall_ioctl,_:___syscall_lstat64,U:___syscall_mkdirat,Z:___syscall_newfstatat,z:___syscall_openat,S:___syscall_rmdir,$:___syscall_stat64,w:___syscall_unlinkat,fa:__abort_js,L:__embind_register_bigint,N:__embind_register_bool,q:__embind_register_class,p:__embind_register_class_constructor,a:__embind_register_class_function,E:__embind_register_emval,C:__embind_register_float,j:__embind_register_integer,h:__embind_register_memory_view,B:__embind_register_optional,v:__embind_register_std_string,r:__embind_register_std_wstring,W:__embind_register_void,da:__emscripten_get_now_is_monotonic,ea:__emscripten_memcpy_js,P:__emscripten_throw_longjmp,la:__emval_as,ma:__emval_decref,na:__emval_is_number,ka:__emval_run_destructors,m:__emval_take_value,H:__gmtime_js,I:__localtime_js,F:__mmap_js,G:__munmap_js,ga:__tzset_js,t:_emscripten_date_now,ja:_emscripten_errn,R:_emscripten_get_heap_max,ca:_emscripten_get_now,Q:_emscripten_resize_heap,V:_environ_get,X:_environ_sizes_get,ha:_exit,o:_fd_close,y:_fd_read,J:_fd_seek,Y:_fd_sync,x:_fd_write,D:get_domain_js,f:invoke_ii,g:invoke_iii,e:invoke_iiii,l:invoke_iiiii,ia:invoke_iiiiiii,u:invoke_iiiiiiiiii,A:invoke_v,c:invoke_vi,d:invoke_vii,M:invoke_viid,b:invoke_viii,i:invoke_viiii,k:invoke_viiiii,O:invoke_viiiiiiiii};var wasmExports=createWasm();var ___wasm_call_ctors=()=>(___wasm_call_ctors=wasmExports["pa"])();var ___getTypeName=a0=>(___getTypeName=wasmExports["qa"])(a0);var _free=Module["_free"]=a0=>(_free=Module["_free"]=wasmExports["ra"])(a0);var _aes_gcm_decrypt=Module["_aes_gcm_decrypt"]=(a0,a1,a2)=>(_aes_gcm_decrypt=Module["_aes_gcm_decrypt"]=wasmExports["sa"])(a0,a1,a2);var _malloc=Module["_malloc"]=a0=>(_malloc=Module["_malloc"]=wasmExports["ta"])(a0);var _GetDynamicImageCoreWasmVersion=Module["_GetDynamicImageCoreWasmVersion"]=()=>(_GetDynamicImageCoreWasmVersion=Module["_GetDynamicImageCoreWasmVersion"]=wasmExports["ua"])();var _aes_gcm_encrypt=Module["_aes_gcm_encrypt"]=(a0,a1,a2)=>(_aes_gcm_encrypt=Module["_aes_gcm_encrypt"]=wasmExports["va"])(a0,a1,a2);var _ds_destroy_file=Module["_ds_destroy_file"]=()=>(_ds_destroy_file=Module["_ds_destroy_file"]=wasmExports["wa"])();var _ds_get_file=Module["_ds_get_file"]=(a0,a1,a2,a3)=>(_ds_get_file=Module["_ds_get_file"]=wasmExports["xa"])(a0,a1,a2,a3);var _GetDynamicPdfWWasmVersion=Module["_GetDynamicPdfWWasmVersion"]=()=>(_GetDynamicPdfWWasmVersion=Module["_GetDynamicPdfWWasmVersion"]=wasmExports["ya"])();var _ds_sub_array=Module["_ds_sub_array"]=(a0,a1,a2,a3)=>(_ds_sub_array=Module["_ds_sub_array"]=wasmExports["za"])(a0,a1,a2,a3);var _htonl=a0=>(_htonl=wasmExports["Aa"])(a0);var _htons=a0=>(_htons=wasmExports["Ba"])(a0);var _memset=Module["_memset"]=(a0,a1,a2)=>(_memset=Module["_memset"]=wasmExports["Da"])(a0,a1,a2);var _ntohs=a0=>(_ntohs=wasmExports["Ea"])(a0);var _emscripten_builtin_memalign=(a0,a1)=>(_emscripten_builtin_memalign=wasmExports["Fa"])(a0,a1);var _setThrew=(a0,a1)=>(_setThrew=wasmExports["Ga"])(a0,a1);var __emscripten_tempret_set=a0=>(__emscripten_tempret_set=wasmExports["Ha"])(a0);var __emscripten_stack_restore=a0=>(__emscripten_stack_restore=wasmExports["Ia"])(a0);var __emscripten_stack_alloc=a0=>(__emscripten_stack_alloc=wasmExports["Ja"])(a0);var _emscripten_stack_get_current=()=>(_emscripten_stack_get_current=wasmExports["Ka"])();var ___cxa_increment_exception_refcount=a0=>(___cxa_increment_exception_refcount=wasmExports["La"])(a0);var ___cxa_is_pointer_type=a0=>(___cxa_is_pointer_type=wasmExports["Ma"])(a0);var dynCall_ji=Module["dynCall_ji"]=(a0,a1)=>(dynCall_ji=Module["dynCall_ji"]=wasmExports["Na"])(a0,a1);var dynCall_iiij=Module["dynCall_iiij"]=(a0,a1,a2,a3,a4)=>(dynCall_iiij=Module["dynCall_iiij"]=wasmExports["Oa"])(a0,a1,a2,a3,a4);var dynCall_jij=Module["dynCall_jij"]=(a0,a1,a2,a3)=>(dynCall_jij=Module["dynCall_jij"]=wasmExports["Pa"])(a0,a1,a2,a3);var dynCall_iij=Module["dynCall_iij"]=(a0,a1,a2,a3)=>(dynCall_iij=Module["dynCall_iij"]=wasmExports["Qa"])(a0,a1,a2,a3);var dynCall_jji=Module["dynCall_jji"]=(a0,a1,a2,a3)=>(dynCall_jji=Module["dynCall_jji"]=wasmExports["Ra"])(a0,a1,a2,a3);var dynCall_iji=Module["dynCall_iji"]=(a0,a1,a2,a3)=>(dynCall_iji=Module["dynCall_iji"]=wasmExports["Sa"])(a0,a1,a2,a3);var dynCall_viij=Module["dynCall_viij"]=(a0,a1,a2,a3,a4)=>(dynCall_viij=Module["dynCall_viij"]=wasmExports["Ta"])(a0,a1,a2,a3,a4);var dynCall_jiji=Module["dynCall_jiji"]=(a0,a1,a2,a3,a4)=>(dynCall_jiji=Module["dynCall_jiji"]=wasmExports["Ua"])(a0,a1,a2,a3,a4);var dynCall_iiji=Module["dynCall_iiji"]=(a0,a1,a2,a3,a4)=>(dynCall_iiji=Module["dynCall_iiji"]=wasmExports["Va"])(a0,a1,a2,a3,a4);var dynCall_vij=Module["dynCall_vij"]=(a0,a1,a2,a3)=>(dynCall_vij=Module["dynCall_vij"]=wasmExports["Wa"])(a0,a1,a2,a3);var dynCall_iijji=Module["dynCall_iijji"]=(a0,a1,a2,a3,a4,a5,a6)=>(dynCall_iijji=Module["dynCall_iijji"]=wasmExports["Xa"])(a0,a1,a2,a3,a4,a5,a6);var dynCall_iiiij=Module["dynCall_iiiij"]=(a0,a1,a2,a3,a4,a5)=>(dynCall_iiiij=Module["dynCall_iiiij"]=wasmExports["Ya"])(a0,a1,a2,a3,a4,a5);var dynCall_viijii=Module["dynCall_viijii"]=(a0,a1,a2,a3,a4,a5,a6)=>(dynCall_viijii=Module["dynCall_viijii"]=wasmExports["Za"])(a0,a1,a2,a3,a4,a5,a6);var dynCall_iijj=Module["dynCall_iijj"]=(a0,a1,a2,a3,a4,a5)=>(dynCall_iijj=Module["dynCall_iijj"]=wasmExports["_a"])(a0,a1,a2,a3,a4,a5);var dynCall_iijii=Module["dynCall_iijii"]=(a0,a1,a2,a3,a4,a5)=>(dynCall_iijii=Module["dynCall_iijii"]=wasmExports["$a"])(a0,a1,a2,a3,a4,a5);var dynCall_iijjj=Module["dynCall_iijjj"]=(a0,a1,a2,a3,a4,a5,a6,a7)=>(dynCall_iijjj=Module["dynCall_iijjj"]=wasmExports["ab"])(a0,a1,a2,a3,a4,a5,a6,a7);var dynCall_iiiiij=Module["dynCall_iiiiij"]=(a0,a1,a2,a3,a4,a5,a6)=>(dynCall_iiiiij=Module["dynCall_iiiiij"]=wasmExports["bb"])(a0,a1,a2,a3,a4,a5,a6);var dynCall_iiiiijj=Module["dynCall_iiiiijj"]=(a0,a1,a2,a3,a4,a5,a6,a7,a8)=>(dynCall_iiiiijj=Module["dynCall_iiiiijj"]=wasmExports["cb"])(a0,a1,a2,a3,a4,a5,a6,a7,a8);var dynCall_iiiiiijj=Module["dynCall_iiiiiijj"]=(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9)=>(dynCall_iiiiiijj=Module["dynCall_iiiiiijj"]=wasmExports["db"])(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9);function invoke_viii(index,a1,a2,a3){var sp=stackSave();try{getWasmTableEntry(index)(a1,a2,a3)}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}function invoke_iii(index,a1,a2){var sp=stackSave();try{return getWasmTableEntry(index)(a1,a2)}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}function invoke_vi(index,a1){var sp=stackSave();try{getWasmTableEntry(index)(a1)}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}function invoke_ii(index,a1){var sp=stackSave();try{return getWasmTableEntry(index)(a1)}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}function invoke_iiii(index,a1,a2,a3){var sp=stackSave();try{return getWasmTableEntry(index)(a1,a2,a3)}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}function invoke_viiii(index,a1,a2,a3,a4){var sp=stackSave();try{getWasmTableEntry(index)(a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}function invoke_iiiii(index,a1,a2,a3,a4){var sp=stackSave();try{return getWasmTableEntry(index)(a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}function invoke_vii(index,a1,a2){var sp=stackSave();try{getWasmTableEntry(index)(a1,a2)}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{return getWasmTableEntry(index)(a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}function invoke_iiiiiii(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return getWasmTableEntry(index)(a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}function invoke_v(index){var sp=stackSave();try{getWasmTableEntry(index)()}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}function invoke_viiiii(index,a1,a2,a3,a4,a5){var sp=stackSave();try{getWasmTableEntry(index)(a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{getWasmTableEntry(index)(a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}function invoke_viid(index,a1,a2,a3){var sp=stackSave();try{getWasmTableEntry(index)(a1,a2,a3)}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}Module["ccall"]=ccall;Module["UTF8ToString"]=UTF8ToString;Module["stringToUTF8"]=stringToUTF8;Module["lengthBytesUTF8"]=lengthBytesUTF8;var calledRun;dependenciesFulfilled=function runCaller(){if(!calledRun)run();if(!calledRun)dependenciesFulfilled=runCaller};function run(){if(runDependencies>0){return}preRun();if(runDependencies>0){return}function doRun(){if(calledRun)return;calledRun=true;Module["calledRun"]=true;if(ABORT)return;initRuntime();readyPromiseResolve(Module);Module["onRuntimeInitialized"]?.();postRun()}if(Module["setStatus"]){Module["setStatus"]("Running...");setTimeout(function(){setTimeout(function(){Module["setStatus"]("")},1);doRun()},1)}else{doRun()}}if(Module["preInit"]){if(typeof Module["preInit"]=="function")Module["preInit"]=[Module["preInit"]];while(Module["preInit"].length>0){Module["preInit"].pop()()}}run();moduleRtn=readyPromise;


  return moduleRtn;
}
);
})();
if (typeof exports === 'object' && typeof module === 'object')
  module.exports = ImageIOModule;
else if (typeof define === 'function' && define['amd'])
  define([], () => ImageIOModule);

!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):((e="undefined"!=typeof globalThis?globalThis:e||self).Dynamsoft=e.Dynamsoft||{},e.Dynamsoft.ImageIOWasm=t())}(this,(function(){"use strict";var e,t,a,n,s,r,o,i,p,l,u,c,m,f,d,g,y,b,h,P,w,A,v,I,k,S,M,T,D,j,_,R;function F(e,t,a,n){return new(a||(a=Promise))((function(s,r){function o(e){try{p(n.next(e))}catch(e){r(e)}}function i(e){try{p(n.throw(e))}catch(e){r(e)}}function p(e){var t;e.done?s(e.value):(t=e.value,t instanceof a?t:new a((function(e){e(t)}))).then(o,i)}p((n=n.apply(e,t||[])).next())}))}function E(e,t,a,n){if("a"===a&&!n)throw new TypeError("Private accessor was defined without a getter");if("function"==typeof t?e!==t||!n:!t.has(e))throw new TypeError("Cannot read private member from an object whose class did not declare it");return"m"===a?n:"a"===a?n.call(e):n?n.value:t.get(e)}function B(e,t,a,n,s){if("m"===n)throw new TypeError("Private method is not writable");if("a"===n&&!s)throw new TypeError("Private accessor was defined without a setter");if("function"==typeof t?e!==t||!s:!t.has(e))throw new TypeError("Cannot write private member to an object whose class did not declare it");return"a"===n?s.call(e,a):s?s.value=a:t.set(e,a),a}!function(e){e.logInfo="logInfo",e.logDebug="logDebug",e.logAll="logAll",e.imgIO="imgIO",e.imgProc="imgProc",e.binaryBlobType="application/octet-stream",e.wasmExtension=".wasm"}(e||(e={})),function(e){e.imgCore="imgCore",e.imgProc="imgProc",e.pdfCore="pdfCore"}(t||(t={})),function(e){e.core="ddv-core",e.reader="ddv-reader",e.detector="ddv-detector",e.loader="ddv-loader",e.proc="ddv-proc"}(a||(a={})),function(e){e.pending="pending",e.ready="ready",e.failed="failed",e.destroyed="destroyed",e.init="init"}(n||(n={})),function(e){e.PARAMETER_TYPE_ERROR="Parameter Type not Supported = ",e.TIMEOUT="Timeout no Response = ",e.FILE_STREAM_ERROR="File Stream Error = ",e.WASM_EXCEPTION_ERROR="An WASM exception occurred."}(s||(s={})),function(e){e[e.LONG_KEY=0]="LONG_KEY",e[e.DLS_KEY=1]="DLS_KEY"}(r||(r={})),function(e){e[e.wasmSucceed=0]="wasmSucceed",e[e.wasmBase=-4e3]="wasmBase",e[e.wasmException=-4001]="wasmException",e[e.wasmNoModule=-4002]="wasmNoModule",e[e.wasmJsBase=-4100]="wasmJsBase",e[e.wasmJsObjectNotInit=-4101]="wasmJsObjectNotInit",e[e.wasmJsObjectTerminated=-4102]="wasmJsObjectTerminated",e[e.wasmJsObjectInitFailed=-4103]="wasmJsObjectInitFailed",e[e.wasmJsNotLoaded=-4104]="wasmJsNotLoaded",e[e.wasmJsInvalidJson=-4105]="wasmJsInvalidJson",e[e.wasmJsWorkerRunException=-4106]="wasmJsWorkerRunException",e[e.wasmJsWorkerRunFailed=-4107]="wasmJsWorkerRunFailed",e[e.wasmJsReadFileFailed=-4108]="wasmJsReadFileFailed",e[e.wasmJsCoreTaskException=-4109]="wasmJsCoreTaskException",e[e.wasmJsProcTaskException=-4110]="wasmJsProcTaskException",e[e.wasmJsSavePdfFailed=-4111]="wasmJsSavePdfFailed",e[e.wasmJsSaveTiffFailed=-4112]="wasmJsSaveTiffFailed"}(o||(o={})),function(e){e[e.IT_DIB=-1]="IT_DIB",e[e.IT_RGBA=-2]="IT_RGBA",e[e.IT_BGRA=-3]="IT_BGRA",e[e.IT_BMP=0]="IT_BMP",e[e.IT_JPG=1]="IT_JPG",e[e.IT_PNG=3]="IT_PNG",e[e.IT_ALL=5]="IT_ALL"}(i||(i={})),function(e){e[e.RT_AUTO=-1]="RT_AUTO",e[e.RT_BINARY=1]="RT_BINARY",e[e.RT_BASE64=2]="RT_BASE64"}(p||(p={})),function(e){e[e.SF_DEF=0]="SF_DEF",e[e.SF_ENABLE=1]="SF_ENABLE",e[e.SF_DISABLE=2]="SF_DISABLE"}(l||(l={})),"function"==typeof SuppressedError&&SuppressedError;class C{static register(e){E(this,u,"f",c).push(e)}static process(e){E(this,u,"f",c).forEach((t=>{e.data.params.moduleName!==t.Name||t.process(e)}))}}u=C,c={value:new Array};class U{constructor(e){this._instances=Object.create(null),m.set(this,""),B(this,m,e,"f"),C.register(this)}get Name(){return E(this,m,"f")}_destroy(e){let t=this._instances[e.data.params.insId];t&&(delete this._instances[e.data.params.insId],t.wasmObject.delete(),e.context.logDebug(e.data,"Delete Instance "+e.data.params.insId))}process(e){}}m=new WeakMap;class O extends U{constructor(){super(t.imgCore)}process(t){let a=t.data,n={errorCode:0,errorMessage:"Successful."},s=this._instances[a.params.insId],r=null==s?void 0:s.wasmObject,l=t.entryModule;switch(a.func){case"init":void 0===this._instances[a.params.insId]&&(this._instances[a.params.insId]={wasmObject:new l.DynamicImagecore(a.params.key,a.params.licMode,a.params.uuid)},t.context.logDebug(a,"Create ImageCore Instance "+a.params.insId));break;case"destroy":(null==s?void 0:s.wasmMemoryPtr)&&(t.wasmMemoryPtr=s.wasmMemoryPtr,s.wasmMemoryPtr=null),this._destroy(t);break;case"terminate":return this._destroy(t),t.context.logDebug(a,"Terminate worker"),void self.close();case"getMemoryUsed":n.memoryUsed=l.HEAPU8.length;break;case"SaveImage":case"ReadImage":case"ReadTiffPage":!function(){"ReadImage"===a.func?n=r.ReadImage.apply(r,a.params.input):"SaveImage"===a.func?n=r.SaveImage.apply(r,a.params.input):"ReadTiffPage"===a.func&&(n=r.ReadTiffPage.apply(r,a.params.input));let t=JSON.parse(n);if(0===t.errorCode&&"Successful."===t.errorMessage)if(a.params.returnType===p.RT_BASE64){let e=r.GetCurrentDataBase64(),a=r.GetCurrentDataMD5();t.MD5=a,t.imageData=e}else{let a,n;t.imageType===i.IT_BMP?n="bmp":t.imageType===i.IT_JPG?n="jpeg":t.imageType===i.IT_PNG&&(n="png"),a=n?"image/"+n:e.binaryBlobType;let s=r.GetCurrentData();t.blobType=a,t.imageData=new Uint8ClampedArray(s)}n=t,r.FreeReservedData()}();break;case"GetMD5":!function(){let e={MD5:r.GetMD5.apply(r,a.params.input)};n=JSON.stringify(e)}();break;case"GetLicenseInfo":n=r.GetLicenseInfo();break;case"GetAesResult":n=r.AESGcmEncrypt.apply(r,a.params.input);break;case"GetImageFormat":n=r.GetImageFormat.apply(r,a.params.input);break;case"ReadImageInfo":n=r.ReadImageInfo.apply(r,a.params.input);break;case"LoadTiff":!function(){var e;if(a.params.input[0]instanceof Blob){const t=l.FS.analyzePath("/loadtiff");if("/loadtiff"===(null===(e=t.object)||void 0===e?void 0:e.mount.mountpoint)){for(const e in t.object.contents)t.object.contents[e].contents=void 0;t.object.mount.opts={},l.FS.unmount("/loadtiff")}const s="/loadtiff/input.tif";l.FS.mount(l.WORKERFS,{blobs:[{name:"input.tif",data:a.params.input[0]}]},"/loadtiff");const o=l.lengthBytesUTF8(s)+1,i=l._malloc(o);l._memset(i,0,o);for(let e=0;e<s.length;e++)l.HEAPU8[i+e]=s.charCodeAt(e);a.params.input[0]=i,a.params.input.splice(1,0,0),n=r.LoadTiff.apply(r,a.params.input)}else t.wasmMemoryPtr&&(s&&(s.wasmMemoryPtr=t.wasmMemoryPtr),t.wasmMemoryPtr=null),n=r.LoadTiff.apply(r,a.params.input)}();break;case"GetTiffPageInfos":!function(){let e=new l.vectorInt;if(Array.isArray(a.params.input[0]))for(let t=0;t<a.params.input[0].length;t++)e.push_back(a.params.input[0][t]);a.params.input[0]=e,n=r.GetTiffPageInfos.apply(r,a.params.input),e.delete()}();break;case"EndReadTiff":!function(){var e;r.EndReadTiff(),r.wasmMemoryPtr&&(t.wasmMemoryPtr=r.wasmMemoryPtr,delete r.wasmMemoryPtr);const a=l.FS.analyzePath("/loadtiff");if("/loadtiff"===(null===(e=a.object)||void 0===e?void 0:e.mount.mountpoint)){for(const e in a.object.contents)a.object.contents[e].contents=void 0;a.object.mount.opts={},l.FS.unmount("/loadtiff")}}();break;case"NewTiff":!function(){const e="output_tiff_"+a.params.insId;l.customStream.initSize=8192;var t=l.FS.makedev(3,5);l.FS.registerDevice(t,l.customStream),l.FS.mkdev(e,511,t);const s="/"+e;n=r.NewTiffFile(s)}();break;case"AppendImageToTiff":n=r.AppendImageToTiff.apply(r,a.params.input);break;case"AddTagToNextPage":n=r.AddTagToNextPage.apply(r,a.params.input);break;case"EndWriteTiff":n=r.EndWriteTiff();break;case"GetTiffStream":!function(){r.EndWriteTiff();const e="output_tiff_"+a.params.insId;let t=l.save_buf[e],s={};t?(s.blobType="image/tiff",s.imageData=new Uint8ClampedArray(t.buffer),s.imageDataSize=t.byteLength):s={errorCode:o.wasmJsSaveTiffFailed,errorMessage:"no tiff content return"},n=s,r.FreeReservedData(),l.save_buf[e]=null}();break;case"GetWasmVersion":n=r.GetWasmVersion();break;case"ds_get_file":!function(){let e,t,s,o,i,p,u,c=a.params.input;t=c[0],s=c[1];let m=c[2];e=new Uint8Array(17),o=l._malloc(e.length),l.HEAPU8.set(e,o),r.GetMultipartFile(t,s,m,o),p=l.HEAPU32[o/4],u=l.HEAPU32[o/4+1],i=l.HEAPU8.slice(p,p+u),l._free(p),l._free(o),r.DestroyMultipartFile(),n=i}();break;case"UpdateLicense":r.UpdateLicense.apply(r,a.params.input)}t.context.logDebug(a,a.func+" end, send back begin");let u,c={id:a.id,func:a.func,result:n,memSize:l.HEAPU8.length};if(a.params.srcBuffer){"string"==typeof c.result&&(c.result=JSON.parse(c.result)),c.result.srcBuffer=a.params.srcBuffer;let e=Object.prototype.toString.call(c.result.srcBuffer);"[object ArrayBuffer]"!==e&&"[object Uint8ClampedArray]"!==e||(u=[null!=c.result.srcBuffer.buffer?c.result.srcBuffer.buffer:c.result.srcBuffer])}let m=Object.prototype.toString.call(n.imageData);"[object ArrayBuffer]"!==m&&"[object Uint8ClampedArray]"!==m&&"[object Uint8Array]"!==m||(u=[null!=c.result.imageData.buffer?c.result.imageData.buffer:c.result.imageData]),null!=u?t.context.sendResult(c,u):t.context.sendResult(c),t.context.logDebug(a,a.func+" end, send back end"),n=null}}new O;class x extends U{constructor(){super(t.pdfCore),f.set(this,Object.create(null))}process(e){var t;let a=e.data,n={errorCode:0,errorMessage:"Successful."},s=this._instances[a.params.insId],r=null==s?void 0:s.wasmObject,l=e.entryModule,u=E(this,f,"f");switch(a.func){case"init":void 0===this._instances[a.params.insId]&&(this._instances[a.params.insId]={wasmObject:new l.DynamicPdfCore(a.params.key,a.params.licMode,a.params.uuid)},e.context.logDebug(a,"Create PdfReader Instance "+a.params.insId));break;case"destroy":n=r.UnloadDocument();const c=l.FS.analyzePath("/loadpdf");if("/loadpdf"===(null===(t=c.object)||void 0===t?void 0:t.mount.mountpoint)){for(const e in c.object.contents)c.object.contents[e].contents=void 0;c.object.mount.opts={},l.FS.unmount("/loadpdf")}(null==s?void 0:s.wasmMemoryPtr)&&(e.wasmMemoryPtr=s.wasmMemoryPtr,s.wasmMemoryPtr=null),this._destroy(e);break;case"terminate":return this._destroy(e),e.context.logDebug(a,"Terminate worker"),void self.close();case"LoadPdf":!function(){var t;if(a.params.input[0]instanceof Blob){const e=l.FS.analyzePath("/loadpdf");if("/loadpdf"===(null===(t=e.object)||void 0===t?void 0:t.mount.mountpoint)){n=r.UnloadDocument();for(const t in e.object.contents)e.object.contents[t].contents=void 0;e.object.mount.opts={},l.FS.unmount("/loadpdf")}const s="/loadpdf/input.pdf";l.FS.mount(l.WORKERFS,{blobs:[{name:"input.pdf",data:a.params.input[0]}]},"/loadpdf");const o=l.lengthBytesUTF8(s)+1,i=l._malloc(o);l._memset(i,0,o);for(let e=0;e<s.length;e++)l.HEAPU8[i+e]=s.charCodeAt(e);a.params.input[0]=i,a.params.input.splice(1,0,0)}e.wasmMemoryPtr&&(s&&(s.wasmMemoryPtr=e.wasmMemoryPtr),e.wasmMemoryPtr=null),n=r.LoadDocument.apply(r,a.params.input)}();break;case"ReadPageImageInfos":!function(){let e=new l.vectorInt;if(Array.isArray(a.params.input[0]))for(let t=0;t<a.params.input[0].length;t++)e.push_back(a.params.input[0][t]);a.params.input[0]=e,n=r.ReadPageImageInfos.apply(r,a.params.input),e.delete()}();break;case"GetPageContentType":n=r.GetPageContentType.apply(r,a.params.input);break;case"ReadPdfPage":case"ReadPdfPageEx":case"RenderPdfPage":!function(){var e;let t;if("ReadPdfPage"===a.func)t=r.ReadPdfPage.apply(r,a.params.input);else if("ReadPdfPageEx"===a.func)t=r.ReadPdfPageEx.apply(r,a.params.input);else if("RenderPdfPage"===a.func){let e=new l.vectorFloat;if(Array.isArray(a.params.input[2]))for(let t=0;t<a.params.input[2].length;t++)e.push_back(a.params.input[2][t]);a.params.input[2]=e,t=r.RenderPdfPage.apply(r,a.params.input)}r.UnloadPdfPage(a.params.input[0]);let s,o=JSON.parse(t),u=[];if(0===o.errorCode&&"Successful."===o.errorMessage){const t=o.imageInfos?o.imageInfos[0].imageType:o.imageInfo.imageType;if(t===i.IT_BMP?s="bmp":t===i.IT_JPG?s="jpeg":t===i.IT_PNG?s="png":t===i.IT_RGBA&&(s="rgba"),o.imageCount=null!==(e=o.imageCount)&&void 0!==e?e:1,o.imageData=[],o.MD5=[],a.params.returnType===p.RT_BASE64)for(let e=0;e<o.imageCount;e++)u[e]=r.GetCurrentDataBase64(e),o.imageData[e]=u[e],o.MD5[e]=r.GetCurrentDataMD5(e);else{for(let e=0;e<o.imageCount;e++)u[e]=r.GetCurrentData(e);"rgba"!=s&&(o.blobType="image/"+s);for(let e=0;e<o.imageCount;e++)o.imageData[e]=new Uint8ClampedArray(u[e])}}a.params.returnType!=p.RT_BASE64&&1===o.imageCount&&(o.imageData=o.imageData[0]),n=o;for(let e=0;e<o.imageCount;e++)r.FreeReservedData(e)}();break;case"GetCurrentData":n=r.GetCurrentData();break;case"GetPageAnnot":n=r.GetPageAnnot.apply(r,a.params.input),r.UnloadPdfPage(a.params.input[0]);break;case"GetPageAnnotCount":n=r.GetPageAnnotCount.apply(r,a.params.input);break;case"GetPdfPageInfos":!function(){let e=new l.vectorInt;if(Array.isArray(a.params.input[0]))for(let t=0;t<a.params.input[0].length;t++)e.push_back(a.params.input[0][t]);a.params.input[0]=e,n=r.GetPageInfos.apply(r,a.params.input),e.delete()}();break;case"SearchText":!function(){let e=new l.vectorInt;if(Array.isArray(a.params.input[0]))for(let t=0;t<a.params.input[0].length;t++)e.push_back(a.params.input[0][t]);a.params.input[0]=e,n=r.SearchText.apply(r,a.params.input),e.delete()}();break;case"GetPageCharInfos":!function(){let e=new l.vectorInt;if(Array.isArray(a.params.input[0]))for(let t=0;t<a.params.input[0].length;t++)e.push_back(a.params.input[0][t]);a.params.input[0]=e,n=r.GetPageCharInfos.apply(r,a.params.input),e.delete()}();break;case"SetSystemFonts":!function(){var e;const t=Object.keys(a.params.input[0]);if(t.length!==l.fonts.length){if(l.fonts.length>0){const t=l.FS.analyzePath("/fonts");if("/fonts"===(null===(e=t.object)||void 0===e?void 0:e.mount.mountpoint)){for(const e in t.object.contents)t.object.contents[e].contents=void 0;t.object.mount.opts={},l.FS.unmount("/fonts")}}let n=[];for(let e of t){let t=e;".ttf"!==e.slice(-4)&&".otf"!==e.slice(-4)&&".ttc"!==e.slice(-4)&&(t=e+".ttf"),n.push({name:t,data:a.params.input[0][e]})}l.fonts=n,l.FS.mount(l.WORKERFS,{blobs:l.fonts},"/fonts")}}();break;case"AddSystemFont":!function(){let e=a.params.input[0],t=e,n=e;if(".ttf"===e.slice(-4)||".ttc"===n.slice(-4)||".otf"===n.slice(-4)?t=e.substring(0,e.lastIndexOf(".")):n=e+".ttf",void 0===u[t]){let e;e=".ttf"===n.slice(-4)?"usr/share/fonts/truetype":".otf"===n.slice(-4)?"usr/share/fonts/opentype":"usr/share/fonts",l.FS.createPath("",e,!0,!0),l.FS.writeFile(e+"/"+n,new Uint8Array(a.params.input[1]),{flags:"w+"}),u[t]=!0}}();break;case"UnloadDocument":!function(){var t;(null==s?void 0:s.wasmMemoryPtr)&&(e.wasmMemoryPtr=s.wasmMemoryPtr,s.wasmMemoryPtr=null);const a=l.FS.analyzePath("/loadpdf");if("/loadpdf"===(null===(t=a.object)||void 0===t?void 0:t.mount.mountpoint)){n=r.UnloadDocument();for(const e in a.object.contents)a.object.contents[e].contents=void 0;a.object.mount.opts={},l.FS.unmount("/loadpdf")}}();break;case"CreateDocument":n=r.CreateDocument.apply(r,a.params.input);break;case"InsertBlankPage":n=r.InsertBlankPage.apply(r,a.params.input);break;case"InsertBlankPages":!function(){var e;const t=null!==(e=a.params.input[3])&&void 0!==e?e:1,s={errorCode:0,errorMessage:"Successful.",pageIndexes:[]};for(let e=0;e<t;e++){const t=r.InsertBlankPage.apply(r,[a.params.input[0]>=0?a.params.input[0]+e:a.params.input[0],a.params.input[1],a.params.input[2]]),n=JSON.parse(t);if(0!==n.errorCode){s.errorCode=n.errorCode,s.errorMessage=n.errorMessage;break}s.pageIndexes.push(n.pageIndex)}n=JSON.stringify(s)}();break;case"InsertImagePage":!function(){let e=a.params.input[0],t=a.params.input[1];a.params.input[0]=a.params.input[2],a.params.input[1]=e,a.params.input[2]=t,n=r.InsertImagePage.apply(r,a.params.input)}();break;case"InsertImagePageByDIB":n=r.InsertImagePageByDIB.apply(r,a.params.input);break;case"PageAddImage":!function(){let e=a.params.input[0],t=a.params.input[1],s=new l.vectorInt;if(Array.isArray(a.params.input[2]))for(let e=0;e<a.params.input[2].length;e++)s.push_back(a.params.input[2][e]);a.params.input[0]=s,a.params.input[1]=a.params.input[3],a.params.input[2]=e,a.params.input[3]=t,n=r.PageAddImage.apply(r,a.params.input),s.delete()}();break;case"PageAddText":!function(){let e=new l.vectorInt;if(Array.isArray(a.params.input[0]))for(let t=0;t<a.params.input[0].length;t++)e.push_back(a.params.input[0][t]);a.params.input[0]=e,n=r.PageAddText.apply(r,a.params.input),e.delete()}();break;case"PageAddPath":!function(){let e=new l.vectorInt;if(Array.isArray(a.params.input[0]))for(let t=0;t<a.params.input[0].length;t++)e.push_back(a.params.input[0][t]);a.params.input[0]=e,n=r.PageAddPath.apply(r,a.params.input),e.delete()}();break;case"PageClearObjects":n=r.PageClearObjects.apply(r,a.params.input);break;case"PageAddAnnot":n=r.AddPageAnnot.apply(r,a.params.input);break;case"SetPageAnnot":n=r.SetPageAnnot.apply(r,a.params.input);break;case"FlattenPageAnnot":n=r.FlattenPageAnnot.apply(r,a.params.input);break;case"DeletePageAnnot":n=r.DeletePageAnnot.apply(r,a.params.input);break;case"DeletePageAnnotByTypes":n=r.DeletePageAnnotByTypes.apply(r,a.params.input);break;case"DeletePageAnnotExceptTypes":n=r.DeletePageAnnotExceptTypes.apply(r,a.params.input);break;case"DeletePageAnnotByNames":n=r.DeletePageAnnotByNames.apply(r,a.params.input);break;case"DeletePage":n=r.DeletePage.apply(r,a.params.input);break;case"MovePages":!function(){let e=new l.vectorInt;if(Array.isArray(a.params.input[1]))for(let t=0;t<a.params.input[1].length;t++)e.push_back(a.params.input[1][t]);a.params.input[1]=e,n=r.MovePages.apply(r,a.params.input),e.delete()}();break;case"SetPdfInfo":n=r.SetPdfInfo.apply(r,a.params.input);break;case"SetPageRotation":n=r.SetPageRotation.apply(r,a.params.input);break;case"SetPageCropBox":n=r.SetPageCropBox.apply(r,a.params.input);break;case"SetPageMediaBox":n=r.SetPageMediaBox.apply(r,a.params.input);break;case"PageFlatten":n=r.FlattenPage.apply(r,a.params.input);break;case"LoadFont":!function(){let e=a.params.input[0],t=a.params.input[1],s=a.params.input[2],o=s;(".ttf"===s.slice(-4)||".ttc"===s.slice(-4)||".otf"===s.slice(-4))&&(o=s.substring(0,s.lastIndexOf("."))),n=r.LoadFont.apply(r,[o,e,t,2,!0])}();break;case"LoadFonts":!function(){var e;const t=Object.keys(a.params.input[0]);if(t.length!==l.fonts.length){if(l.fonts.length>0){const t=l.FS.analyzePath("/fonts");if("/fonts"===(null===(e=t.object)||void 0===e?void 0:e.mount.mountpoint)){for(const e in t.object.contents)t.object.contents[e].contents=void 0;t.object.mount.opts={},l.FS.unmount("/fonts")}}let n=[];for(let e of t){let t=e;".ttf"!==e.slice(-4)&&".otf"!==e.slice(-4)&&".ttc"!==e.slice(-4)&&(t=e+".ttf"),n.push({name:t,data:a.params.input[0][e]})}l.fonts=n,l.FS.mount(l.WORKERFS,{blobs:l.fonts},"/fonts")}let s="";l.fonts.forEach((e=>{s.length>0&&(s+=";"),s+="/fonts/"+e.name})),n=r.LoadFontFiles.apply(r,[s])}();break;case"GetFontInfo":n=r.GetFontInfo.apply(r,a.params.input);break;case"IfFontsExist":n=r.IfFontsExist.apply(r,a.params.input);break;case"MergePdfPages":case"ReplacePdfPages":!function(){let e=!1;if(a.params.input[0]instanceof Blob){e=!0;const t="/mergepdf/merge.pdf";l.FS.mount(l.WORKERFS,{blobs:[{name:"merge.pdf",data:a.params.input[0]}]},"/mergepdf");const n=l.lengthBytesUTF8(t)+1,s=l._malloc(n);l._memset(s,0,n);for(let e=0;e<t.length;e++)l.HEAPU8[s+e]=t.charCodeAt(e);a.params.input[0]=s,a.params.input.splice(1,0,0)}let t=a.params.input[0],s=a.params.input[1];if("MergePdfPages"===a.func){a.params.input[0]=a.params.input[2],a.params.input[1]=t,a.params.input[2]=s;let e=new l.vectorInt;if(Array.isArray(a.params.input[4]))for(let t=0;t<a.params.input[4].length;t++)e.push_back(a.params.input[4][t]);a.params.input[4]=e,n=r.MergePdfPages.apply(r,a.params.input),e.delete()}else if("ReplacePdfPages"===a.func){a.params.input[0]=t,a.params.input[1]=s;let e=new l.vectorInt,o=new l.vectorInt;if(Array.isArray(a.params.input[3]))for(let t=0;t<a.params.input[3].length;t++)e.push_back(a.params.input[3][t]);if(Array.isArray(a.params.input[4]))for(let e=0;e<a.params.input[4].length;e++)o.push_back(a.params.input[4][e]);a.params.input[3]=e,a.params.input[4]=o,n=r.ReplacePdfPages.apply(r,a.params.input),e.delete(),o.delete()}if(e){const e=l.FS.analyzePath("/mergepdf");for(const t in e.object.contents)e.object.contents[t].contents=void 0;e.object.mount.opts={},l.FS.unmount("/mergepdf")}}();break;case"GetCurrentPdf":!function(){n=r.WriteCurrentPdfFile("");const e=JSON.parse(n);l.customStream.initSize=e.pdfDataSize;const t="output_pdf_"+a.params.insId;var s=l.FS.makedev(3,5);l.FS.registerDevice(s,l.customStream),l.FS.mkdev(t,511,s),n=r.WriteCurrentPdfFile("/"+t);let i=l.save_buf[t],p={};i?(p.blobType="application/pdf",p.pdfData=new Uint8ClampedArray(i.buffer),p.pdfDataSize=i.byteLength):p={errorCode:o.wasmJsSavePdfFailed,errorMessage:"no pdf content return"},n=p,l.save_buf[t]=null}();break;case"UpdateLicense":r.UpdateLicense.apply(r,a.params.input);break;case"UnloadPdfPage":r.UnloadPdfPage.apply(r,a.params.input)}e.context.logDebug(a,a.func+" end, send back begin");let c,m={id:a.id,func:a.func,result:n,memSize:l.HEAPU8.length};if(a.params.srcBuffer){"string"==typeof m.result&&(m.result=JSON.parse(m.result)),m.result.srcBuffer=a.params.srcBuffer;let e=Object.prototype.toString.call(m.result.srcBuffer);"[object ArrayBuffer]"!==e&&"[object Uint8ClampedArray]"!==e||(c=[null!=m.result.srcBuffer.buffer?m.result.srcBuffer.buffer:m.result.srcBuffer])}if(null!=n.imageData)if(c=[],1===n.imageCount){let e=Object.prototype.toString.call(n.imageData);"[object ArrayBuffer]"!==e&&"[object Uint8ClampedArray]"!==e&&"[object Uint8Array]"!=e||(c=[null!=m.result.imageData.buffer?m.result.imageData.buffer:m.result.imageData])}else for(let e=0;e<n.imageCount;e++){let t=Object.prototype.toString.call(n.imageData[e]);"[object ArrayBuffer]"!==t&&"[object Uint8ClampedArray]"!==t&&"[object Uint8Array]"!=t||(c[e]=null!=m.result.imageData[e].buffer?m.result.imageData[e].buffer:m.result.imageData[e])}if(null!=n.pdfData){let e=Object.prototype.toString.call(n.pdfData);"[object ArrayBuffer]"!==e&&"[object Uint8ClampedArray]"!==e&&"[object Uint8Array]"!=e||(c=[null!=m.result.pdfData.buffer?m.result.pdfData.buffer:m.result.pdfData])}null!=c?e.context.sendResult(m,c):e.context.sendResult(m),e.context.logDebug(a,a.func+" end, send back end")}}f=new WeakMap,new x;class G{static fetchRetry(e,t,a,n){let s=t.retries,r=t.retryDelay;return new Promise((function(o,i){const p=function(l){return fetch(e,t).then((function(e){o(e)})).catch((function(e){l<s?function(e,t,s){a&&a(t,n);setTimeout((function(){p(++e)}),r)}(l,e):i(e)}))};return p(0)}))}}class W{static buildWasmFileName(e,t,a,n,s){return e+(n?"-simd":"")+a+"?v="+t}static base64DecToArr(e,t){let a=e.replace(/[^A-Za-z0-9\+\/]/g,""),n=a.length,s=t?Math.ceil((3*n+1>>>2)/t)*t:3*n+1>>>2,r=new Uint8Array(s);for(let e,t,o=0,i=0,p=0;p<n;p++)if(t=3&p,o|=E(this,d,"m",g).call(this,a.charCodeAt(p))<<18-6*t,3===t||n-p==1){for(e=0;e<3&&i<s;e++,i++)r[i]=o>>>(16>>>e&24)&255;o=0}return r}static isWasmSupport(){try{if("object"==typeof WebAssembly&&"function"==typeof WebAssembly.instantiate){let e=new WebAssembly.Module(Uint8Array.of(0,97,115,109,1,0,0,0));if(e instanceof WebAssembly.Module)return new WebAssembly.Instance(e)instanceof WebAssembly.Instance}}catch(e){}return!1}static random(){return(Date.now()%10086).toString(36).slice(2)+Math.random().toString(36).slice(2)}static newBlobInChunks(e,t,a){var n;let s;const r=a||e.byteLength,o=8388608,i=[];for(let t=0;t<r;t+=o)i.push(new Blob([new Uint8Array(null!==(n=e.buffer)&&void 0!==n?n:e,t,Math.min(r-t,o))]));return s=null!=t?new Blob(i,{type:t}):new Blob(i),s}}d=W,g=function(e){return e>64&&e<91?e-65:e>96&&e<123?e-71:e>47&&e<58?e+4:43===e?62:47===e?63:0};class J{constructor(e,t){this.docId=e,this.length=0,this.data=new Uint8Array(null!=t?t:8192),this.position=0}seek(e){this.position=e}close(){if(this.data){const e=this.data.subarray(0,this.length);return this.data=new Uint8Array(1),e}return this.data=new Uint8Array(1),null}getPos(){return this.position}getTotalSize(){return this.length}read(e,t,a){const n=this.data.length;let s;s=a+this.position<n?a:n-this.position;const r=e.subarray(t,t+s),o=this.data.subarray(this.position,this.position+s);return r.set(o),this.position+=s,s}write(e,t,a){const n=this.position+a,s=this.data.length;if(n>this.data.length){const e=16777216<s?104857600<s?.2:.5:1,t=Math.max(s*(1+e),n),a=new Uint8Array(t);a.set(this.data.subarray(0,this.length),0),this.data=a}const r=e.subarray(t,t+a);return this.data.set(r,this.position),this.position+=a,this.position>this.length&&(this.length=this.position),a}}var N={};b=new WeakMap,h=new WeakMap,P=new WeakMap,w=new WeakMap,A=new WeakMap,v=new WeakMap,I=new WeakMap,k=new WeakMap,S=new WeakMap,y=new WeakSet,M=function(){B(this,b,null,"f")},T=function(e,t){E(this,v,"f").postMessage({id:e.id,func:"status",log:t}),e.params&&"function"==typeof e.params.callback&&e.params.callback(t)},D=function(e,t){E(this,v,"f").postMessage({id:e.id,func:"log",log:t}),e.params&&"function"==typeof e.params.callback&&e.params.callback(t)},j=function(e){let t={name:"",promise:void 0,resolve:void 0,reject:void 0,wasmResource:null};return t.name=e,t.promise=new Promise((function(e,a){t.resolve=e,t.reject=a})),t.wasmResource={},t},_=function(t,a){var n,s,r;let o=this,i=Date.now();B(this,w,W.buildWasmFileName(t.prefixName,t.ver,e.wasmExtension,null!==(n=t.useSimd)&&void 0!==n&&n,null!==(s=t.useBrotli)&&void 0!==s&&s),"f"),E(this,y,"m",T).call(this,a,"loading "+E(this,w,"f")+"...");let p=E(this,y,"m",j).call(this,t.name);p.wasmResource.wasmModule=t.wasmModule;let l={print:function(e){e+="",E(o,y,"m",D).call(o,a,e)},printErr:function(e){e+="",p.reject({name:p.name,error:e})},INITIAL_MEMORY:1024*(null!==(r=a.params.initMemory)&&void 0!==r?r:32)*1024,instantiateWasm:function(e,t){if(p.wasmResource.wasmModule)return WebAssembly.instantiate(p.wasmResource.wasmModule,e).then((function(e){E(o,y,"m",D).call(o,a,"instantiate with wasm module"),t(e,p.wasmResource.wasmModule)}),(function(e){e+="",E(o,y,"m",D).call(o,a,"wasm instantiate 2 failed: "+e),p.reject({name:p.name,error:e})})).catch((function(e){E(o,y,"m",D).call(o,a,JSON.stringify(e));let t=e.message+"";p.reject({name:p.name,error:t})}));{const n=E(o,P,"f").retries,s=E(o,P,"f").retryDelay;let r=function(s){return F(this,void 0,void 0,(function*(){try{const r=G.fetchRetry(E(o,h,"f")+E(o,w,"f"),E(o,P,"f"),(function(e,t){return E(o,y,"m",D).call(o,a,e),!0}),a),l=yield r;if(l.ok){let a=yield l.arrayBuffer();const n=yield WebAssembly.instantiate(a,e);return p.wasmResource.wasmModule=n.module,t(n.instance,n.module),n}if(s<n)i(s);else{let e="failed to load wasm binary file, please check.";p.reject({name:p.name,error:e})}}catch(e){if(E(o,y,"m",D).call(o,a,"wasm instantiate 1 failed: "),E(o,y,"m",D).call(o,a,JSON.stringify(e)),E(o,y,"m",D).call(o,a,"attempt "+s+", retries: "+n),s<n)i(s);else{let t=e.message+"";p.reject({name:p.name,error:t})}}}))};function i(e){setTimeout((function(){r(++e)}),s)}r(0)}return{}},onRuntimeInitialized:function(){return F(this,void 0,void 0,(function*(){E(o,y,"m",T).call(o,a,t.name+" wasm initialized, cost "+(Date.now()-i)+" ms"),p.resolve()}))},locateFile:function(e,t){if(e.startsWith(t))return e;if(-1!=e.indexOf("/")){return t+e.substring(e.lastIndexOf("/")+1)}return t+e},save_buf:{},customStream:{id:"",initSize:8192,open:function(e){e.provider=new J(e.path.slice(1),this.initSize)},close:function(e){E(o,b,"f").save_buf[e.path.slice(1)]=e.provider.close()},read:function(e,t,a,n,s){return e.provider.read(t,a,n)},write:function(e,t,a,n,s){return n>0?e.provider.write(t,a,n):0},llseek:function(e,t,a){let n=t;return 1===a?n=e.provider.getPos()+t:2===a&&(n=e.provider.getTotalSize()+t),0>n?-1:(e.provider.seek(n),n)}},fonts:[]};return E(this,A,"f").call(this,l).then((a=>{B(this,b,a,"f"),E(this,I,"f")[t.name]=!0,t.name!==e.imgProc&&(E(this,b,"f").FS.mkdir("/fonts"),E(this,b,"f").FS.mkdir("/loadpdf"),E(this,b,"f").FS.mkdir("/loadtiff"),E(this,b,"f").FS.mkdir("/mergepdf"))})),p},R=function(e){try{this.sendResult(e)}catch(t){for(const t of e.result.modules)t.wasmModule=null;this.sendResult(e)}};var L=new class{constructor(e){y.add(this),b.set(this,null),h.set(this,""),P.set(this,{mode:"cors",credentials:"same-origin"}),w.set(this,""),A.set(this,null),v.set(this,self),I.set(this,[]),k.set(this,void 0),S.set(this,void 0),E(this,y,"m",M).call(this),B(this,A,e,"f")}sendResult(e,t){"object"==typeof e&&E(this,S,"f")&&(e.time=Date.now(),e.cost=e.time-E(this,S,"f"),e.ctime=E(this,S,"f"),B(this,S,void 0,"f")),t?E(this,v,"f").postMessage(e,t):E(this,v,"f").postMessage(e)}logDebug(t,a){if(t&&t.params){let n="";t.params.logLevel===e.logDebug&&(n=`[${Date.now()}][wm][`+t.params.insId+"] "+a,E(this,y,"m",D).call(this,t,n))}}get Module(){return E(this,b,"f")}loadWasm(e){return F(this,void 0,void 0,(function*(){null!=e.params.resourceDir&&B(this,h,e.params.resourceDir,"f"),null!=e.params.fetchOptions&&B(this,P,e.params.fetchOptions,"f");let t=Object.create(null);t.promise=new Promise((function(e,a){t.resolve=e,t.reject=a}));try{let t={modules:[]};if(e.params.module){let a=e.params.module.modulesInfo;for(const n of a){if(E(this,I,"f")[n.name])continue;let a=E(this,y,"m",_).call(this,n,e);yield a.promise,t.modules.push({name:n.name,wasmResource:a.wasmResource})}E(this,y,"m",R).call(this,{id:e.id,func:e.func,result:t,memSize:E(this,b,"f").HEAPU8.length})}}catch(a){let n={errorCode:o.wasmException,errorMessage:JSON.stringify(a),stack:JSON.stringify(a.stack)};if("object"==typeof a&&e.params.module){let t=e.params.module.modulesInfo;n.modules=[],void 0!==a.error?n.errorMessage=a.error:n.errorMessage=void 0!==a.message?a.message:"unknown error",delete n.stack,n.modules.push({name:a.name,wasmModule:null});for(const e of t)n.modules.push({name:e.name,wasmModule:null})}this.sendResult({id:e.id,func:e.func,result:n}),t.reject(n)}return t.promise}))}handleMessage(e){if("string"==typeof e)return;if(null==e.func)return;let t=null;e.params&&(t=e.params.val,this.logDebug(e,"received "+e.func)),null!=t&&(N=t),B(this,k,N,"f");let a=e;if("object"==typeof a&&"object"==typeof a.result&&a.result.errorCode===o.wasmException)return;let n=this.Module,s=this,r={data:e,entryModule:n,context:this,wasmMemoryPtr:null};try{let t=null;if(B(this,S,Date.now(),"f"),"loadWasm"===e.func)return void this.loadWasm(e).catch((function(t){let a=(void 0!==t.message?t.message:"")+""+(void 0!==t.errorMessage?t.errorMessage:"");s.sendResult({id:e.id,func:e.func,result:{errorCode:o.wasmException,errorMessage:a,stack:t.stack}})}));if(e.func,n){this.logDebug(e,"try to init buffer start");let a=Object.prototype.toString.call(e.params.input);if("[object Array]"===Object.prototype.toString.call(e.params.input)){if(a=Object.prototype.toString.call(e.params.input[0]),"[object ArrayBuffer]"===a||"[object Uint8ClampedArray]"===a||"[object Uint8Array]"==a){let s=e.params.input[0].byteLength;t=n._malloc(s),"[object ArrayBuffer]"===a?n.HEAPU8.set(new Uint8Array(e.params.input[0]),t):n.HEAPU8.set(new Uint8Array(e.params.input[0].buffer),t),e.params.srcBuffer=e.params.input[0],e.params.input[0]=t,e.params.input.splice(1,0,s)}}else if("[object ArrayBuffer]"===a||"[object Uint8ClampedArray]"===a||"[object Uint8Array]"==a){let s=e.params.input.byteLength;t=n._malloc(s),"[object ArrayBuffer]"===a?n.HEAPU8.set(new Uint8Array(e.params.input),t):n.HEAPU8.set(new Uint8Array(e.params.input.buffer),t),e.params.srcBuffer=e.params.input,e.params.input=[t,s]}this.logDebug(e,"try to init buffer end")}this.logDebug(e,e.func+" start"),r.wasmMemoryPtr=t,C.process(r),r.wasmMemoryPtr&&n&&n._free(r.wasmMemoryPtr)}catch(t){r.wasmMemoryPtr&&n&&n._free(r.wasmMemoryPtr),"object"!=typeof t&&(t={message:t,stack:""}),s.sendResult({id:e.id,func:e.func,result:{errorCode:o.wasmException,errorMessage:t.message,stack:t.stack},memSize:n.HEAPU8.length})}}}(ImageIOModule);onmessage=function(e){L.handleMessage(e.data)},self.postMessage("ready");class z{}return z.ImageCoreGlue=O,z.PdfReaderGlue=x,z}));
