/*!
* Dynamsoft JavaScript Library
* @product Dynamsoft Image IO WASM Worker JS
* @website http://www.dynamsoft.com
* @copyright Copyright 2025, Dynamsoft Corporation
* @author Dynamsoft
* @version 3.0.0 (2025-06-27T06:39:28.218Z)
* @fileoverview Dynamsoft JavaScript Library for Image IO WASM Worker
* 
*/


var ImageProcModule = (() => {
  var _scriptDir = typeof document !== 'undefined' && document.currentScript ? document.currentScript.src : undefined;
  if (typeof __filename !== 'undefined') _scriptDir = _scriptDir || __filename;
  return (
function(ImageProcModule = {})  {

var Module=typeof ImageProcModule!="undefined"?ImageProcModule:{};var readyPromiseResolve,readyPromiseReject;Module["ready"]=new Promise(function(resolve,reject){readyPromiseResolve=resolve;readyPromiseReject=reject});var moduleOverrides=Object.assign({},Module);var arguments_=[];var thisProgram="./this.program";var quit_=(status,toThrow)=>{throw toThrow};var ENVIRONMENT_IS_WEB=typeof window=="object";var ENVIRONMENT_IS_WORKER=typeof importScripts=="function";var ENVIRONMENT_IS_NODE=typeof process=="object"&&typeof process.versions=="object"&&typeof process.versions.node=="string";var scriptDirectory="";function locateFile(path){if(Module["locateFile"]){return Module["locateFile"](path,scriptDirectory)}return scriptDirectory+path}var read_,readAsync,readBinary,setWindowTitle;if(ENVIRONMENT_IS_NODE){var fs=require("fs");var nodePath=require("path");if(ENVIRONMENT_IS_WORKER){scriptDirectory=nodePath.dirname(scriptDirectory)+"/"}else{scriptDirectory=__dirname+"/"}read_=(filename,binary)=>{filename=isFileURI(filename)?new URL(filename):nodePath.normalize(filename);return fs.readFileSync(filename,binary?undefined:"utf8")};readBinary=filename=>{var ret=read_(filename,true);if(!ret.buffer){ret=new Uint8Array(ret)}return ret};readAsync=(filename,onload,onerror)=>{filename=isFileURI(filename)?new URL(filename):nodePath.normalize(filename);fs.readFile(filename,function(err,data){if(err)onerror(err);else onload(data.buffer)})};if(process.argv.length>1){thisProgram=process.argv[1].replace(/\\/g,"/")}arguments_=process.argv.slice(2);quit_=(status,toThrow)=>{process.exitCode=status;throw toThrow};Module["inspect"]=function(){return"[Emscripten Module object]"}}else if(ENVIRONMENT_IS_WEB||ENVIRONMENT_IS_WORKER){if(ENVIRONMENT_IS_WORKER){scriptDirectory=self.location.href}else if(typeof document!="undefined"&&document.currentScript){scriptDirectory=document.currentScript.src}if(_scriptDir){scriptDirectory=_scriptDir}if(scriptDirectory.indexOf("blob:")!==0){scriptDirectory=scriptDirectory.substr(0,scriptDirectory.replace(/[?#].*/,"").lastIndexOf("/")+1)}else{scriptDirectory=""}{read_=url=>{var xhr=new XMLHttpRequest;xhr.open("GET",url,false);xhr.send(null);return xhr.responseText};if(ENVIRONMENT_IS_WORKER){readBinary=url=>{var xhr=new XMLHttpRequest;xhr.open("GET",url,false);xhr.responseType="arraybuffer";xhr.send(null);return new Uint8Array(xhr.response)}}readAsync=(url,onload,onerror)=>{var xhr=new XMLHttpRequest;xhr.open("GET",url,true);xhr.responseType="arraybuffer";xhr.onload=()=>{if(xhr.status==200||xhr.status==0&&xhr.response){onload(xhr.response);return}onerror()};xhr.onerror=onerror;xhr.send(null)}}setWindowTitle=title=>document.title=title}else{}var out=Module["print"]||console.log.bind(console);var err=Module["printErr"]||console.warn.bind(console);Object.assign(Module,moduleOverrides);moduleOverrides=null;if(Module["arguments"])arguments_=Module["arguments"];if(Module["thisProgram"])thisProgram=Module["thisProgram"];if(Module["quit"])quit_=Module["quit"];var wasmBinary;if(Module["wasmBinary"])wasmBinary=Module["wasmBinary"];var noExitRuntime=Module["noExitRuntime"]||true;if(typeof WebAssembly!="object"){abort("no native wasm support detected")}var wasmMemory;var ABORT=false;var EXITSTATUS;function assert(condition,text){if(!condition){abort(text)}}var UTF8Decoder=typeof TextDecoder!="undefined"?new TextDecoder("utf8"):undefined;function UTF8ArrayToString(heapOrArray,idx,maxBytesToRead){var endIdx=idx+maxBytesToRead;var endPtr=idx;while(heapOrArray[endPtr]&&!(endPtr>=endIdx))++endPtr;if(endPtr-idx>16&&heapOrArray.buffer&&UTF8Decoder){return UTF8Decoder.decode(heapOrArray.subarray(idx,endPtr))}var str="";while(idx<endPtr){var u0=heapOrArray[idx++];if(!(u0&128)){str+=String.fromCharCode(u0);continue}var u1=heapOrArray[idx++]&63;if((u0&224)==192){str+=String.fromCharCode((u0&31)<<6|u1);continue}var u2=heapOrArray[idx++]&63;if((u0&240)==224){u0=(u0&15)<<12|u1<<6|u2}else{u0=(u0&7)<<18|u1<<12|u2<<6|heapOrArray[idx++]&63}if(u0<65536){str+=String.fromCharCode(u0)}else{var ch=u0-65536;str+=String.fromCharCode(55296|ch>>10,56320|ch&1023)}}return str}function UTF8ToString(ptr,maxBytesToRead){return ptr?UTF8ArrayToString(HEAPU8,ptr,maxBytesToRead):""}function stringToUTF8Array(str,heap,outIdx,maxBytesToWrite){if(!(maxBytesToWrite>0))return 0;var startIdx=outIdx;var endIdx=outIdx+maxBytesToWrite-1;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343){var u1=str.charCodeAt(++i);u=65536+((u&1023)<<10)|u1&1023}if(u<=127){if(outIdx>=endIdx)break;heap[outIdx++]=u}else if(u<=2047){if(outIdx+1>=endIdx)break;heap[outIdx++]=192|u>>6;heap[outIdx++]=128|u&63}else if(u<=65535){if(outIdx+2>=endIdx)break;heap[outIdx++]=224|u>>12;heap[outIdx++]=128|u>>6&63;heap[outIdx++]=128|u&63}else{if(outIdx+3>=endIdx)break;heap[outIdx++]=240|u>>18;heap[outIdx++]=128|u>>12&63;heap[outIdx++]=128|u>>6&63;heap[outIdx++]=128|u&63}}heap[outIdx]=0;return outIdx-startIdx}function stringToUTF8(str,outPtr,maxBytesToWrite){return stringToUTF8Array(str,HEAPU8,outPtr,maxBytesToWrite)}function lengthBytesUTF8(str){var len=0;for(var i=0;i<str.length;++i){var c=str.charCodeAt(i);if(c<=127){len++}else if(c<=2047){len+=2}else if(c>=55296&&c<=57343){len+=4;++i}else{len+=3}}return len}var HEAP8,HEAPU8,HEAP16,HEAPU16,HEAP32,HEAPU32,HEAPF32,HEAPF64;function updateMemoryViews(){var b=wasmMemory.buffer;Module["HEAP8"]=HEAP8=new Int8Array(b);Module["HEAP16"]=HEAP16=new Int16Array(b);Module["HEAP32"]=HEAP32=new Int32Array(b);Module["HEAPU8"]=HEAPU8=new Uint8Array(b);Module["HEAPU16"]=HEAPU16=new Uint16Array(b);Module["HEAPU32"]=HEAPU32=new Uint32Array(b);Module["HEAPF32"]=HEAPF32=new Float32Array(b);Module["HEAPF64"]=HEAPF64=new Float64Array(b)}var wasmTable;var __ATPRERUN__=[];var __ATINIT__=[];var __ATPOSTRUN__=[];var runtimeInitialized=false;var runtimeKeepaliveCounter=0;function keepRuntimeAlive(){return noExitRuntime||runtimeKeepaliveCounter>0}function preRun(){if(Module["preRun"]){if(typeof Module["preRun"]=="function")Module["preRun"]=[Module["preRun"]];while(Module["preRun"].length){addOnPreRun(Module["preRun"].shift())}}callRuntimeCallbacks(__ATPRERUN__)}function initRuntime(){runtimeInitialized=true;callRuntimeCallbacks(__ATINIT__)}function postRun(){if(Module["postRun"]){if(typeof Module["postRun"]=="function")Module["postRun"]=[Module["postRun"]];while(Module["postRun"].length){addOnPostRun(Module["postRun"].shift())}}callRuntimeCallbacks(__ATPOSTRUN__)}function addOnPreRun(cb){__ATPRERUN__.unshift(cb)}function addOnInit(cb){__ATINIT__.unshift(cb)}function addOnPostRun(cb){__ATPOSTRUN__.unshift(cb)}var runDependencies=0;var runDependencyWatcher=null;var dependenciesFulfilled=null;function addRunDependency(id){runDependencies++;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}}function removeRunDependency(id){runDependencies--;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}if(runDependencies==0){if(runDependencyWatcher!==null){clearInterval(runDependencyWatcher);runDependencyWatcher=null}if(dependenciesFulfilled){var callback=dependenciesFulfilled;dependenciesFulfilled=null;callback()}}}function abort(what){if(Module["onAbort"]){Module["onAbort"](what)}what="Aborted("+what+")";err(what);ABORT=true;EXITSTATUS=1;what+=". Build with -sASSERTIONS for more info.";var e=new WebAssembly.RuntimeError(what);readyPromiseReject(e);throw e}var dataURIPrefix="data:application/octet-stream;base64,";function isDataURI(filename){return filename.startsWith(dataURIPrefix)}function isFileURI(filename){return filename.startsWith("file://")}var wasmBinaryFile;wasmBinaryFile="ddv-imageproc-simd.wasm";if(!isDataURI(wasmBinaryFile)){wasmBinaryFile=locateFile(wasmBinaryFile)}function getBinary(file){try{if(file==wasmBinaryFile&&wasmBinary){return new Uint8Array(wasmBinary)}if(readBinary){return readBinary(file)}throw"both async and sync fetching of the wasm failed"}catch(err){abort(err)}}function getBinaryPromise(binaryFile){if(!wasmBinary&&(ENVIRONMENT_IS_WEB||ENVIRONMENT_IS_WORKER)){if(typeof fetch=="function"&&!isFileURI(binaryFile)){return fetch(binaryFile,{credentials:"same-origin"}).then(function(response){if(!response["ok"]){throw"failed to load wasm binary file at '"+binaryFile+"'"}return response["arrayBuffer"]()}).catch(function(){return getBinary(binaryFile)})}else{if(readAsync){return new Promise(function(resolve,reject){readAsync(binaryFile,function(response){resolve(new Uint8Array(response))},reject)})}}}return Promise.resolve().then(function(){return getBinary(binaryFile)})}function instantiateArrayBuffer(binaryFile,imports,receiver){return getBinaryPromise(binaryFile).then(function(binary){return WebAssembly.instantiate(binary,imports)}).then(function(instance){return instance}).then(receiver,function(reason){err("failed to asynchronously prepare wasm: "+reason);abort(reason)})}function instantiateAsync(binary,binaryFile,imports,callback){if(!binary&&typeof WebAssembly.instantiateStreaming=="function"&&!isDataURI(binaryFile)&&!isFileURI(binaryFile)&&!ENVIRONMENT_IS_NODE&&typeof fetch=="function"){return fetch(binaryFile,{credentials:"same-origin"}).then(function(response){var result=WebAssembly.instantiateStreaming(response,imports);return result.then(callback,function(reason){err("wasm streaming compile failed: "+reason);err("falling back to ArrayBuffer instantiation");return instantiateArrayBuffer(binaryFile,imports,callback)})})}else{return instantiateArrayBuffer(binaryFile,imports,callback)}}function createWasm(){var info={"a":wasmImports};function receiveInstance(instance,module){var exports=instance.exports;Module["asm"]=exports;wasmMemory=Module["asm"]["fa"];updateMemoryViews();wasmTable=Module["asm"]["Ya"];addOnInit(Module["asm"]["ga"]);removeRunDependency("wasm-instantiate");return exports}addRunDependency("wasm-instantiate");function receiveInstantiationResult(result){receiveInstance(result["instance"])}if(Module["instantiateWasm"]){try{return Module["instantiateWasm"](info,receiveInstance)}catch(e){err("Module.instantiateWasm callback failed with error: "+e);readyPromiseReject(e)}}instantiateAsync(wasmBinary,wasmBinaryFile,info,receiveInstantiationResult).catch(readyPromiseReject);return{}}var tempDouble;var tempI64;function get_domain_js(){var origin;if(typeof global!=="undefined"){origin=""}else if(typeof window!=="undefined"){origin=window.location.origin}else if(typeof self!=="undefined"){origin=self.location.origin||"";if(origin==="blob://"){var href=self.location.href;var pos0=href.indexOf(":")+1;var pos1=href.indexOf("//",pos0)+2;var pos2=href.indexOf("/",pos1);origin=href.substring(pos0,pos2)}}else{origin=""}var lengthBytes=lengthBytesUTF8(origin)+1;var stringOnWasmHeap=_malloc(lengthBytes);stringToUTF8(origin,stringOnWasmHeap,lengthBytes);return stringOnWasmHeap}function ExitStatus(status){this.name="ExitStatus";this.message="Program terminated with exit("+status+")";this.status=status}Module["ExitStatus"]=ExitStatus;function callRuntimeCallbacks(callbacks){while(callbacks.length>0){callbacks.shift()(Module)}}Module["callRuntimeCallbacks"]=callRuntimeCallbacks;function getValue(ptr,type="i8"){if(type.endsWith("*"))type="*";switch(type){case"i1":return HEAP8[ptr>>0];case"i8":return HEAP8[ptr>>0];case"i16":return HEAP16[ptr>>1];case"i32":return HEAP32[ptr>>2];case"i64":return HEAP32[ptr>>2];case"float":return HEAPF32[ptr>>2];case"double":return HEAPF64[ptr>>3];case"*":return HEAPU32[ptr>>2];default:abort("invalid type for getValue: "+type)}}Module["getValue"]=getValue;function setValue(ptr,value,type="i8"){if(type.endsWith("*"))type="*";switch(type){case"i1":HEAP8[ptr>>0]=value;break;case"i8":HEAP8[ptr>>0]=value;break;case"i16":HEAP16[ptr>>1]=value;break;case"i32":HEAP32[ptr>>2]=value;break;case"i64":tempI64=[value>>>0,(tempDouble=value,+Math.abs(tempDouble)>=1?tempDouble>0?(Math.min(+Math.floor(tempDouble/4294967296),4294967295)|0)>>>0:~~+Math.ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[ptr>>2]=tempI64[0],HEAP32[ptr+4>>2]=tempI64[1];break;case"float":HEAPF32[ptr>>2]=value;break;case"double":HEAPF64[ptr>>3]=value;break;case"*":HEAPU32[ptr>>2]=value;break;default:abort("invalid type for setValue: "+type)}}Module["setValue"]=setValue;function ExceptionInfo(excPtr){this.excPtr=excPtr;this.ptr=excPtr-24;this.set_type=function(type){HEAPU32[this.ptr+4>>2]=type};this.get_type=function(){return HEAPU32[this.ptr+4>>2]};this.set_destructor=function(destructor){HEAPU32[this.ptr+8>>2]=destructor};this.get_destructor=function(){return HEAPU32[this.ptr+8>>2]};this.set_refcount=function(refcount){HEAP32[this.ptr>>2]=refcount};this.set_caught=function(caught){caught=caught?1:0;HEAP8[this.ptr+12>>0]=caught};this.get_caught=function(){return HEAP8[this.ptr+12>>0]!=0};this.set_rethrown=function(rethrown){rethrown=rethrown?1:0;HEAP8[this.ptr+13>>0]=rethrown};this.get_rethrown=function(){return HEAP8[this.ptr+13>>0]!=0};this.init=function(type,destructor){this.set_adjusted_ptr(0);this.set_type(type);this.set_destructor(destructor);this.set_refcount(0);this.set_caught(false);this.set_rethrown(false)};this.add_ref=function(){var value=HEAP32[this.ptr>>2];HEAP32[this.ptr>>2]=value+1};this.release_ref=function(){var prev=HEAP32[this.ptr>>2];HEAP32[this.ptr>>2]=prev-1;return prev===1};this.set_adjusted_ptr=function(adjustedPtr){HEAPU32[this.ptr+16>>2]=adjustedPtr};this.get_adjusted_ptr=function(){return HEAPU32[this.ptr+16>>2]};this.get_exception_ptr=function(){var isPointer=___cxa_is_pointer_type(this.get_type());if(isPointer){return HEAPU32[this.excPtr>>2]}var adjusted=this.get_adjusted_ptr();if(adjusted!==0)return adjusted;return this.excPtr}}Module["ExceptionInfo"]=ExceptionInfo;var exceptionLast=0;Module["exceptionLast"]=exceptionLast;var uncaughtExceptionCount=0;Module["uncaughtExceptionCount"]=uncaughtExceptionCount;function ___cxa_throw(ptr,type,destructor){var info=new ExceptionInfo(ptr);info.init(type,destructor);exceptionLast=ptr;uncaughtExceptionCount++;throw ptr}Module["___cxa_throw"]=___cxa_throw;function setErrNo(value){HEAP32[___errno_location()>>2]=value;return value}Module["setErrNo"]=setErrNo;var SYSCALLS={varargs:undefined,get:function(){SYSCALLS.varargs+=4;var ret=HEAP32[SYSCALLS.varargs-4>>2];return ret},getStr:function(ptr){var ret=UTF8ToString(ptr);return ret}};Module["SYSCALLS"]=SYSCALLS;function ___syscall_fcntl64(fd,cmd,varargs){SYSCALLS.varargs=varargs;return 0}Module["___syscall_fcntl64"]=___syscall_fcntl64;function ___syscall_fstat64(fd,buf){}Module["___syscall_fstat64"]=___syscall_fstat64;function ___syscall_getdents64(fd,dirp,count){}Module["___syscall_getdents64"]=___syscall_getdents64;function ___syscall_ioctl(fd,op,varargs){SYSCALLS.varargs=varargs;return 0}Module["___syscall_ioctl"]=___syscall_ioctl;function ___syscall_lstat64(path,buf){}Module["___syscall_lstat64"]=___syscall_lstat64;function ___syscall_newfstatat(dirfd,path,buf,flags){}Module["___syscall_newfstatat"]=___syscall_newfstatat;function ___syscall_openat(dirfd,path,flags,varargs){SYSCALLS.varargs=varargs}Module["___syscall_openat"]=___syscall_openat;function ___syscall_stat64(path,buf){}Module["___syscall_stat64"]=___syscall_stat64;function __embind_register_bigint(primitiveType,name,size,minRange,maxRange){}Module["__embind_register_bigint"]=__embind_register_bigint;function getShiftFromSize(size){switch(size){case 1:return 0;case 2:return 1;case 4:return 2;case 8:return 3;default:throw new TypeError("Unknown type size: "+size)}}Module["getShiftFromSize"]=getShiftFromSize;function embind_init_charCodes(){var codes=new Array(256);for(var i=0;i<256;++i){codes[i]=String.fromCharCode(i)}embind_charCodes=codes}Module["embind_init_charCodes"]=embind_init_charCodes;var embind_charCodes=undefined;Module["embind_charCodes"]=embind_charCodes;function readLatin1String(ptr){var ret="";var c=ptr;while(HEAPU8[c]){ret+=embind_charCodes[HEAPU8[c++]]}return ret}Module["readLatin1String"]=readLatin1String;var awaitingDependencies={};Module["awaitingDependencies"]=awaitingDependencies;var registeredTypes={};Module["registeredTypes"]=registeredTypes;var typeDependencies={};Module["typeDependencies"]=typeDependencies;var char_0=48;Module["char_0"]=char_0;var char_9=57;Module["char_9"]=char_9;function makeLegalFunctionName(name){if(undefined===name){return"_unknown"}name=name.replace(/[^a-zA-Z0-9_]/g,"$");var f=name.charCodeAt(0);if(f>=char_0&&f<=char_9){return"_"+name}return name}Module["makeLegalFunctionName"]=makeLegalFunctionName;function createNamedFunction(name,body){name=makeLegalFunctionName(name);return{[name]:function(){return body.apply(this,arguments)}}[name]}Module["createNamedFunction"]=createNamedFunction;function extendError(baseErrorType,errorName){var errorClass=createNamedFunction(errorName,function(message){this.name=errorName;this.message=message;var stack=new Error(message).stack;if(stack!==undefined){this.stack=this.toString()+"\n"+stack.replace(/^Error(:[^\n]*)?\n/,"")}});errorClass.prototype=Object.create(baseErrorType.prototype);errorClass.prototype.constructor=errorClass;errorClass.prototype.toString=function(){if(this.message===undefined){return this.name}else{return this.name+": "+this.message}};return errorClass}Module["extendError"]=extendError;var BindingError=undefined;Module["BindingError"]=BindingError;function throwBindingError(message){throw new BindingError(message)}Module["throwBindingError"]=throwBindingError;var InternalError=undefined;Module["InternalError"]=InternalError;function throwInternalError(message){throw new InternalError(message)}Module["throwInternalError"]=throwInternalError;function whenDependentTypesAreResolved(myTypes,dependentTypes,getTypeConverters){myTypes.forEach(function(type){typeDependencies[type]=dependentTypes});function onComplete(typeConverters){var myTypeConverters=getTypeConverters(typeConverters);if(myTypeConverters.length!==myTypes.length){throwInternalError("Mismatched type converter count")}for(var i=0;i<myTypes.length;++i){registerType(myTypes[i],myTypeConverters[i])}}var typeConverters=new Array(dependentTypes.length);var unregisteredTypes=[];var registered=0;dependentTypes.forEach((dt,i)=>{if(registeredTypes.hasOwnProperty(dt)){typeConverters[i]=registeredTypes[dt]}else{unregisteredTypes.push(dt);if(!awaitingDependencies.hasOwnProperty(dt)){awaitingDependencies[dt]=[]}awaitingDependencies[dt].push(()=>{typeConverters[i]=registeredTypes[dt];++registered;if(registered===unregisteredTypes.length){onComplete(typeConverters)}})}});if(0===unregisteredTypes.length){onComplete(typeConverters)}}Module["whenDependentTypesAreResolved"]=whenDependentTypesAreResolved;function registerType(rawType,registeredInstance,options={}){if(!("argPackAdvance"in registeredInstance)){throw new TypeError("registerType registeredInstance requires argPackAdvance")}var name=registeredInstance.name;if(!rawType){throwBindingError('type "'+name+'" must have a positive integer typeid pointer')}if(registeredTypes.hasOwnProperty(rawType)){if(options.ignoreDuplicateRegistrations){return}else{throwBindingError("Cannot register type '"+name+"' twice")}}registeredTypes[rawType]=registeredInstance;delete typeDependencies[rawType];if(awaitingDependencies.hasOwnProperty(rawType)){var callbacks=awaitingDependencies[rawType];delete awaitingDependencies[rawType];callbacks.forEach(cb=>cb())}}Module["registerType"]=registerType;function __embind_register_bool(rawType,name,size,trueValue,falseValue){var shift=getShiftFromSize(size);name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":function(wt){return!!wt},"toWireType":function(destructors,o){return o?trueValue:falseValue},"argPackAdvance":8,"readValueFromPointer":function(pointer){var heap;if(size===1){heap=HEAP8}else if(size===2){heap=HEAP16}else if(size===4){heap=HEAP32}else{throw new TypeError("Unknown boolean type size: "+name)}return this["fromWireType"](heap[pointer>>shift])},destructorFunction:null})}Module["__embind_register_bool"]=__embind_register_bool;function ClassHandle_isAliasOf(other){if(!(this instanceof ClassHandle)){return false}if(!(other instanceof ClassHandle)){return false}var leftClass=this.$$.ptrType.registeredClass;var left=this.$$.ptr;var rightClass=other.$$.ptrType.registeredClass;var right=other.$$.ptr;while(leftClass.baseClass){left=leftClass.upcast(left);leftClass=leftClass.baseClass}while(rightClass.baseClass){right=rightClass.upcast(right);rightClass=rightClass.baseClass}return leftClass===rightClass&&left===right}Module["ClassHandle_isAliasOf"]=ClassHandle_isAliasOf;function shallowCopyInternalPointer(o){return{count:o.count,deleteScheduled:o.deleteScheduled,preservePointerOnDelete:o.preservePointerOnDelete,ptr:o.ptr,ptrType:o.ptrType,smartPtr:o.smartPtr,smartPtrType:o.smartPtrType}}Module["shallowCopyInternalPointer"]=shallowCopyInternalPointer;function throwInstanceAlreadyDeleted(obj){function getInstanceTypeName(handle){return handle.$$.ptrType.registeredClass.name}throwBindingError(getInstanceTypeName(obj)+" instance already deleted")}Module["throwInstanceAlreadyDeleted"]=throwInstanceAlreadyDeleted;var finalizationRegistry=false;Module["finalizationRegistry"]=finalizationRegistry;function detachFinalizer(handle){}Module["detachFinalizer"]=detachFinalizer;function runDestructor($$){if($$.smartPtr){$$.smartPtrType.rawDestructor($$.smartPtr)}else{$$.ptrType.registeredClass.rawDestructor($$.ptr)}}Module["runDestructor"]=runDestructor;function releaseClassHandle($$){$$.count.value-=1;var toDelete=0===$$.count.value;if(toDelete){runDestructor($$)}}Module["releaseClassHandle"]=releaseClassHandle;function downcastPointer(ptr,ptrClass,desiredClass){if(ptrClass===desiredClass){return ptr}if(undefined===desiredClass.baseClass){return null}var rv=downcastPointer(ptr,ptrClass,desiredClass.baseClass);if(rv===null){return null}return desiredClass.downcast(rv)}Module["downcastPointer"]=downcastPointer;var registeredPointers={};Module["registeredPointers"]=registeredPointers;function getInheritedInstanceCount(){return Object.keys(registeredInstances).length}Module["getInheritedInstanceCount"]=getInheritedInstanceCount;function getLiveInheritedInstances(){var rv=[];for(var k in registeredInstances){if(registeredInstances.hasOwnProperty(k)){rv.push(registeredInstances[k])}}return rv}Module["getLiveInheritedInstances"]=getLiveInheritedInstances;var deletionQueue=[];Module["deletionQueue"]=deletionQueue;function flushPendingDeletes(){while(deletionQueue.length){var obj=deletionQueue.pop();obj.$$.deleteScheduled=false;obj["delete"]()}}Module["flushPendingDeletes"]=flushPendingDeletes;var delayFunction=undefined;Module["delayFunction"]=delayFunction;function setDelayFunction(fn){delayFunction=fn;if(deletionQueue.length&&delayFunction){delayFunction(flushPendingDeletes)}}Module["setDelayFunction"]=setDelayFunction;function init_embind(){Module["getInheritedInstanceCount"]=getInheritedInstanceCount;Module["getLiveInheritedInstances"]=getLiveInheritedInstances;Module["flushPendingDeletes"]=flushPendingDeletes;Module["setDelayFunction"]=setDelayFunction}Module["init_embind"]=init_embind;var registeredInstances={};Module["registeredInstances"]=registeredInstances;function getBasestPointer(class_,ptr){if(ptr===undefined){throwBindingError("ptr should not be undefined")}while(class_.baseClass){ptr=class_.upcast(ptr);class_=class_.baseClass}return ptr}Module["getBasestPointer"]=getBasestPointer;function getInheritedInstance(class_,ptr){ptr=getBasestPointer(class_,ptr);return registeredInstances[ptr]}Module["getInheritedInstance"]=getInheritedInstance;function makeClassHandle(prototype,record){if(!record.ptrType||!record.ptr){throwInternalError("makeClassHandle requires ptr and ptrType")}var hasSmartPtrType=!!record.smartPtrType;var hasSmartPtr=!!record.smartPtr;if(hasSmartPtrType!==hasSmartPtr){throwInternalError("Both smartPtrType and smartPtr must be specified")}record.count={value:1};return attachFinalizer(Object.create(prototype,{$$:{value:record}}))}Module["makeClassHandle"]=makeClassHandle;function RegisteredPointer_fromWireType(ptr){var rawPointer=this.getPointee(ptr);if(!rawPointer){this.destructor(ptr);return null}var registeredInstance=getInheritedInstance(this.registeredClass,rawPointer);if(undefined!==registeredInstance){if(0===registeredInstance.$$.count.value){registeredInstance.$$.ptr=rawPointer;registeredInstance.$$.smartPtr=ptr;return registeredInstance["clone"]()}else{var rv=registeredInstance["clone"]();this.destructor(ptr);return rv}}function makeDefaultHandle(){if(this.isSmartPointer){return makeClassHandle(this.registeredClass.instancePrototype,{ptrType:this.pointeeType,ptr:rawPointer,smartPtrType:this,smartPtr:ptr})}else{return makeClassHandle(this.registeredClass.instancePrototype,{ptrType:this,ptr:ptr})}}var actualType=this.registeredClass.getActualType(rawPointer);var registeredPointerRecord=registeredPointers[actualType];if(!registeredPointerRecord){return makeDefaultHandle.call(this)}var toType;if(this.isConst){toType=registeredPointerRecord.constPointerType}else{toType=registeredPointerRecord.pointerType}var dp=downcastPointer(rawPointer,this.registeredClass,toType.registeredClass);if(dp===null){return makeDefaultHandle.call(this)}if(this.isSmartPointer){return makeClassHandle(toType.registeredClass.instancePrototype,{ptrType:toType,ptr:dp,smartPtrType:this,smartPtr:ptr})}else{return makeClassHandle(toType.registeredClass.instancePrototype,{ptrType:toType,ptr:dp})}}Module["RegisteredPointer_fromWireType"]=RegisteredPointer_fromWireType;function attachFinalizer(handle){if("undefined"===typeof FinalizationRegistry){attachFinalizer=handle=>handle;return handle}finalizationRegistry=new FinalizationRegistry(info=>{releaseClassHandle(info.$$)});attachFinalizer=handle=>{var $$=handle.$$;var hasSmartPtr=!!$$.smartPtr;if(hasSmartPtr){var info={$$:$$};finalizationRegistry.register(handle,info,handle)}return handle};detachFinalizer=handle=>finalizationRegistry.unregister(handle);return attachFinalizer(handle)}Module["attachFinalizer"]=attachFinalizer;function ClassHandle_clone(){if(!this.$$.ptr){throwInstanceAlreadyDeleted(this)}if(this.$$.preservePointerOnDelete){this.$$.count.value+=1;return this}else{var clone=attachFinalizer(Object.create(Object.getPrototypeOf(this),{$$:{value:shallowCopyInternalPointer(this.$$)}}));clone.$$.count.value+=1;clone.$$.deleteScheduled=false;return clone}}Module["ClassHandle_clone"]=ClassHandle_clone;function ClassHandle_delete(){if(!this.$$.ptr){throwInstanceAlreadyDeleted(this)}if(this.$$.deleteScheduled&&!this.$$.preservePointerOnDelete){throwBindingError("Object already scheduled for deletion")}detachFinalizer(this);releaseClassHandle(this.$$);if(!this.$$.preservePointerOnDelete){this.$$.smartPtr=undefined;this.$$.ptr=undefined}}Module["ClassHandle_delete"]=ClassHandle_delete;function ClassHandle_isDeleted(){return!this.$$.ptr}Module["ClassHandle_isDeleted"]=ClassHandle_isDeleted;function ClassHandle_deleteLater(){if(!this.$$.ptr){throwInstanceAlreadyDeleted(this)}if(this.$$.deleteScheduled&&!this.$$.preservePointerOnDelete){throwBindingError("Object already scheduled for deletion")}deletionQueue.push(this);if(deletionQueue.length===1&&delayFunction){delayFunction(flushPendingDeletes)}this.$$.deleteScheduled=true;return this}Module["ClassHandle_deleteLater"]=ClassHandle_deleteLater;function init_ClassHandle(){ClassHandle.prototype["isAliasOf"]=ClassHandle_isAliasOf;ClassHandle.prototype["clone"]=ClassHandle_clone;ClassHandle.prototype["delete"]=ClassHandle_delete;ClassHandle.prototype["isDeleted"]=ClassHandle_isDeleted;ClassHandle.prototype["deleteLater"]=ClassHandle_deleteLater}Module["init_ClassHandle"]=init_ClassHandle;function ClassHandle(){}Module["ClassHandle"]=ClassHandle;function ensureOverloadTable(proto,methodName,humanName){if(undefined===proto[methodName].overloadTable){var prevFunc=proto[methodName];proto[methodName]=function(){if(!proto[methodName].overloadTable.hasOwnProperty(arguments.length)){throwBindingError("Function '"+humanName+"' called with an invalid number of arguments ("+arguments.length+") - expects one of ("+proto[methodName].overloadTable+")!")}return proto[methodName].overloadTable[arguments.length].apply(this,arguments)};proto[methodName].overloadTable=[];proto[methodName].overloadTable[prevFunc.argCount]=prevFunc}}Module["ensureOverloadTable"]=ensureOverloadTable;function exposePublicSymbol(name,value,numArguments){if(Module.hasOwnProperty(name)){if(undefined===numArguments||undefined!==Module[name].overloadTable&&undefined!==Module[name].overloadTable[numArguments]){throwBindingError("Cannot register public name '"+name+"' twice")}ensureOverloadTable(Module,name,name);if(Module.hasOwnProperty(numArguments)){throwBindingError("Cannot register multiple overloads of a function with the same number of arguments ("+numArguments+")!")}Module[name].overloadTable[numArguments]=value}else{Module[name]=value;if(undefined!==numArguments){Module[name].numArguments=numArguments}}}Module["exposePublicSymbol"]=exposePublicSymbol;function RegisteredClass(name,constructor,instancePrototype,rawDestructor,baseClass,getActualType,upcast,downcast){this.name=name;this.constructor=constructor;this.instancePrototype=instancePrototype;this.rawDestructor=rawDestructor;this.baseClass=baseClass;this.getActualType=getActualType;this.upcast=upcast;this.downcast=downcast;this.pureVirtualFunctions=[]}Module["RegisteredClass"]=RegisteredClass;function upcastPointer(ptr,ptrClass,desiredClass){while(ptrClass!==desiredClass){if(!ptrClass.upcast){throwBindingError("Expected null or instance of "+desiredClass.name+", got an instance of "+ptrClass.name)}ptr=ptrClass.upcast(ptr);ptrClass=ptrClass.baseClass}return ptr}Module["upcastPointer"]=upcastPointer;function constNoSmartPtrRawPointerToWireType(destructors,handle){if(handle===null){if(this.isReference){throwBindingError("null is not a valid "+this.name)}return 0}if(!handle.$$){throwBindingError('Cannot pass "'+embindRepr(handle)+'" as a '+this.name)}if(!handle.$$.ptr){throwBindingError("Cannot pass deleted object as a pointer of type "+this.name)}var handleClass=handle.$$.ptrType.registeredClass;var ptr=upcastPointer(handle.$$.ptr,handleClass,this.registeredClass);return ptr}Module["constNoSmartPtrRawPointerToWireType"]=constNoSmartPtrRawPointerToWireType;function genericPointerToWireType(destructors,handle){var ptr;if(handle===null){if(this.isReference){throwBindingError("null is not a valid "+this.name)}if(this.isSmartPointer){ptr=this.rawConstructor();if(destructors!==null){destructors.push(this.rawDestructor,ptr)}return ptr}else{return 0}}if(!handle.$$){throwBindingError('Cannot pass "'+embindRepr(handle)+'" as a '+this.name)}if(!handle.$$.ptr){throwBindingError("Cannot pass deleted object as a pointer of type "+this.name)}if(!this.isConst&&handle.$$.ptrType.isConst){throwBindingError("Cannot convert argument of type "+(handle.$$.smartPtrType?handle.$$.smartPtrType.name:handle.$$.ptrType.name)+" to parameter type "+this.name)}var handleClass=handle.$$.ptrType.registeredClass;ptr=upcastPointer(handle.$$.ptr,handleClass,this.registeredClass);if(this.isSmartPointer){if(undefined===handle.$$.smartPtr){throwBindingError("Passing raw pointer to smart pointer is illegal")}switch(this.sharingPolicy){case 0:if(handle.$$.smartPtrType===this){ptr=handle.$$.smartPtr}else{throwBindingError("Cannot convert argument of type "+(handle.$$.smartPtrType?handle.$$.smartPtrType.name:handle.$$.ptrType.name)+" to parameter type "+this.name)}break;case 1:ptr=handle.$$.smartPtr;break;case 2:if(handle.$$.smartPtrType===this){ptr=handle.$$.smartPtr}else{var clonedHandle=handle["clone"]();ptr=this.rawShare(ptr,Emval.toHandle(function(){clonedHandle["delete"]()}));if(destructors!==null){destructors.push(this.rawDestructor,ptr)}}break;default:throwBindingError("Unsupporting sharing policy")}}return ptr}Module["genericPointerToWireType"]=genericPointerToWireType;function nonConstNoSmartPtrRawPointerToWireType(destructors,handle){if(handle===null){if(this.isReference){throwBindingError("null is not a valid "+this.name)}return 0}if(!handle.$$){throwBindingError('Cannot pass "'+embindRepr(handle)+'" as a '+this.name)}if(!handle.$$.ptr){throwBindingError("Cannot pass deleted object as a pointer of type "+this.name)}if(handle.$$.ptrType.isConst){throwBindingError("Cannot convert argument of type "+handle.$$.ptrType.name+" to parameter type "+this.name)}var handleClass=handle.$$.ptrType.registeredClass;var ptr=upcastPointer(handle.$$.ptr,handleClass,this.registeredClass);return ptr}Module["nonConstNoSmartPtrRawPointerToWireType"]=nonConstNoSmartPtrRawPointerToWireType;function simpleReadValueFromPointer(pointer){return this["fromWireType"](HEAP32[pointer>>2])}Module["simpleReadValueFromPointer"]=simpleReadValueFromPointer;function RegisteredPointer_getPointee(ptr){if(this.rawGetPointee){ptr=this.rawGetPointee(ptr)}return ptr}Module["RegisteredPointer_getPointee"]=RegisteredPointer_getPointee;function RegisteredPointer_destructor(ptr){if(this.rawDestructor){this.rawDestructor(ptr)}}Module["RegisteredPointer_destructor"]=RegisteredPointer_destructor;function RegisteredPointer_deleteObject(handle){if(handle!==null){handle["delete"]()}}Module["RegisteredPointer_deleteObject"]=RegisteredPointer_deleteObject;function init_RegisteredPointer(){RegisteredPointer.prototype.getPointee=RegisteredPointer_getPointee;RegisteredPointer.prototype.destructor=RegisteredPointer_destructor;RegisteredPointer.prototype["argPackAdvance"]=8;RegisteredPointer.prototype["readValueFromPointer"]=simpleReadValueFromPointer;RegisteredPointer.prototype["deleteObject"]=RegisteredPointer_deleteObject;RegisteredPointer.prototype["fromWireType"]=RegisteredPointer_fromWireType}Module["init_RegisteredPointer"]=init_RegisteredPointer;function RegisteredPointer(name,registeredClass,isReference,isConst,isSmartPointer,pointeeType,sharingPolicy,rawGetPointee,rawConstructor,rawShare,rawDestructor){this.name=name;this.registeredClass=registeredClass;this.isReference=isReference;this.isConst=isConst;this.isSmartPointer=isSmartPointer;this.pointeeType=pointeeType;this.sharingPolicy=sharingPolicy;this.rawGetPointee=rawGetPointee;this.rawConstructor=rawConstructor;this.rawShare=rawShare;this.rawDestructor=rawDestructor;if(!isSmartPointer&&registeredClass.baseClass===undefined){if(isConst){this["toWireType"]=constNoSmartPtrRawPointerToWireType;this.destructorFunction=null}else{this["toWireType"]=nonConstNoSmartPtrRawPointerToWireType;this.destructorFunction=null}}else{this["toWireType"]=genericPointerToWireType}}Module["RegisteredPointer"]=RegisteredPointer;function replacePublicSymbol(name,value,numArguments){if(!Module.hasOwnProperty(name)){throwInternalError("Replacing nonexistant public symbol")}if(undefined!==Module[name].overloadTable&&undefined!==numArguments){Module[name].overloadTable[numArguments]=value}else{Module[name]=value;Module[name].argCount=numArguments}}Module["replacePublicSymbol"]=replacePublicSymbol;function dynCallLegacy(sig,ptr,args){var f=Module["dynCall_"+sig];return args&&args.length?f.apply(null,[ptr].concat(args)):f.call(null,ptr)}Module["dynCallLegacy"]=dynCallLegacy;var wasmTableMirror=[];Module["wasmTableMirror"]=wasmTableMirror;function getWasmTableEntry(funcPtr){var func=wasmTableMirror[funcPtr];if(!func){if(funcPtr>=wasmTableMirror.length)wasmTableMirror.length=funcPtr+1;wasmTableMirror[funcPtr]=func=wasmTable.get(funcPtr)}return func}Module["getWasmTableEntry"]=getWasmTableEntry;function dynCall(sig,ptr,args){if(sig.includes("j")){return dynCallLegacy(sig,ptr,args)}var rtn=getWasmTableEntry(ptr).apply(null,args);return rtn}Module["dynCall"]=dynCall;function getDynCaller(sig,ptr){var argCache=[];return function(){argCache.length=0;Object.assign(argCache,arguments);return dynCall(sig,ptr,argCache)}}Module["getDynCaller"]=getDynCaller;function embind__requireFunction(signature,rawFunction){signature=readLatin1String(signature);function makeDynCaller(){if(signature.includes("j")){return getDynCaller(signature,rawFunction)}return getWasmTableEntry(rawFunction)}var fp=makeDynCaller();if(typeof fp!="function"){throwBindingError("unknown function pointer with signature "+signature+": "+rawFunction)}return fp}Module["embind__requireFunction"]=embind__requireFunction;var UnboundTypeError=undefined;Module["UnboundTypeError"]=UnboundTypeError;function getTypeName(type){var ptr=___getTypeName(type);var rv=readLatin1String(ptr);_free(ptr);return rv}Module["getTypeName"]=getTypeName;function throwUnboundTypeError(message,types){var unboundTypes=[];var seen={};function visit(type){if(seen[type]){return}if(registeredTypes[type]){return}if(typeDependencies[type]){typeDependencies[type].forEach(visit);return}unboundTypes.push(type);seen[type]=true}types.forEach(visit);throw new UnboundTypeError(message+": "+unboundTypes.map(getTypeName).join([", "]))}Module["throwUnboundTypeError"]=throwUnboundTypeError;function __embind_register_class(rawType,rawPointerType,rawConstPointerType,baseClassRawType,getActualTypeSignature,getActualType,upcastSignature,upcast,downcastSignature,downcast,name,destructorSignature,rawDestructor){name=readLatin1String(name);getActualType=embind__requireFunction(getActualTypeSignature,getActualType);if(upcast){upcast=embind__requireFunction(upcastSignature,upcast)}if(downcast){downcast=embind__requireFunction(downcastSignature,downcast)}rawDestructor=embind__requireFunction(destructorSignature,rawDestructor);var legalFunctionName=makeLegalFunctionName(name);exposePublicSymbol(legalFunctionName,function(){throwUnboundTypeError("Cannot construct "+name+" due to unbound types",[baseClassRawType])});whenDependentTypesAreResolved([rawType,rawPointerType,rawConstPointerType],baseClassRawType?[baseClassRawType]:[],function(base){base=base[0];var baseClass;var basePrototype;if(baseClassRawType){baseClass=base.registeredClass;basePrototype=baseClass.instancePrototype}else{basePrototype=ClassHandle.prototype}var constructor=createNamedFunction(legalFunctionName,function(){if(Object.getPrototypeOf(this)!==instancePrototype){throw new BindingError("Use 'new' to construct "+name)}if(undefined===registeredClass.constructor_body){throw new BindingError(name+" has no accessible constructor")}var body=registeredClass.constructor_body[arguments.length];if(undefined===body){throw new BindingError("Tried to invoke ctor of "+name+" with invalid number of parameters ("+arguments.length+") - expected ("+Object.keys(registeredClass.constructor_body).toString()+") parameters instead!")}return body.apply(this,arguments)});var instancePrototype=Object.create(basePrototype,{constructor:{value:constructor}});constructor.prototype=instancePrototype;var registeredClass=new RegisteredClass(name,constructor,instancePrototype,rawDestructor,baseClass,getActualType,upcast,downcast);var referenceConverter=new RegisteredPointer(name,registeredClass,true,false,false);var pointerConverter=new RegisteredPointer(name+"*",registeredClass,false,false,false);var constPointerConverter=new RegisteredPointer(name+" const*",registeredClass,false,true,false);registeredPointers[rawType]={pointerType:pointerConverter,constPointerType:constPointerConverter};replacePublicSymbol(legalFunctionName,constructor);return[referenceConverter,pointerConverter,constPointerConverter]})}Module["__embind_register_class"]=__embind_register_class;function heap32VectorToArray(count,firstElement){var array=[];for(var i=0;i<count;i++){array.push(HEAPU32[firstElement+i*4>>2])}return array}Module["heap32VectorToArray"]=heap32VectorToArray;function runDestructors(destructors){while(destructors.length){var ptr=destructors.pop();var del=destructors.pop();del(ptr)}}Module["runDestructors"]=runDestructors;function new_(constructor,argumentList){if(!(constructor instanceof Function)){throw new TypeError("new_ called with constructor type "+typeof constructor+" which is not a function")}if(constructor===Function){throw new Error("new_ cannot create a new Function with DYNAMIC_EXECUTION == 0.")}var dummy=createNamedFunction(constructor.name||"unknownFunctionName",function(){});dummy.prototype=constructor.prototype;var obj=new dummy;var r=constructor.apply(obj,argumentList);return r instanceof Object?r:obj}Module["new_"]=new_;function craftInvokerFunction(humanName,argTypes,classType,cppInvokerFunc,cppTargetFunc,isAsync){var argCount=argTypes.length;if(argCount<2){throwBindingError("argTypes array size mismatch! Must at least get return value and 'this' types!")}var isClassMethodFunc=argTypes[1]!==null&&classType!==null;var needsDestructorStack=false;for(var i=1;i<argTypes.length;++i){if(argTypes[i]!==null&&argTypes[i].destructorFunction===undefined){needsDestructorStack=true;break}}var returns=argTypes[0].name!=="void";var expectedArgCount=argCount-2;var argsWired=new Array(expectedArgCount);var invokerFuncArgs=[];var destructors=[];return function(){if(arguments.length!==expectedArgCount){throwBindingError("function "+humanName+" called with "+arguments.length+" arguments, expected "+expectedArgCount+" args!")}destructors.length=0;var thisWired;invokerFuncArgs.length=isClassMethodFunc?2:1;invokerFuncArgs[0]=cppTargetFunc;if(isClassMethodFunc){thisWired=argTypes[1]["toWireType"](destructors,this);invokerFuncArgs[1]=thisWired}for(var i=0;i<expectedArgCount;++i){argsWired[i]=argTypes[i+2]["toWireType"](destructors,arguments[i]);invokerFuncArgs.push(argsWired[i])}var rv=cppInvokerFunc.apply(null,invokerFuncArgs);function onDone(rv){if(needsDestructorStack){runDestructors(destructors)}else{for(var i=isClassMethodFunc?1:2;i<argTypes.length;i++){var param=i===1?thisWired:argsWired[i-2];if(argTypes[i].destructorFunction!==null){argTypes[i].destructorFunction(param)}}}if(returns){return argTypes[0]["fromWireType"](rv)}}return onDone(rv)}}Module["craftInvokerFunction"]=craftInvokerFunction;function __embind_register_class_constructor(rawClassType,argCount,rawArgTypesAddr,invokerSignature,invoker,rawConstructor){assert(argCount>0);var rawArgTypes=heap32VectorToArray(argCount,rawArgTypesAddr);invoker=embind__requireFunction(invokerSignature,invoker);whenDependentTypesAreResolved([],[rawClassType],function(classType){classType=classType[0];var humanName="constructor "+classType.name;if(undefined===classType.registeredClass.constructor_body){classType.registeredClass.constructor_body=[]}if(undefined!==classType.registeredClass.constructor_body[argCount-1]){throw new BindingError("Cannot register multiple constructors with identical number of parameters ("+(argCount-1)+") for class '"+classType.name+"'! Overload resolution is currently only performed using the parameter count, not actual type info!")}classType.registeredClass.constructor_body[argCount-1]=()=>{throwUnboundTypeError("Cannot construct "+classType.name+" due to unbound types",rawArgTypes)};whenDependentTypesAreResolved([],rawArgTypes,function(argTypes){argTypes.splice(1,0,null);classType.registeredClass.constructor_body[argCount-1]=craftInvokerFunction(humanName,argTypes,null,invoker,rawConstructor);return[]});return[]})}Module["__embind_register_class_constructor"]=__embind_register_class_constructor;function __embind_register_class_function(rawClassType,methodName,argCount,rawArgTypesAddr,invokerSignature,rawInvoker,context,isPureVirtual,isAsync){var rawArgTypes=heap32VectorToArray(argCount,rawArgTypesAddr);methodName=readLatin1String(methodName);rawInvoker=embind__requireFunction(invokerSignature,rawInvoker);whenDependentTypesAreResolved([],[rawClassType],function(classType){classType=classType[0];var humanName=classType.name+"."+methodName;if(methodName.startsWith("@@")){methodName=Symbol[methodName.substring(2)]}if(isPureVirtual){classType.registeredClass.pureVirtualFunctions.push(methodName)}function unboundTypesHandler(){throwUnboundTypeError("Cannot call "+humanName+" due to unbound types",rawArgTypes)}var proto=classType.registeredClass.instancePrototype;var method=proto[methodName];if(undefined===method||undefined===method.overloadTable&&method.className!==classType.name&&method.argCount===argCount-2){unboundTypesHandler.argCount=argCount-2;unboundTypesHandler.className=classType.name;proto[methodName]=unboundTypesHandler}else{ensureOverloadTable(proto,methodName,humanName);proto[methodName].overloadTable[argCount-2]=unboundTypesHandler}whenDependentTypesAreResolved([],rawArgTypes,function(argTypes){var memberFunction=craftInvokerFunction(humanName,argTypes,classType,rawInvoker,context,isAsync);if(undefined===proto[methodName].overloadTable){memberFunction.argCount=argCount-2;proto[methodName]=memberFunction}else{proto[methodName].overloadTable[argCount-2]=memberFunction}return[]});return[]})}Module["__embind_register_class_function"]=__embind_register_class_function;var emval_free_list=[];Module["emval_free_list"]=emval_free_list;var emval_handle_array=[{},{value:undefined},{value:null},{value:true},{value:false}];Module["emval_handle_array"]=emval_handle_array;function __emval_decref(handle){if(handle>4&&0===--emval_handle_array[handle].refcount){emval_handle_array[handle]=undefined;emval_free_list.push(handle)}}Module["__emval_decref"]=__emval_decref;function count_emval_handles(){var count=0;for(var i=5;i<emval_handle_array.length;++i){if(emval_handle_array[i]!==undefined){++count}}return count}Module["count_emval_handles"]=count_emval_handles;function get_first_emval(){for(var i=5;i<emval_handle_array.length;++i){if(emval_handle_array[i]!==undefined){return emval_handle_array[i]}}return null}Module["get_first_emval"]=get_first_emval;function init_emval(){Module["count_emval_handles"]=count_emval_handles;Module["get_first_emval"]=get_first_emval}Module["init_emval"]=init_emval;var Emval={toValue:handle=>{if(!handle){throwBindingError("Cannot use deleted val. handle = "+handle)}return emval_handle_array[handle].value},toHandle:value=>{switch(value){case undefined:return 1;case null:return 2;case true:return 3;case false:return 4;default:{var handle=emval_free_list.length?emval_free_list.pop():emval_handle_array.length;emval_handle_array[handle]={refcount:1,value:value};return handle}}}};Module["Emval"]=Emval;function __embind_register_emval(rawType,name){name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":function(handle){var rv=Emval.toValue(handle);__emval_decref(handle);return rv},"toWireType":function(destructors,value){return Emval.toHandle(value)},"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:null})}Module["__embind_register_emval"]=__embind_register_emval;function embindRepr(v){if(v===null){return"null"}var t=typeof v;if(t==="object"||t==="array"||t==="function"){return v.toString()}else{return""+v}}Module["embindRepr"]=embindRepr;function floatReadValueFromPointer(name,shift){switch(shift){case 2:return function(pointer){return this["fromWireType"](HEAPF32[pointer>>2])};case 3:return function(pointer){return this["fromWireType"](HEAPF64[pointer>>3])};default:throw new TypeError("Unknown float type: "+name)}}Module["floatReadValueFromPointer"]=floatReadValueFromPointer;function __embind_register_float(rawType,name,size){var shift=getShiftFromSize(size);name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":function(value){return value},"toWireType":function(destructors,value){return value},"argPackAdvance":8,"readValueFromPointer":floatReadValueFromPointer(name,shift),destructorFunction:null})}Module["__embind_register_float"]=__embind_register_float;function integerReadValueFromPointer(name,shift,signed){switch(shift){case 0:return signed?function readS8FromPointer(pointer){return HEAP8[pointer]}:function readU8FromPointer(pointer){return HEAPU8[pointer]};case 1:return signed?function readS16FromPointer(pointer){return HEAP16[pointer>>1]}:function readU16FromPointer(pointer){return HEAPU16[pointer>>1]};case 2:return signed?function readS32FromPointer(pointer){return HEAP32[pointer>>2]}:function readU32FromPointer(pointer){return HEAPU32[pointer>>2]};default:throw new TypeError("Unknown integer type: "+name)}}Module["integerReadValueFromPointer"]=integerReadValueFromPointer;function __embind_register_integer(primitiveType,name,size,minRange,maxRange){name=readLatin1String(name);if(maxRange===-1){maxRange=4294967295}var shift=getShiftFromSize(size);var fromWireType=value=>value;if(minRange===0){var bitshift=32-8*size;fromWireType=value=>value<<bitshift>>>bitshift}var isUnsignedType=name.includes("unsigned");var checkAssertions=(value,toTypeName)=>{};var toWireType;if(isUnsignedType){toWireType=function(destructors,value){checkAssertions(value,this.name);return value>>>0}}else{toWireType=function(destructors,value){checkAssertions(value,this.name);return value}}registerType(primitiveType,{name:name,"fromWireType":fromWireType,"toWireType":toWireType,"argPackAdvance":8,"readValueFromPointer":integerReadValueFromPointer(name,shift,minRange!==0),destructorFunction:null})}Module["__embind_register_integer"]=__embind_register_integer;function __embind_register_memory_view(rawType,dataTypeIndex,name){var typeMapping=[Int8Array,Uint8Array,Int16Array,Uint16Array,Int32Array,Uint32Array,Float32Array,Float64Array];var TA=typeMapping[dataTypeIndex];function decodeMemoryView(handle){handle=handle>>2;var heap=HEAPU32;var size=heap[handle];var data=heap[handle+1];return new TA(heap.buffer,data,size)}name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":decodeMemoryView,"argPackAdvance":8,"readValueFromPointer":decodeMemoryView},{ignoreDuplicateRegistrations:true})}Module["__embind_register_memory_view"]=__embind_register_memory_view;function __embind_register_std_string(rawType,name){name=readLatin1String(name);var stdStringIsUTF8=name==="std::string";registerType(rawType,{name:name,"fromWireType":function(value){var length=HEAPU32[value>>2];var payload=value+4;var str;if(stdStringIsUTF8){var decodeStartPtr=payload;for(var i=0;i<=length;++i){var currentBytePtr=payload+i;if(i==length||HEAPU8[currentBytePtr]==0){var maxRead=currentBytePtr-decodeStartPtr;var stringSegment=UTF8ToString(decodeStartPtr,maxRead);if(str===undefined){str=stringSegment}else{str+=String.fromCharCode(0);str+=stringSegment}decodeStartPtr=currentBytePtr+1}}}else{var a=new Array(length);for(var i=0;i<length;++i){a[i]=String.fromCharCode(HEAPU8[payload+i])}str=a.join("")}_free(value);return str},"toWireType":function(destructors,value){if(value instanceof ArrayBuffer){value=new Uint8Array(value)}var length;var valueIsOfTypeString=typeof value=="string";if(!(valueIsOfTypeString||value instanceof Uint8Array||value instanceof Uint8ClampedArray||value instanceof Int8Array)){throwBindingError("Cannot pass non-string to std::string")}if(stdStringIsUTF8&&valueIsOfTypeString){length=lengthBytesUTF8(value)}else{length=value.length}var base=_malloc(4+length+1);var ptr=base+4;HEAPU32[base>>2]=length;if(stdStringIsUTF8&&valueIsOfTypeString){stringToUTF8(value,ptr,length+1)}else{if(valueIsOfTypeString){for(var i=0;i<length;++i){var charCode=value.charCodeAt(i);if(charCode>255){_free(ptr);throwBindingError("String has UTF-16 code units that do not fit in 8 bits")}HEAPU8[ptr+i]=charCode}}else{for(var i=0;i<length;++i){HEAPU8[ptr+i]=value[i]}}}if(destructors!==null){destructors.push(_free,base)}return base},"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:function(ptr){_free(ptr)}})}Module["__embind_register_std_string"]=__embind_register_std_string;var UTF16Decoder=typeof TextDecoder!="undefined"?new TextDecoder("utf-16le"):undefined;Module["UTF16Decoder"]=UTF16Decoder;function UTF16ToString(ptr,maxBytesToRead){var endPtr=ptr;var idx=endPtr>>1;var maxIdx=idx+maxBytesToRead/2;while(!(idx>=maxIdx)&&HEAPU16[idx])++idx;endPtr=idx<<1;if(endPtr-ptr>32&&UTF16Decoder)return UTF16Decoder.decode(HEAPU8.subarray(ptr,endPtr));var str="";for(var i=0;!(i>=maxBytesToRead/2);++i){var codeUnit=HEAP16[ptr+i*2>>1];if(codeUnit==0)break;str+=String.fromCharCode(codeUnit)}return str}Module["UTF16ToString"]=UTF16ToString;function stringToUTF16(str,outPtr,maxBytesToWrite){if(maxBytesToWrite===undefined){maxBytesToWrite=2147483647}if(maxBytesToWrite<2)return 0;maxBytesToWrite-=2;var startPtr=outPtr;var numCharsToWrite=maxBytesToWrite<str.length*2?maxBytesToWrite/2:str.length;for(var i=0;i<numCharsToWrite;++i){var codeUnit=str.charCodeAt(i);HEAP16[outPtr>>1]=codeUnit;outPtr+=2}HEAP16[outPtr>>1]=0;return outPtr-startPtr}Module["stringToUTF16"]=stringToUTF16;function lengthBytesUTF16(str){return str.length*2}Module["lengthBytesUTF16"]=lengthBytesUTF16;function UTF32ToString(ptr,maxBytesToRead){var i=0;var str="";while(!(i>=maxBytesToRead/4)){var utf32=HEAP32[ptr+i*4>>2];if(utf32==0)break;++i;if(utf32>=65536){var ch=utf32-65536;str+=String.fromCharCode(55296|ch>>10,56320|ch&1023)}else{str+=String.fromCharCode(utf32)}}return str}Module["UTF32ToString"]=UTF32ToString;function stringToUTF32(str,outPtr,maxBytesToWrite){if(maxBytesToWrite===undefined){maxBytesToWrite=2147483647}if(maxBytesToWrite<4)return 0;var startPtr=outPtr;var endPtr=startPtr+maxBytesToWrite-4;for(var i=0;i<str.length;++i){var codeUnit=str.charCodeAt(i);if(codeUnit>=55296&&codeUnit<=57343){var trailSurrogate=str.charCodeAt(++i);codeUnit=65536+((codeUnit&1023)<<10)|trailSurrogate&1023}HEAP32[outPtr>>2]=codeUnit;outPtr+=4;if(outPtr+4>endPtr)break}HEAP32[outPtr>>2]=0;return outPtr-startPtr}Module["stringToUTF32"]=stringToUTF32;function lengthBytesUTF32(str){var len=0;for(var i=0;i<str.length;++i){var codeUnit=str.charCodeAt(i);if(codeUnit>=55296&&codeUnit<=57343)++i;len+=4}return len}Module["lengthBytesUTF32"]=lengthBytesUTF32;function __embind_register_std_wstring(rawType,charSize,name){name=readLatin1String(name);var decodeString,encodeString,getHeap,lengthBytesUTF,shift;if(charSize===2){decodeString=UTF16ToString;encodeString=stringToUTF16;lengthBytesUTF=lengthBytesUTF16;getHeap=()=>HEAPU16;shift=1}else if(charSize===4){decodeString=UTF32ToString;encodeString=stringToUTF32;lengthBytesUTF=lengthBytesUTF32;getHeap=()=>HEAPU32;shift=2}registerType(rawType,{name:name,"fromWireType":function(value){var length=HEAPU32[value>>2];var HEAP=getHeap();var str;var decodeStartPtr=value+4;for(var i=0;i<=length;++i){var currentBytePtr=value+4+i*charSize;if(i==length||HEAP[currentBytePtr>>shift]==0){var maxReadBytes=currentBytePtr-decodeStartPtr;var stringSegment=decodeString(decodeStartPtr,maxReadBytes);if(str===undefined){str=stringSegment}else{str+=String.fromCharCode(0);str+=stringSegment}decodeStartPtr=currentBytePtr+charSize}}_free(value);return str},"toWireType":function(destructors,value){if(!(typeof value=="string")){throwBindingError("Cannot pass non-string to C++ string type "+name)}var length=lengthBytesUTF(value);var ptr=_malloc(4+length+charSize);HEAPU32[ptr>>2]=length>>shift;encodeString(value,ptr+4,length+charSize);if(destructors!==null){destructors.push(_free,ptr)}return ptr},"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:function(ptr){_free(ptr)}})}Module["__embind_register_std_wstring"]=__embind_register_std_wstring;function __embind_register_void(rawType,name){name=readLatin1String(name);registerType(rawType,{isVoid:true,name:name,"argPackAdvance":0,"fromWireType":function(){return undefined},"toWireType":function(destructors,o){return undefined}})}Module["__embind_register_void"]=__embind_register_void;var nowIsMonotonic=true;Module["nowIsMonotonic"]=nowIsMonotonic;function __emscripten_get_now_is_monotonic(){return nowIsMonotonic}Module["__emscripten_get_now_is_monotonic"]=__emscripten_get_now_is_monotonic;function __emscripten_throw_longjmp(){throw Infinity}Module["__emscripten_throw_longjmp"]=__emscripten_throw_longjmp;function requireRegisteredType(rawType,humanName){var impl=registeredTypes[rawType];if(undefined===impl){throwBindingError(humanName+" has unknown type "+getTypeName(rawType))}return impl}Module["requireRegisteredType"]=requireRegisteredType;function __emval_as(handle,returnType,destructorsRef){handle=Emval.toValue(handle);returnType=requireRegisteredType(returnType,"emval::as");var destructors=[];var rd=Emval.toHandle(destructors);HEAPU32[destructorsRef>>2]=rd;return returnType["toWireType"](destructors,handle)}Module["__emval_as"]=__emval_as;function __emval_incref(handle){if(handle>4){emval_handle_array[handle].refcount+=1}}Module["__emval_incref"]=__emval_incref;function __emval_is_number(handle){handle=Emval.toValue(handle);return typeof handle=="number"}Module["__emval_is_number"]=__emval_is_number;function __emval_run_destructors(handle){var destructors=Emval.toValue(handle);runDestructors(destructors);__emval_decref(handle)}Module["__emval_run_destructors"]=__emval_run_destructors;function __emval_take_value(type,arg){type=requireRegisteredType(type,"_emval_take_value");var v=type["readValueFromPointer"](arg);return Emval.toHandle(v)}Module["__emval_take_value"]=__emval_take_value;function readI53FromI64(ptr){return HEAPU32[ptr>>2]+HEAP32[ptr+4>>2]*4294967296}Module["readI53FromI64"]=readI53FromI64;function __isLeapYear(year){return year%4===0&&(year%100!==0||year%400===0)}Module["__isLeapYear"]=__isLeapYear;var __MONTH_DAYS_LEAP_CUMULATIVE=[0,31,60,91,121,152,182,213,244,274,305,335];Module["__MONTH_DAYS_LEAP_CUMULATIVE"]=__MONTH_DAYS_LEAP_CUMULATIVE;var __MONTH_DAYS_REGULAR_CUMULATIVE=[0,31,59,90,120,151,181,212,243,273,304,334];Module["__MONTH_DAYS_REGULAR_CUMULATIVE"]=__MONTH_DAYS_REGULAR_CUMULATIVE;function __yday_from_date(date){var isLeapYear=__isLeapYear(date.getFullYear());var monthDaysCumulative=isLeapYear?__MONTH_DAYS_LEAP_CUMULATIVE:__MONTH_DAYS_REGULAR_CUMULATIVE;var yday=monthDaysCumulative[date.getMonth()]+date.getDate()-1;return yday}Module["__yday_from_date"]=__yday_from_date;function __localtime_js(time,tmPtr){var date=new Date(readI53FromI64(time)*1e3);HEAP32[tmPtr>>2]=date.getSeconds();HEAP32[tmPtr+4>>2]=date.getMinutes();HEAP32[tmPtr+8>>2]=date.getHours();HEAP32[tmPtr+12>>2]=date.getDate();HEAP32[tmPtr+16>>2]=date.getMonth();HEAP32[tmPtr+20>>2]=date.getFullYear()-1900;HEAP32[tmPtr+24>>2]=date.getDay();var yday=__yday_from_date(date)|0;HEAP32[tmPtr+28>>2]=yday;HEAP32[tmPtr+36>>2]=-(date.getTimezoneOffset()*60);var start=new Date(date.getFullYear(),0,1);var summerOffset=new Date(date.getFullYear(),6,1).getTimezoneOffset();var winterOffset=start.getTimezoneOffset();var dst=(summerOffset!=winterOffset&&date.getTimezoneOffset()==Math.min(winterOffset,summerOffset))|0;HEAP32[tmPtr+32>>2]=dst}Module["__localtime_js"]=__localtime_js;function __munmap_js(addr,len,prot,flags,fd,offset){}Module["__munmap_js"]=__munmap_js;function allocateUTF8(str){var size=lengthBytesUTF8(str)+1;var ret=_malloc(size);if(ret)stringToUTF8Array(str,HEAP8,ret,size);return ret}Module["allocateUTF8"]=allocateUTF8;function __tzset_js(timezone,daylight,tzname){var currentYear=(new Date).getFullYear();var winter=new Date(currentYear,0,1);var summer=new Date(currentYear,6,1);var winterOffset=winter.getTimezoneOffset();var summerOffset=summer.getTimezoneOffset();var stdTimezoneOffset=Math.max(winterOffset,summerOffset);HEAPU32[timezone>>2]=stdTimezoneOffset*60;HEAP32[daylight>>2]=Number(winterOffset!=summerOffset);function extractZone(date){var match=date.toTimeString().match(/\(([A-Za-z ]+)\)$/);return match?match[1]:"GMT"}var winterName=extractZone(winter);var summerName=extractZone(summer);var winterNamePtr=allocateUTF8(winterName);var summerNamePtr=allocateUTF8(summerName);if(summerOffset<winterOffset){HEAPU32[tzname>>2]=winterNamePtr;HEAPU32[tzname+4>>2]=summerNamePtr}else{HEAPU32[tzname>>2]=summerNamePtr;HEAPU32[tzname+4>>2]=winterNamePtr}}Module["__tzset_js"]=__tzset_js;function _abort(){abort("")}Module["_abort"]=_abort;function _emscripten_date_now(){return Date.now()}Module["_emscripten_date_now"]=_emscripten_date_now;function getHeapMax(){return 2147483648}Module["getHeapMax"]=getHeapMax;function _emscripten_get_heap_max(){return getHeapMax()}Module["_emscripten_get_heap_max"]=_emscripten_get_heap_max;var _emscripten_get_now;if(ENVIRONMENT_IS_NODE){_emscripten_get_now=()=>{var t=process.hrtime();return t[0]*1e3+t[1]/1e6}}else _emscripten_get_now=()=>performance.now();Module["_emscripten_get_now"]=_emscripten_get_now;function _emscripten_memcpy_big(dest,src,num){HEAPU8.copyWithin(dest,src,src+num)}Module["_emscripten_memcpy_big"]=_emscripten_memcpy_big;function emscripten_realloc_buffer(size){var b=wasmMemory.buffer;try{wasmMemory.grow(size-b.byteLength+65535>>>16);updateMemoryViews();return 1}catch(e){}}Module["emscripten_realloc_buffer"]=emscripten_realloc_buffer;function _emscripten_resize_heap(requestedSize){var oldSize=HEAPU8.length;requestedSize=requestedSize>>>0;var maxHeapSize=getHeapMax();if(requestedSize>maxHeapSize){return false}let alignUp=(x,multiple)=>x+(multiple-x%multiple)%multiple;for(var cutDown=1;cutDown<=4;cutDown*=2){var overGrownHeapSize=oldSize*(1+.2/cutDown);overGrownHeapSize=Math.min(overGrownHeapSize,requestedSize+100663296);var newSize=Math.min(maxHeapSize,alignUp(Math.max(requestedSize,overGrownHeapSize),65536));var replacement=emscripten_realloc_buffer(newSize);if(replacement){return true}}return false}Module["_emscripten_resize_heap"]=_emscripten_resize_heap;var ENV={};Module["ENV"]=ENV;function getExecutableName(){return thisProgram||"./this.program"}Module["getExecutableName"]=getExecutableName;function getEnvStrings(){if(!getEnvStrings.strings){var lang=(typeof navigator=="object"&&navigator.languages&&navigator.languages[0]||"C").replace("-","_")+".UTF-8";var env={"USER":"web_user","LOGNAME":"web_user","PATH":"/","PWD":"/","HOME":"/home/web_user","LANG":lang,"_":getExecutableName()};for(var x in ENV){if(ENV[x]===undefined)delete env[x];else env[x]=ENV[x]}var strings=[];for(var x in env){strings.push(x+"="+env[x])}getEnvStrings.strings=strings}return getEnvStrings.strings}Module["getEnvStrings"]=getEnvStrings;function writeAsciiToMemory(str,buffer,dontAddNull){for(var i=0;i<str.length;++i){HEAP8[buffer++>>0]=str.charCodeAt(i)}if(!dontAddNull)HEAP8[buffer>>0]=0}Module["writeAsciiToMemory"]=writeAsciiToMemory;function _environ_get(__environ,environ_buf){var bufSize=0;getEnvStrings().forEach(function(string,i){var ptr=environ_buf+bufSize;HEAPU32[__environ+i*4>>2]=ptr;writeAsciiToMemory(string,ptr);bufSize+=string.length+1});return 0}Module["_environ_get"]=_environ_get;function _environ_sizes_get(penviron_count,penviron_buf_size){var strings=getEnvStrings();HEAPU32[penviron_count>>2]=strings.length;var bufSize=0;strings.forEach(function(string){bufSize+=string.length+1});HEAPU32[penviron_buf_size>>2]=bufSize;return 0}Module["_environ_sizes_get"]=_environ_sizes_get;function _proc_exit(code){EXITSTATUS=code;if(!keepRuntimeAlive()){if(Module["onExit"])Module["onExit"](code);ABORT=true}quit_(code,new ExitStatus(code))}Module["_proc_exit"]=_proc_exit;function exitJS(status,implicit){EXITSTATUS=status;_proc_exit(status)}Module["exitJS"]=exitJS;var _exit=exitJS;Module["_exit"]=_exit;function _fd_close(fd){return 52}Module["_fd_close"]=_fd_close;function _fd_read(fd,iov,iovcnt,pnum){return 52}Module["_fd_read"]=_fd_read;function convertI32PairToI53Checked(lo,hi){return hi+2097152>>>0<4194305-!!lo?(lo>>>0)+hi*4294967296:NaN}Module["convertI32PairToI53Checked"]=convertI32PairToI53Checked;function _fd_seek(fd,offset_low,offset_high,whence,newOffset){return 70}Module["_fd_seek"]=_fd_seek;var printCharBuffers=[null,[],[]];Module["printCharBuffers"]=printCharBuffers;function printChar(stream,curr){var buffer=printCharBuffers[stream];if(curr===0||curr===10){(stream===1?out:err)(UTF8ArrayToString(buffer,0));buffer.length=0}else{buffer.push(curr)}}Module["printChar"]=printChar;function flush_NO_FILESYSTEM(){if(printCharBuffers[1].length)printChar(1,10);if(printCharBuffers[2].length)printChar(2,10)}Module["flush_NO_FILESYSTEM"]=flush_NO_FILESYSTEM;function _fd_write(fd,iov,iovcnt,pnum){var num=0;for(var i=0;i<iovcnt;i++){var ptr=HEAPU32[iov>>2];var len=HEAPU32[iov+4>>2];iov+=8;for(var j=0;j<len;j++){printChar(fd,HEAPU8[ptr+j])}num+=len}HEAPU32[pnum>>2]=num;return 0}Module["_fd_write"]=_fd_write;function __arraySum(array,index){var sum=0;for(var i=0;i<=index;sum+=array[i++]){}return sum}Module["__arraySum"]=__arraySum;var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];Module["__MONTH_DAYS_LEAP"]=__MONTH_DAYS_LEAP;var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];Module["__MONTH_DAYS_REGULAR"]=__MONTH_DAYS_REGULAR;function __addDays(date,days){var newDate=new Date(date.getTime());while(days>0){var leap=__isLeapYear(newDate.getFullYear());var currentMonth=newDate.getMonth();var daysInCurrentMonth=(leap?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR)[currentMonth];if(days>daysInCurrentMonth-newDate.getDate()){days-=daysInCurrentMonth-newDate.getDate()+1;newDate.setDate(1);if(currentMonth<11){newDate.setMonth(currentMonth+1)}else{newDate.setMonth(0);newDate.setFullYear(newDate.getFullYear()+1)}}else{newDate.setDate(newDate.getDate()+days);return newDate}}return newDate}Module["__addDays"]=__addDays;function intArrayFromString(stringy,dontAddNull,length){var len=length>0?length:lengthBytesUTF8(stringy)+1;var u8array=new Array(len);var numBytesWritten=stringToUTF8Array(stringy,u8array,0,u8array.length);if(dontAddNull)u8array.length=numBytesWritten;return u8array}Module["intArrayFromString"]=intArrayFromString;function writeArrayToMemory(array,buffer){HEAP8.set(array,buffer)}Module["writeArrayToMemory"]=writeArrayToMemory;function _strftime(s,maxsize,format,tm){var tm_zone=HEAP32[tm+40>>2];var date={tm_sec:HEAP32[tm>>2],tm_min:HEAP32[tm+4>>2],tm_hour:HEAP32[tm+8>>2],tm_mday:HEAP32[tm+12>>2],tm_mon:HEAP32[tm+16>>2],tm_year:HEAP32[tm+20>>2],tm_wday:HEAP32[tm+24>>2],tm_yday:HEAP32[tm+28>>2],tm_isdst:HEAP32[tm+32>>2],tm_gmtoff:HEAP32[tm+36>>2],tm_zone:tm_zone?UTF8ToString(tm_zone):""};var pattern=UTF8ToString(format);var EXPANSION_RULES_1={"%c":"%a %b %d %H:%M:%S %Y","%D":"%m/%d/%y","%F":"%Y-%m-%d","%h":"%b","%r":"%I:%M:%S %p","%R":"%H:%M","%T":"%H:%M:%S","%x":"%m/%d/%y","%X":"%H:%M:%S","%Ec":"%c","%EC":"%C","%Ex":"%m/%d/%y","%EX":"%H:%M:%S","%Ey":"%y","%EY":"%Y","%Od":"%d","%Oe":"%e","%OH":"%H","%OI":"%I","%Om":"%m","%OM":"%M","%OS":"%S","%Ou":"%u","%OU":"%U","%OV":"%V","%Ow":"%w","%OW":"%W","%Oy":"%y"};for(var rule in EXPANSION_RULES_1){pattern=pattern.replace(new RegExp(rule,"g"),EXPANSION_RULES_1[rule])}var WEEKDAYS=["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"];var MONTHS=["January","February","March","April","May","June","July","August","September","October","November","December"];function leadingSomething(value,digits,character){var str=typeof value=="number"?value.toString():value||"";while(str.length<digits){str=character[0]+str}return str}function leadingNulls(value,digits){return leadingSomething(value,digits,"0")}function compareByDay(date1,date2){function sgn(value){return value<0?-1:value>0?1:0}var compare;if((compare=sgn(date1.getFullYear()-date2.getFullYear()))===0){if((compare=sgn(date1.getMonth()-date2.getMonth()))===0){compare=sgn(date1.getDate()-date2.getDate())}}return compare}function getFirstWeekStartDate(janFourth){switch(janFourth.getDay()){case 0:return new Date(janFourth.getFullYear()-1,11,29);case 1:return janFourth;case 2:return new Date(janFourth.getFullYear(),0,3);case 3:return new Date(janFourth.getFullYear(),0,2);case 4:return new Date(janFourth.getFullYear(),0,1);case 5:return new Date(janFourth.getFullYear()-1,11,31);case 6:return new Date(janFourth.getFullYear()-1,11,30)}}function getWeekBasedYear(date){var thisDate=__addDays(new Date(date.tm_year+1900,0,1),date.tm_yday);var janFourthThisYear=new Date(thisDate.getFullYear(),0,4);var janFourthNextYear=new Date(thisDate.getFullYear()+1,0,4);var firstWeekStartThisYear=getFirstWeekStartDate(janFourthThisYear);var firstWeekStartNextYear=getFirstWeekStartDate(janFourthNextYear);if(compareByDay(firstWeekStartThisYear,thisDate)<=0){if(compareByDay(firstWeekStartNextYear,thisDate)<=0){return thisDate.getFullYear()+1}return thisDate.getFullYear()}return thisDate.getFullYear()-1}var EXPANSION_RULES_2={"%a":function(date){return WEEKDAYS[date.tm_wday].substring(0,3)},"%A":function(date){return WEEKDAYS[date.tm_wday]},"%b":function(date){return MONTHS[date.tm_mon].substring(0,3)},"%B":function(date){return MONTHS[date.tm_mon]},"%C":function(date){var year=date.tm_year+1900;return leadingNulls(year/100|0,2)},"%d":function(date){return leadingNulls(date.tm_mday,2)},"%e":function(date){return leadingSomething(date.tm_mday,2," ")},"%g":function(date){return getWeekBasedYear(date).toString().substring(2)},"%G":function(date){return getWeekBasedYear(date)},"%H":function(date){return leadingNulls(date.tm_hour,2)},"%I":function(date){var twelveHour=date.tm_hour;if(twelveHour==0)twelveHour=12;else if(twelveHour>12)twelveHour-=12;return leadingNulls(twelveHour,2)},"%j":function(date){return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900)?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,date.tm_mon-1),3)},"%m":function(date){return leadingNulls(date.tm_mon+1,2)},"%M":function(date){return leadingNulls(date.tm_min,2)},"%n":function(){return"\n"},"%p":function(date){if(date.tm_hour>=0&&date.tm_hour<12){return"AM"}return"PM"},"%S":function(date){return leadingNulls(date.tm_sec,2)},"%t":function(){return"\t"},"%u":function(date){return date.tm_wday||7},"%U":function(date){var days=date.tm_yday+7-date.tm_wday;return leadingNulls(Math.floor(days/7),2)},"%V":function(date){var val=Math.floor((date.tm_yday+7-(date.tm_wday+6)%7)/7);if((date.tm_wday+371-date.tm_yday-2)%7<=2){val++}if(!val){val=52;var dec31=(date.tm_wday+7-date.tm_yday-1)%7;if(dec31==4||dec31==5&&__isLeapYear(date.tm_year%400-1)){val++}}else if(val==53){var jan1=(date.tm_wday+371-date.tm_yday)%7;if(jan1!=4&&(jan1!=3||!__isLeapYear(date.tm_year)))val=1}return leadingNulls(val,2)},"%w":function(date){return date.tm_wday},"%W":function(date){var days=date.tm_yday+7-(date.tm_wday+6)%7;return leadingNulls(Math.floor(days/7),2)},"%y":function(date){return(date.tm_year+1900).toString().substring(2)},"%Y":function(date){return date.tm_year+1900},"%z":function(date){var off=date.tm_gmtoff;var ahead=off>=0;off=Math.abs(off)/60;off=off/60*100+off%60;return(ahead?"+":"-")+String("0000"+off).slice(-4)},"%Z":function(date){return date.tm_zone},"%%":function(){return"%"}};pattern=pattern.replace(/%%/g,"\0\0");for(var rule in EXPANSION_RULES_2){if(pattern.includes(rule)){pattern=pattern.replace(new RegExp(rule,"g"),EXPANSION_RULES_2[rule](date))}}pattern=pattern.replace(/\0\0/g,"%");var bytes=intArrayFromString(pattern,false);if(bytes.length>maxsize){return 0}writeArrayToMemory(bytes,s);return bytes.length-1}Module["_strftime"]=_strftime;function _strftime_l(s,maxsize,format,tm,loc){return _strftime(s,maxsize,format,tm)}Module["_strftime_l"]=_strftime_l;function getCFunc(ident){var func=Module["_"+ident];return func}Module["getCFunc"]=getCFunc;function ccall(ident,returnType,argTypes,args,opts){var toC={"string":str=>{var ret=0;if(str!==null&&str!==undefined&&str!==0){var len=(str.length<<2)+1;ret=stackAlloc(len);stringToUTF8(str,ret,len)}return ret},"array":arr=>{var ret=stackAlloc(arr.length);writeArrayToMemory(arr,ret);return ret}};function convertReturnValue(ret){if(returnType==="string"){return UTF8ToString(ret)}if(returnType==="boolean")return Boolean(ret);return ret}var func=getCFunc(ident);var cArgs=[];var stack=0;if(args){for(var i=0;i<args.length;i++){var converter=toC[argTypes[i]];if(converter){if(stack===0)stack=stackSave();cArgs[i]=converter(args[i])}else{cArgs[i]=args[i]}}}var ret=func.apply(null,cArgs);function onDone(ret){if(stack!==0)stackRestore(stack);return convertReturnValue(ret)}ret=onDone(ret);return ret}Module["ccall"]=ccall;embind_init_charCodes();BindingError=Module["BindingError"]=extendError(Error,"BindingError");InternalError=Module["InternalError"]=extendError(Error,"InternalError");init_ClassHandle();init_embind();init_RegisteredPointer();UnboundTypeError=Module["UnboundTypeError"]=extendError(Error,"UnboundTypeError");init_emval();var wasmImports={"h":___cxa_throw,"v":___syscall_fcntl64,"U":___syscall_fstat64,"M":___syscall_getdents64,"W":___syscall_ioctl,"S":___syscall_lstat64,"R":___syscall_newfstatat,"w":___syscall_openat,"T":___syscall_stat64,"D":__embind_register_bigint,"ba":__embind_register_bool,"aa":__embind_register_class,"Y":__embind_register_class_constructor,"a":__embind_register_class_function,"$":__embind_register_emval,"x":__embind_register_float,"g":__embind_register_integer,"b":__embind_register_memory_view,"y":__embind_register_std_string,"q":__embind_register_std_wstring,"ca":__embind_register_void,"Z":__emscripten_get_now_is_monotonic,"I":__emscripten_throw_longjmp,"s":__emval_as,"p":__emval_decref,"B":__emval_incref,"z":__emval_is_number,"r":__emval_run_destructors,"A":__emval_take_value,"O":__localtime_js,"N":__munmap_js,"K":__tzset_js,"n":_abort,"m":_emscripten_date_now,"L":_emscripten_get_heap_max,"X":_emscripten_get_now,"_":_emscripten_memcpy_big,"J":_emscripten_resize_heap,"P":_environ_get,"Q":_environ_sizes_get,"da":_exit,"o":_fd_close,"u":_fd_read,"C":_fd_seek,"V":_fd_write,"ea":get_domain_js,"d":invoke_ii,"f":invoke_iii,"j":invoke_iiii,"t":invoke_iiiii,"i":invoke_vi,"e":invoke_vii,"F":invoke_viid,"c":invoke_viii,"k":invoke_viiii,"l":invoke_viiiii,"E":invoke_viiiiiii,"G":invoke_viiiiiiiii,"H":_strftime_l};var asm=createWasm();var ___wasm_call_ctors=function(){return(___wasm_call_ctors=Module["asm"]["ga"]).apply(null,arguments)};var _GetDynamImageProcWasmVersion=Module["_GetDynamImageProcWasmVersion"]=function(){return(_GetDynamImageProcWasmVersion=Module["_GetDynamImageProcWasmVersion"]=Module["asm"]["ha"]).apply(null,arguments)};var _InitDynamImageProc=Module["_InitDynamImageProc"]=function(){return(_InitDynamImageProc=Module["_InitDynamImageProc"]=Module["asm"]["ia"]).apply(null,arguments)};var _DestroyDynamImageProc=Module["_DestroyDynamImageProc"]=function(){return(_DestroyDynamImageProc=Module["_DestroyDynamImageProc"]=Module["asm"]["ja"]).apply(null,arguments)};var _DynamImageProcSetDebugMode=Module["_DynamImageProcSetDebugMode"]=function(){return(_DynamImageProcSetDebugMode=Module["_DynamImageProcSetDebugMode"]=Module["asm"]["ka"]).apply(null,arguments)};var _DynamImageProcGetWidth=Module["_DynamImageProcGetWidth"]=function(){return(_DynamImageProcGetWidth=Module["_DynamImageProcGetWidth"]=Module["asm"]["la"]).apply(null,arguments)};var _DynamImageProcGetHeight=Module["_DynamImageProcGetHeight"]=function(){return(_DynamImageProcGetHeight=Module["_DynamImageProcGetHeight"]=Module["asm"]["ma"]).apply(null,arguments)};var _DynamImageProcSave=Module["_DynamImageProcSave"]=function(){return(_DynamImageProcSave=Module["_DynamImageProcSave"]=Module["asm"]["na"]).apply(null,arguments)};var _DynamImageProcGetDataPointer=Module["_DynamImageProcGetDataPointer"]=function(){return(_DynamImageProcGetDataPointer=Module["_DynamImageProcGetDataPointer"]=Module["asm"]["oa"]).apply(null,arguments)};var _DynamImageProcRotateFlipType=Module["_DynamImageProcRotateFlipType"]=function(){return(_DynamImageProcRotateFlipType=Module["_DynamImageProcRotateFlipType"]=Module["asm"]["pa"]).apply(null,arguments)};var _DynamImageProcRotateEX=Module["_DynamImageProcRotateEX"]=function(){return(_DynamImageProcRotateEX=Module["_DynamImageProcRotateEX"]=Module["asm"]["qa"]).apply(null,arguments)};var _DynamImageProcResize=Module["_DynamImageProcResize"]=function(){return(_DynamImageProcResize=Module["_DynamImageProcResize"]=Module["asm"]["ra"]).apply(null,arguments)};var _DynamImageProcCrop=Module["_DynamImageProcCrop"]=function(){return(_DynamImageProcCrop=Module["_DynamImageProcCrop"]=Module["asm"]["sa"]).apply(null,arguments)};var _DynamImageProcErase=Module["_DynamImageProcErase"]=function(){return(_DynamImageProcErase=Module["_DynamImageProcErase"]=Module["asm"]["ta"]).apply(null,arguments)};var _DynamImageProcSetDPI=Module["_DynamImageProcSetDPI"]=function(){return(_DynamImageProcSetDPI=Module["_DynamImageProcSetDPI"]=Module["asm"]["ua"]).apply(null,arguments)};var _DynamImageProcInvert=Module["_DynamImageProcInvert"]=function(){return(_DynamImageProcInvert=Module["_DynamImageProcInvert"]=Module["asm"]["va"]).apply(null,arguments)};var _DynamImageProcConvertToBW=Module["_DynamImageProcConvertToBW"]=function(){return(_DynamImageProcConvertToBW=Module["_DynamImageProcConvertToBW"]=Module["asm"]["wa"]).apply(null,arguments)};var _DynamImageProcConvertToGrayScale=Module["_DynamImageProcConvertToGrayScale"]=function(){return(_DynamImageProcConvertToGrayScale=Module["_DynamImageProcConvertToGrayScale"]=Module["asm"]["xa"]).apply(null,arguments)};var _DynamImageProcSetImageWidth=Module["_DynamImageProcSetImageWidth"]=function(){return(_DynamImageProcSetImageWidth=Module["_DynamImageProcSetImageWidth"]=Module["asm"]["ya"]).apply(null,arguments)};var _DynamImageProcSetImageHeight=Module["_DynamImageProcSetImageHeight"]=function(){return(_DynamImageProcSetImageHeight=Module["_DynamImageProcSetImageHeight"]=Module["asm"]["za"]).apply(null,arguments)};var _DynamImageProcGetSkewAngle=Module["_DynamImageProcGetSkewAngle"]=function(){return(_DynamImageProcGetSkewAngle=Module["_DynamImageProcGetSkewAngle"]=Module["asm"]["Aa"]).apply(null,arguments)};var _DynamImageProcDocumentDetect=Module["_DynamImageProcDocumentDetect"]=function(){return(_DynamImageProcDocumentDetect=Module["_DynamImageProcDocumentDetect"]=Module["asm"]["Ba"]).apply(null,arguments)};var _DynamImageProcPerspective=Module["_DynamImageProcPerspective"]=function(){return(_DynamImageProcPerspective=Module["_DynamImageProcPerspective"]=Module["asm"]["Ca"]).apply(null,arguments)};var _DynamImageProcGetBlurryScore=Module["_DynamImageProcGetBlurryScore"]=function(){return(_DynamImageProcGetBlurryScore=Module["_DynamImageProcGetBlurryScore"]=Module["asm"]["Da"]).apply(null,arguments)};var _DynamImageProcColorFilter=Module["_DynamImageProcColorFilter"]=function(){return(_DynamImageProcColorFilter=Module["_DynamImageProcColorFilter"]=Module["asm"]["Ea"]).apply(null,arguments)};var _DynamImageProcSharpen=Module["_DynamImageProcSharpen"]=function(){return(_DynamImageProcSharpen=Module["_DynamImageProcSharpen"]=Module["asm"]["Fa"]).apply(null,arguments)};var _DynamImageProcEnhanceAndSharpen=Module["_DynamImageProcEnhanceAndSharpen"]=function(){return(_DynamImageProcEnhanceAndSharpen=Module["_DynamImageProcEnhanceAndSharpen"]=Module["asm"]["Ga"]).apply(null,arguments)};var _DynamImageProcEqualize=Module["_DynamImageProcEqualize"]=function(){return(_DynamImageProcEqualize=Module["_DynamImageProcEqualize"]=Module["asm"]["Ha"]).apply(null,arguments)};var _DynamImageProcNormalize=Module["_DynamImageProcNormalize"]=function(){return(_DynamImageProcNormalize=Module["_DynamImageProcNormalize"]=Module["asm"]["Ia"]).apply(null,arguments)};var _DynamImageProcShadowRemovel=Module["_DynamImageProcShadowRemovel"]=function(){return(_DynamImageProcShadowRemovel=Module["_DynamImageProcShadowRemovel"]=Module["asm"]["Ja"]).apply(null,arguments)};var _DynamImageProcConvert=Module["_DynamImageProcConvert"]=function(){return(_DynamImageProcConvert=Module["_DynamImageProcConvert"]=Module["asm"]["Ka"]).apply(null,arguments)};var _DynamImageProcGetBrightnessScore=Module["_DynamImageProcGetBrightnessScore"]=function(){return(_DynamImageProcGetBrightnessScore=Module["_DynamImageProcGetBrightnessScore"]=Module["asm"]["La"]).apply(null,arguments)};var _DynamImageProcGetContrastScore=Module["_DynamImageProcGetContrastScore"]=function(){return(_DynamImageProcGetContrastScore=Module["_DynamImageProcGetContrastScore"]=Module["asm"]["Ma"]).apply(null,arguments)};var _DynamImageProcAutoBrightnessAndContrast=Module["_DynamImageProcAutoBrightnessAndContrast"]=function(){return(_DynamImageProcAutoBrightnessAndContrast=Module["_DynamImageProcAutoBrightnessAndContrast"]=Module["asm"]["Na"]).apply(null,arguments)};var _DynamImageProcDrawQuadrangle=Module["_DynamImageProcDrawQuadrangle"]=function(){return(_DynamImageProcDrawQuadrangle=Module["_DynamImageProcDrawQuadrangle"]=Module["asm"]["Oa"]).apply(null,arguments)};var _DynamImageProcChangeBrightnessAndContrast=Module["_DynamImageProcChangeBrightnessAndContrast"]=function(){return(_DynamImageProcChangeBrightnessAndContrast=Module["_DynamImageProcChangeBrightnessAndContrast"]=Module["asm"]["Pa"]).apply(null,arguments)};var _DynamImageProcBackToOriginal=Module["_DynamImageProcBackToOriginal"]=function(){return(_DynamImageProcBackToOriginal=Module["_DynamImageProcBackToOriginal"]=Module["asm"]["Qa"]).apply(null,arguments)};var _DynamImageProcGetErrorString=Module["_DynamImageProcGetErrorString"]=function(){return(_DynamImageProcGetErrorString=Module["_DynamImageProcGetErrorString"]=Module["asm"]["Ra"]).apply(null,arguments)};var _malloc=Module["_malloc"]=function(){return(_malloc=Module["_malloc"]=Module["asm"]["Sa"]).apply(null,arguments)};var _free=Module["_free"]=function(){return(_free=Module["_free"]=Module["asm"]["Ta"]).apply(null,arguments)};var __Z15aes_gcm_decryptPciPi=Module["__Z15aes_gcm_decryptPciPi"]=function(){return(__Z15aes_gcm_decryptPciPi=Module["__Z15aes_gcm_decryptPciPi"]=Module["asm"]["Ua"]).apply(null,arguments)};var __Z15aes_gcm_encryptPKciPi=Module["__Z15aes_gcm_encryptPKciPi"]=function(){return(__Z15aes_gcm_encryptPKciPi=Module["__Z15aes_gcm_encryptPKciPi"]=Module["asm"]["Va"]).apply(null,arguments)};var ___errno_location=function(){return(___errno_location=Module["asm"]["Wa"]).apply(null,arguments)};var _memset=Module["_memset"]=function(){return(_memset=Module["_memset"]=Module["asm"]["Xa"]).apply(null,arguments)};var _ntohs=function(){return(_ntohs=Module["asm"]["Za"]).apply(null,arguments)};var _saveSetjmp=function(){return(_saveSetjmp=Module["asm"]["_a"]).apply(null,arguments)};var ___getTypeName=Module["___getTypeName"]=function(){return(___getTypeName=Module["___getTypeName"]=Module["asm"]["$a"]).apply(null,arguments)};var __embind_initialize_bindings=Module["__embind_initialize_bindings"]=function(){return(__embind_initialize_bindings=Module["__embind_initialize_bindings"]=Module["asm"]["ab"]).apply(null,arguments)};var ___dl_seterr=function(){return(___dl_seterr=Module["asm"]["bb"]).apply(null,arguments)};var _htonl=function(){return(_htonl=Module["asm"]["cb"]).apply(null,arguments)};var _htons=function(){return(_htons=Module["asm"]["db"]).apply(null,arguments)};var _setThrew=function(){return(_setThrew=Module["asm"]["eb"]).apply(null,arguments)};var stackSave=function(){return(stackSave=Module["asm"]["fb"]).apply(null,arguments)};var stackRestore=function(){return(stackRestore=Module["asm"]["gb"]).apply(null,arguments)};var stackAlloc=function(){return(stackAlloc=Module["asm"]["hb"]).apply(null,arguments)};var ___cxa_is_pointer_type=function(){return(___cxa_is_pointer_type=Module["asm"]["ib"]).apply(null,arguments)};var dynCall_iijj=Module["dynCall_iijj"]=function(){return(dynCall_iijj=Module["dynCall_iijj"]=Module["asm"]["jb"]).apply(null,arguments)};var dynCall_iiiij=Module["dynCall_iiiij"]=function(){return(dynCall_iiiij=Module["dynCall_iiiij"]=Module["asm"]["kb"]).apply(null,arguments)};var dynCall_iij=Module["dynCall_iij"]=function(){return(dynCall_iij=Module["dynCall_iij"]=Module["asm"]["lb"]).apply(null,arguments)};var dynCall_iijii=Module["dynCall_iijii"]=function(){return(dynCall_iijii=Module["dynCall_iijii"]=Module["asm"]["mb"]).apply(null,arguments)};var dynCall_iijjj=Module["dynCall_iijjj"]=function(){return(dynCall_iijjj=Module["dynCall_iijjj"]=Module["asm"]["nb"]).apply(null,arguments)};var dynCall_ji=Module["dynCall_ji"]=function(){return(dynCall_ji=Module["dynCall_ji"]=Module["asm"]["ob"]).apply(null,arguments)};var dynCall_jiji=Module["dynCall_jiji"]=function(){return(dynCall_jiji=Module["dynCall_jiji"]=Module["asm"]["pb"]).apply(null,arguments)};var dynCall_viijii=Module["dynCall_viijii"]=function(){return(dynCall_viijii=Module["dynCall_viijii"]=Module["asm"]["qb"]).apply(null,arguments)};var dynCall_iiiiij=Module["dynCall_iiiiij"]=function(){return(dynCall_iiiiij=Module["dynCall_iiiiij"]=Module["asm"]["rb"]).apply(null,arguments)};var dynCall_iiiiijj=Module["dynCall_iiiiijj"]=function(){return(dynCall_iiiiijj=Module["dynCall_iiiiijj"]=Module["asm"]["sb"]).apply(null,arguments)};var dynCall_iiiiiijj=Module["dynCall_iiiiiijj"]=function(){return(dynCall_iiiiiijj=Module["dynCall_iiiiiijj"]=Module["asm"]["tb"]).apply(null,arguments)};var ___start_em_js=Module["___start_em_js"]=471672;var ___stop_em_js=Module["___stop_em_js"]=472303;function invoke_viiii(index,a1,a2,a3,a4){var sp=stackSave();try{getWasmTableEntry(index)(a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}function invoke_iii(index,a1,a2){var sp=stackSave();try{return getWasmTableEntry(index)(a1,a2)}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}function invoke_vii(index,a1,a2){var sp=stackSave();try{getWasmTableEntry(index)(a1,a2)}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}function invoke_ii(index,a1){var sp=stackSave();try{return getWasmTableEntry(index)(a1)}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}function invoke_vi(index,a1){var sp=stackSave();try{getWasmTableEntry(index)(a1)}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}function invoke_viii(index,a1,a2,a3){var sp=stackSave();try{getWasmTableEntry(index)(a1,a2,a3)}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}function invoke_iiii(index,a1,a2,a3){var sp=stackSave();try{return getWasmTableEntry(index)(a1,a2,a3)}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}function invoke_viiiii(index,a1,a2,a3,a4,a5){var sp=stackSave();try{getWasmTableEntry(index)(a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}function invoke_iiiii(index,a1,a2,a3,a4){var sp=stackSave();try{return getWasmTableEntry(index)(a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{getWasmTableEntry(index)(a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}function invoke_viid(index,a1,a2,a3){var sp=stackSave();try{getWasmTableEntry(index)(a1,a2,a3)}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{getWasmTableEntry(index)(a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0)throw e;_setThrew(1,0)}}Module["UTF8ToString"]=UTF8ToString;Module["stringToUTF8"]=stringToUTF8;Module["lengthBytesUTF8"]=lengthBytesUTF8;Module["ccall"]=ccall;var calledRun;dependenciesFulfilled=function runCaller(){if(!calledRun)run();if(!calledRun)dependenciesFulfilled=runCaller};function run(){if(runDependencies>0){return}preRun();if(runDependencies>0){return}function doRun(){if(calledRun)return;calledRun=true;Module["calledRun"]=true;if(ABORT)return;initRuntime();readyPromiseResolve(Module);if(Module["onRuntimeInitialized"])Module["onRuntimeInitialized"]();postRun()}if(Module["setStatus"]){Module["setStatus"]("Running...");setTimeout(function(){setTimeout(function(){Module["setStatus"]("")},1);doRun()},1)}else{doRun()}}if(Module["preInit"]){if(typeof Module["preInit"]=="function")Module["preInit"]=[Module["preInit"]];while(Module["preInit"].length>0){Module["preInit"].pop()()}}run();


  return ImageProcModule.ready
}

);
})();
if (typeof exports === 'object' && typeof module === 'object')
  module.exports = ImageProcModule;
else if (typeof define === 'function' && define['amd'])
  define([], function() { return ImageProcModule; });
else if (typeof exports === 'object')
  exports["ImageProcModule"] = ImageProcModule;

!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):((e="undefined"!=typeof globalThis?globalThis:e||self).Dynamsoft=e.Dynamsoft||{},e.Dynamsoft.ImageIOWasm=t())}(this,(function(){"use strict";var e,t,a,s,r,n,i,o,l,c,u,m,p,f,d,h,g,y,b,w,v,I,S,k,A,T,M,E,B,R,_;function P(e,t,a,s){return new(a||(a=Promise))((function(r,n){function i(e){try{l(s.next(e))}catch(e){n(e)}}function o(e){try{l(s.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?r(e.value):(t=e.value,t instanceof a?t:new a((function(e){e(t)}))).then(i,o)}l((s=s.apply(e,t||[])).next())}))}function D(e,t,a,s){if("a"===a&&!s)throw new TypeError("Private accessor was defined without a getter");if("function"==typeof t?e!==t||!s:!t.has(e))throw new TypeError("Cannot read private member from an object whose class did not declare it");return"m"===a?s:"a"===a?s.call(e):s?s.value:t.get(e)}function j(e,t,a,s,r){if("m"===s)throw new TypeError("Private method is not writable");if("a"===s&&!r)throw new TypeError("Private accessor was defined without a setter");if("function"==typeof t?e!==t||!r:!t.has(e))throw new TypeError("Cannot write private member to an object whose class did not declare it");return"a"===s?r.call(e,a):r?r.value=a:t.set(e,a),a}!function(e){e.logInfo="logInfo",e.logDebug="logDebug",e.logAll="logAll",e.imgIO="imgIO",e.imgProc="imgProc",e.binaryBlobType="application/octet-stream",e.wasmExtension=".wasm"}(e||(e={})),function(e){e.imgCore="imgCore",e.imgProc="imgProc",e.pdfCore="pdfCore"}(t||(t={})),function(e){e.core="ddv-core",e.reader="ddv-reader",e.detector="ddv-detector",e.loader="ddv-loader",e.proc="ddv-proc"}(a||(a={})),function(e){e.pending="pending",e.ready="ready",e.failed="failed",e.destroyed="destroyed",e.init="init"}(s||(s={})),function(e){e.PARAMETER_TYPE_ERROR="Parameter Type not Supported = ",e.TIMEOUT="Timeout no Response = ",e.FILE_STREAM_ERROR="File Stream Error = ",e.WASM_EXCEPTION_ERROR="An WASM exception occurred."}(r||(r={})),function(e){e[e.LONG_KEY=0]="LONG_KEY",e[e.DLS_KEY=1]="DLS_KEY"}(n||(n={})),function(e){e[e.wasmSucceed=0]="wasmSucceed",e[e.wasmBase=-4e3]="wasmBase",e[e.wasmException=-4001]="wasmException",e[e.wasmNoModule=-4002]="wasmNoModule",e[e.wasmJsBase=-4100]="wasmJsBase",e[e.wasmJsObjectNotInit=-4101]="wasmJsObjectNotInit",e[e.wasmJsObjectTerminated=-4102]="wasmJsObjectTerminated",e[e.wasmJsObjectInitFailed=-4103]="wasmJsObjectInitFailed",e[e.wasmJsNotLoaded=-4104]="wasmJsNotLoaded",e[e.wasmJsInvalidJson=-4105]="wasmJsInvalidJson",e[e.wasmJsWorkerRunException=-4106]="wasmJsWorkerRunException",e[e.wasmJsWorkerRunFailed=-4107]="wasmJsWorkerRunFailed",e[e.wasmJsReadFileFailed=-4108]="wasmJsReadFileFailed",e[e.wasmJsCoreTaskException=-4109]="wasmJsCoreTaskException",e[e.wasmJsProcTaskException=-4110]="wasmJsProcTaskException",e[e.wasmJsSavePdfFailed=-4111]="wasmJsSavePdfFailed",e[e.wasmJsSaveTiffFailed=-4112]="wasmJsSaveTiffFailed"}(i||(i={})),function(e){e[e.IT_DIB=-1]="IT_DIB",e[e.IT_RGBA=-2]="IT_RGBA",e[e.IT_BGRA=-3]="IT_BGRA",e[e.IT_BMP=0]="IT_BMP",e[e.IT_JPG=1]="IT_JPG",e[e.IT_PNG=3]="IT_PNG",e[e.IT_ALL=5]="IT_ALL"}(o||(o={})),function(e){e[e.RT_AUTO=-1]="RT_AUTO",e[e.RT_BINARY=1]="RT_BINARY",e[e.RT_BASE64=2]="RT_BASE64"}(l||(l={})),function(e){e[e.SF_DEF=0]="SF_DEF",e[e.SF_ENABLE=1]="SF_ENABLE",e[e.SF_DISABLE=2]="SF_DISABLE"}(c||(c={})),"function"==typeof SuppressedError&&SuppressedError;class C{static register(e){D(this,u,"f",m).push(e)}static process(e){D(this,u,"f",m).forEach((t=>{e.data.params.moduleName!==t.Name||t.process(e)}))}}u=C,m={value:new Array};class O{constructor(e){this._instances=Object.create(null),p.set(this,""),j(this,p,e,"f"),C.register(this)}get Name(){return D(this,p,"f")}_destroy(e){let t=this._instances[e.data.params.insId];t&&(delete this._instances[e.data.params.insId],t.wasmObject.delete(),e.context.logDebug(e.data,"Delete Instance "+e.data.params.insId))}process(e){}}p=new WeakMap;class J extends O{constructor(){super(e.imgProc)}process(t){let a,s=t.data,r={errorCode:0,errorMessage:"Successful."},n=this._instances[s.params.insId],i=null==n?void 0:n.wasmObject,l=t.entryModule;switch(s.func){case"init":void 0===this._instances[s.params.insId]&&(this._instances[s.params.insId]={wasmObject:new l.ImageProc(s.params.key,s.params.licMode,s.params.uuid)},t.context.logDebug(s,"Create ImageProc Instance "+s.params.insId));break;case"destroy":this._destroy(t);break;case"terminate":return this._destroy(t),t.context.logDebug(s,"Terminate worker"),void self.close();case"InitImageObject":r=i.InitImageObject.apply(i,s.params.input),r=JSON.parse(r);break;case"RotateEx":r=i.RotateEx.apply(i,s.params.input);break;case"Flip":r=i.Flip();break;case"Mirror":r=i.Mirror();break;case"Erase":r=i.Erase.apply(i,s.params.input);break;case"ChangeImageSize":r=i.ChangeImageSize.apply(i,s.params.input);break;case"Crop":r=i.Crop.apply(i,s.params.input);break;case"GetSkewAngle":r=i.GetSkewAngle.apply(i,s.params.input);break;case"ConvertToGrayScale":r=i.ConvertToGrayScale(s.params.input);break;case"ConvertToBW":r=i.ConvertToBW(s.params.input);break;case"Invert":r=i.Invert();break;case"SetDPI":r=i.SetDPI.apply(i,s.params.input);break;case"SetImageWidth":r=i.SetImageWidth.apply(i,s.params.input);break;case"SetImageHeight":r=i.SetImageHeight.apply(i,s.params.input);break;case"GetImageSize":r=i.GetImageSize();break;case"GetCurrentImage":!function(){let t;r=i.Save.apply(i,s.params.input),a=JSON.parse(r),0!==a.errorCode&&"Successful."!==a.errorMessage||(t=i.GetCurrentImage(),a.imageType===o.IT_JPG?a.blobType="image/jpeg":a.imageType===o.IT_PNG?a.blobType="image/png":a.blobType=e.binaryBlobType,a.imageData=new Uint8ClampedArray(t)),r=a}();break;case"FreeReservedData":i.FreeReservedData();break;case"DocumentDetect":r=i.DocumentDetect.apply(i,s.params.input);break;case"Perspective":r=i.Perspective.apply(i,s.params.input);break;case"ChangeBrightness":r=i.ChangeBrightness.apply(i,s.params.input);break;case"ChangeContrast":r=i.ChangeContrast.apply(i,s.params.input);break;case"ShadowRemovel":r=i.ShadowRemovel.apply(i,s.params.input);break;case"EnhanceAndSharpen":r=i.EnhanceAndSharpen.apply(i,s.params.input);break;case"Brighten":r=i.Brighten.apply(i,s.params.input);break;case"GetBlurryScore":r=i.GetBlurScore.apply(i,s.params.input);break;case"DrawQuadrangle":r=i.DrawQuadrangle.apply(i,s.params.input);break;case"ChangeBrightnessAndContrast":r=i.ChangeBrightnessAndContrast.apply(i,s.params.input);break;case"GetImageInfo":r=i.GetImageInfo();break;case"BackToOriginal":r=i.BackToOriginal();break;case"Filter":!function(){let t;"toBW"===s.params.input[0]?i.ConvertToBW.apply(i,s.params.input.slice(1,-1)):"toGray"===s.params.input[0]?i.ConvertToGrayScale.apply(i,s.params.input.slice(1,-1)):"removeShadow"===s.params.input[0]?i.ShadowRemovel.apply(i,s.params.input.slice(1,-1)):"enhance"===s.params.input[0]?i.EnhanceAndSharpen.apply(i,s.params.input.slice(1,-1)):"invert"===s.params.input[0]?i.Invert():"brightnessAndContrast"===s.params.input[0]&&i.ChangeBrightnessAndContrast.apply(i,s.params.input.slice(1,-1)),r=i.Save.apply(i,s.params.input[s.params.input.length-1]),a=JSON.parse(r),0!==a.errorCode&&"Successful."!==a.errorMessage||(t=i.GetCurrentImage(),a.imageType===o.IT_JPG?a.blobType="image/jpeg":a.imageType===o.IT_PNG?a.blobType="image/png":a.blobType=e.binaryBlobType,a.imageData=new Uint8ClampedArray(t)),i.BackToOriginal(),i.FreeReservedData(),r=a}();break;case"UpdateLicense":i.UpdateLicense.apply(i,s.params.input)}t.context.logDebug(s,s.func+" end, send back begin");let c,u={id:s.id,func:s.func,result:r,memSize:l.HEAPU8.length};if(s.params.srcBuffer){"string"==typeof u.result&&(u.result=JSON.parse(u.result)),u.result.srcBuffer=s.params.srcBuffer;let e=Object.prototype.toString.call(u.result.srcBuffer);"[object ArrayBuffer]"!==e&&"[object Uint8ClampedArray]"!==e||(c=[null!=u.result.srcBuffer.buffer?u.result.srcBuffer.buffer:u.result.srcBuffer])}let m=Object.prototype.toString.call(r.imageData);"[object ArrayBuffer]"!==m&&"[object Uint8ClampedArray]"!==m&&"[object Uint8Array]"!=m||(c=[null!=u.result.imageData.buffer?u.result.imageData.buffer:u.result.imageData]),null!=c?t.context.sendResult(u,c):t.context.sendResult(u),r=null,t.context.logDebug(s,s.func+" end, send back end")}}new J;class W{static fetchRetry(e,t,a,s){let r=t.retries,n=t.retryDelay;return new Promise((function(i,o){const l=function(c){return fetch(e,t).then((function(e){i(e)})).catch((function(e){c<r?function(e,t,r){a&&a(t,s);setTimeout((function(){l(++e)}),n)}(c,e):o(e)}))};return l(0)}))}}class F{static buildWasmFileName(e,t,a,s,r){return e+(s?"-simd":"")+a+"?v="+t}static base64DecToArr(e,t){let a=e.replace(/[^A-Za-z0-9\+\/]/g,""),s=a.length,r=t?Math.ceil((3*s+1>>>2)/t)*t:3*s+1>>>2,n=new Uint8Array(r);for(let e,t,i=0,o=0,l=0;l<s;l++)if(t=3&l,i|=D(this,f,"m",d).call(this,a.charCodeAt(l))<<18-6*t,3===t||s-l==1){for(e=0;e<3&&o<r;e++,o++)n[o]=i>>>(16>>>e&24)&255;i=0}return n}static isWasmSupport(){try{if("object"==typeof WebAssembly&&"function"==typeof WebAssembly.instantiate){let e=new WebAssembly.Module(Uint8Array.of(0,97,115,109,1,0,0,0));if(e instanceof WebAssembly.Module)return new WebAssembly.Instance(e)instanceof WebAssembly.Instance}}catch(e){}return!1}static random(){return(Date.now()%10086).toString(36).slice(2)+Math.random().toString(36).slice(2)}static newBlobInChunks(e,t,a){var s;let r;const n=a||e.byteLength,i=8388608,o=[];for(let t=0;t<n;t+=i)o.push(new Blob([new Uint8Array(null!==(s=e.buffer)&&void 0!==s?s:e,t,Math.min(n-t,i))]));return r=null!=t?new Blob(o,{type:t}):new Blob(o),r}}f=F,d=function(e){return e>64&&e<91?e-65:e>96&&e<123?e-71:e>47&&e<58?e+4:43===e?62:47===e?63:0};class x{constructor(e,t){this.docId=e,this.length=0,this.data=new Uint8Array(null!=t?t:8192),this.position=0}seek(e){this.position=e}close(){if(this.data){const e=this.data.subarray(0,this.length);return this.data=new Uint8Array(1),e}return this.data=new Uint8Array(1),null}getPos(){return this.position}getTotalSize(){return this.length}read(e,t,a){const s=this.data.length;let r;r=a+this.position<s?a:s-this.position;const n=e.subarray(t,t+r),i=this.data.subarray(this.position,this.position+r);return n.set(i),this.position+=r,r}write(e,t,a){const s=this.position+a,r=this.data.length;if(s>this.data.length){const e=16777216<r?104857600<r?.2:.5:1,t=Math.max(r*(1+e),s),a=new Uint8Array(t);a.set(this.data.subarray(0,this.length),0),this.data=a}const n=e.subarray(t,t+a);return this.data.set(n,this.position),this.position+=a,this.position>this.length&&(this.length=this.position),a}}var N={};g=new WeakMap,y=new WeakMap,b=new WeakMap,w=new WeakMap,v=new WeakMap,I=new WeakMap,S=new WeakMap,k=new WeakMap,A=new WeakMap,h=new WeakSet,T=function(){j(this,g,null,"f")},M=function(e,t){D(this,I,"f").postMessage({id:e.id,func:"status",log:t}),e.params&&"function"==typeof e.params.callback&&e.params.callback(t)},E=function(e,t){D(this,I,"f").postMessage({id:e.id,func:"log",log:t}),e.params&&"function"==typeof e.params.callback&&e.params.callback(t)},B=function(e){let t={name:"",promise:void 0,resolve:void 0,reject:void 0,wasmResource:null};return t.name=e,t.promise=new Promise((function(e,a){t.resolve=e,t.reject=a})),t.wasmResource={},t},R=function(t,a){var s,r,n;let i=this,o=Date.now();j(this,w,F.buildWasmFileName(t.prefixName,t.ver,e.wasmExtension,null!==(s=t.useSimd)&&void 0!==s&&s,null!==(r=t.useBrotli)&&void 0!==r&&r),"f"),D(this,h,"m",M).call(this,a,"loading "+D(this,w,"f")+"...");let l=D(this,h,"m",B).call(this,t.name);l.wasmResource.wasmModule=t.wasmModule;let c={print:function(e){e+="",D(i,h,"m",E).call(i,a,e)},printErr:function(e){e+="",l.reject({name:l.name,error:e})},INITIAL_MEMORY:1024*(null!==(n=a.params.initMemory)&&void 0!==n?n:32)*1024,instantiateWasm:function(e,t){if(l.wasmResource.wasmModule)return WebAssembly.instantiate(l.wasmResource.wasmModule,e).then((function(e){D(i,h,"m",E).call(i,a,"instantiate with wasm module"),t(e,l.wasmResource.wasmModule)}),(function(e){e+="",D(i,h,"m",E).call(i,a,"wasm instantiate 2 failed: "+e),l.reject({name:l.name,error:e})})).catch((function(e){D(i,h,"m",E).call(i,a,JSON.stringify(e));let t=e.message+"";l.reject({name:l.name,error:t})}));{const s=D(i,b,"f").retries,r=D(i,b,"f").retryDelay;let n=function(r){return P(this,void 0,void 0,(function*(){try{const n=W.fetchRetry(D(i,y,"f")+D(i,w,"f"),D(i,b,"f"),(function(e,t){return D(i,h,"m",E).call(i,a,e),!0}),a),c=yield n;if(c.ok){let a=yield c.arrayBuffer();const s=yield WebAssembly.instantiate(a,e);return l.wasmResource.wasmModule=s.module,t(s.instance,s.module),s}if(r<s)o(r);else{let e="failed to load wasm binary file, please check.";l.reject({name:l.name,error:e})}}catch(e){if(D(i,h,"m",E).call(i,a,"wasm instantiate 1 failed: "),D(i,h,"m",E).call(i,a,JSON.stringify(e)),D(i,h,"m",E).call(i,a,"attempt "+r+", retries: "+s),r<s)o(r);else{let t=e.message+"";l.reject({name:l.name,error:t})}}}))};function o(e){setTimeout((function(){n(++e)}),r)}n(0)}return{}},onRuntimeInitialized:function(){return P(this,void 0,void 0,(function*(){D(i,h,"m",M).call(i,a,t.name+" wasm initialized, cost "+(Date.now()-o)+" ms"),l.resolve()}))},locateFile:function(e,t){if(e.startsWith(t))return e;if(-1!=e.indexOf("/")){return t+e.substring(e.lastIndexOf("/")+1)}return t+e},save_buf:{},customStream:{id:"",initSize:8192,open:function(e){e.provider=new x(e.path.slice(1),this.initSize)},close:function(e){D(i,g,"f").save_buf[e.path.slice(1)]=e.provider.close()},read:function(e,t,a,s,r){return e.provider.read(t,a,s)},write:function(e,t,a,s,r){return s>0?e.provider.write(t,a,s):0},llseek:function(e,t,a){let s=t;return 1===a?s=e.provider.getPos()+t:2===a&&(s=e.provider.getTotalSize()+t),0>s?-1:(e.provider.seek(s),s)}},fonts:[]};return D(this,v,"f").call(this,c).then((a=>{j(this,g,a,"f"),D(this,S,"f")[t.name]=!0,t.name!==e.imgProc&&(D(this,g,"f").FS.mkdir("/fonts"),D(this,g,"f").FS.mkdir("/loadpdf"),D(this,g,"f").FS.mkdir("/loadtiff"),D(this,g,"f").FS.mkdir("/mergepdf"))})),l},_=function(e){try{this.sendResult(e)}catch(t){for(const t of e.result.modules)t.wasmModule=null;this.sendResult(e)}};var U=new class{constructor(e){h.add(this),g.set(this,null),y.set(this,""),b.set(this,{mode:"cors",credentials:"same-origin"}),w.set(this,""),v.set(this,null),I.set(this,self),S.set(this,[]),k.set(this,void 0),A.set(this,void 0),D(this,h,"m",T).call(this),j(this,v,e,"f")}sendResult(e,t){"object"==typeof e&&D(this,A,"f")&&(e.time=Date.now(),e.cost=e.time-D(this,A,"f"),e.ctime=D(this,A,"f"),j(this,A,void 0,"f")),t?D(this,I,"f").postMessage(e,t):D(this,I,"f").postMessage(e)}logDebug(t,a){if(t&&t.params){let s="";t.params.logLevel===e.logDebug&&(s=`[${Date.now()}][wm][`+t.params.insId+"] "+a,D(this,h,"m",E).call(this,t,s))}}get Module(){return D(this,g,"f")}loadWasm(e){return P(this,void 0,void 0,(function*(){null!=e.params.resourceDir&&j(this,y,e.params.resourceDir,"f"),null!=e.params.fetchOptions&&j(this,b,e.params.fetchOptions,"f");let t=Object.create(null);t.promise=new Promise((function(e,a){t.resolve=e,t.reject=a}));try{let t={modules:[]};if(e.params.module){let a=e.params.module.modulesInfo;for(const s of a){if(D(this,S,"f")[s.name])continue;let a=D(this,h,"m",R).call(this,s,e);yield a.promise,t.modules.push({name:s.name,wasmResource:a.wasmResource})}D(this,h,"m",_).call(this,{id:e.id,func:e.func,result:t,memSize:D(this,g,"f").HEAPU8.length})}}catch(a){let s={errorCode:i.wasmException,errorMessage:JSON.stringify(a),stack:JSON.stringify(a.stack)};if("object"==typeof a&&e.params.module){let t=e.params.module.modulesInfo;s.modules=[],void 0!==a.error?s.errorMessage=a.error:s.errorMessage=void 0!==a.message?a.message:"unknown error",delete s.stack,s.modules.push({name:a.name,wasmModule:null});for(const e of t)s.modules.push({name:e.name,wasmModule:null})}this.sendResult({id:e.id,func:e.func,result:s}),t.reject(s)}return t.promise}))}handleMessage(e){if("string"==typeof e)return;if(null==e.func)return;let t=null;e.params&&(t=e.params.val,this.logDebug(e,"received "+e.func)),null!=t&&(N=t),j(this,k,N,"f");let a=e;if("object"==typeof a&&"object"==typeof a.result&&a.result.errorCode===i.wasmException)return;let s=this.Module,r=this,n={data:e,entryModule:s,context:this,wasmMemoryPtr:null};try{let t=null;if(j(this,A,Date.now(),"f"),"loadWasm"===e.func)return void this.loadWasm(e).catch((function(t){let a=(void 0!==t.message?t.message:"")+""+(void 0!==t.errorMessage?t.errorMessage:"");r.sendResult({id:e.id,func:e.func,result:{errorCode:i.wasmException,errorMessage:a,stack:t.stack}})}));if(e.func,s){this.logDebug(e,"try to init buffer start");let a=Object.prototype.toString.call(e.params.input);if("[object Array]"===Object.prototype.toString.call(e.params.input)){if(a=Object.prototype.toString.call(e.params.input[0]),"[object ArrayBuffer]"===a||"[object Uint8ClampedArray]"===a||"[object Uint8Array]"==a){let r=e.params.input[0].byteLength;t=s._malloc(r),"[object ArrayBuffer]"===a?s.HEAPU8.set(new Uint8Array(e.params.input[0]),t):s.HEAPU8.set(new Uint8Array(e.params.input[0].buffer),t),e.params.srcBuffer=e.params.input[0],e.params.input[0]=t,e.params.input.splice(1,0,r)}}else if("[object ArrayBuffer]"===a||"[object Uint8ClampedArray]"===a||"[object Uint8Array]"==a){let r=e.params.input.byteLength;t=s._malloc(r),"[object ArrayBuffer]"===a?s.HEAPU8.set(new Uint8Array(e.params.input),t):s.HEAPU8.set(new Uint8Array(e.params.input.buffer),t),e.params.srcBuffer=e.params.input,e.params.input=[t,r]}this.logDebug(e,"try to init buffer end")}this.logDebug(e,e.func+" start"),n.wasmMemoryPtr=t,C.process(n),n.wasmMemoryPtr&&s&&s._free(n.wasmMemoryPtr)}catch(t){n.wasmMemoryPtr&&s&&s._free(n.wasmMemoryPtr),"object"!=typeof t&&(t={message:t,stack:""}),r.sendResult({id:e.id,func:e.func,result:{errorCode:i.wasmException,errorMessage:t.message,stack:t.stack},memSize:s.HEAPU8.length})}}}(ImageProcModule);onmessage=function(e){U.handleMessage(e.data)},self.postMessage("ready");class G{}return G.ImageProcGlue=J,G}));
